<?php
/**
 * Mostra agenda de compromissos
 *
 * @author Gonalo Franco
 * @version $Id: cis_hist.php 825 2006-09-04 19:56:55Z suporte $
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_time.php");
require_once(NWX_BAS . DIRECTORY_SEPARATOR . "csa_util.php");

/**
 * Define o quadro para mostrar historicos e versoes
 */
class csa_agenda extends nwx_quadro {
  
  private $comps;
  
  /**
   * Construtor: ajusta o titulo e tipo
   */
  function __construct($id) {
      
    parent::__construct($id);
    $this->titulo = _("Agenda");
    $this->fixo = 0;
    $this->comps = array();
  
  }
  
  function monta() {

    $tab = $_SESSION[NWX_SIS . '_tab'];
    
    $index = NWX_IDX;

    if (isset($_GET['d'])) {
      $data = $_GET['d'];
      unset($_SESSION['nwx_etc']['aba']);
    } else if (isset($_SESSION['nwx_etc']['agn'])) {
      $data = $_SESSION['nwx_etc']['agn'];
    } else {
      $data = date(nwx_time::date_format());
    }
    if (!nwx_time::data_valida($data)) {
      $data = date(nwx_time::date_format());
    }
    $_SESSION['nwx_etc']['agn'] = $data;
    
    $this->comps = $this->_compromissos($data);
    
    echo "<form method=\"post\" name=\"csa_agenda\">\n";
    
    echo "<table width=\"100%\" class=\"layout\" cellspacing=\"0\">\n";
    echo "<tr><td class=\"rel-cabec\">";
    echo _("Agenda de compromissos");
    echo "</td><td width=\"20%\" style=\"text-align:right;\" class=\"rel-control\">";
    echo "<input type=\"hidden\" name=\"csa_opr\" value=\"\">";
    echo bt_comado(_("Novo"), "nw_tarefas", "d=$data", _("Criar novo compromisso"), 1, 10, 2, nwx_qico('csa_agenda'));
    echo "<a ".nwx_ttip(_('Fechar a tela'))."class=\"nav\" href=\"$index?blc=csa_agenda&x\">"._('Fechar')."</a>\n";
    echo "</td></tr>";
    echo "</table>";

    // Layout geral do quadro
    echo "<table width=\"100%\" class=\"layout\" cellspacing=\"0\">\n";
    echo "<tr>";
    
    // Coluna com abas
    echo "<td class=\"agenda1\">";
    
    // Abas
    $opr = array();
    $opr[] = _('Dia');
    $opr[] = _('Semana');
    $opr[] = _('Mes');
    
    if (isset($_SESSION['nwx_etc']['aba'])) {
      $_p = $_SESSION['nwx_etc']['aba'];
    } else {
      $_p = 1;
    } 
    
    $pg = 0;
    // Desenha as abas das paginas
    echo "<table width=\"100%\" class=\"vitrine\" cellspacing=\"0\">\n";
    echo "<tr><td class=\"form-cel-menu\">";
    echo "<ul class=\"mnulista\">";
    foreach ($opr as $a) {
      ++$pg;
      $k = "<a href=\"javascript:pag($pg);\">$a</a>";
      $j =  "onmouseover=\"nwliover(this);\" onmouseout=\"nwliout(this);\"";
      echo "<li id=\"t$pg\" class=\"mnu\" $j>$k</li>\n";
    }
    echo "</ul>";
    echo "</td></tr></table>\n";
   
    echo "</td>";
    
    // Coluna acima do mini calendario
    echo "<td class=\"agenda1\">&nbsp;</td>";
    echo "</tr>";
    echo "<tr>";
    
    // Coluna principal com visoes
    echo "<td class=\"agenda1\">"; // Coluna 1 da agenda
     
    // Agenda Diaria (Tab 1)
    echo "<div name=\"p1\" id=\"p1\" style=\"position:relative; left:0px; top:0px;margin:4px;\">\n";
    echo $this->_diario($data);    
    echo "</div>";
    
    // Agenda Semanal (Tab 2)
    echo "<div name=\"p2\" id=\"p2\" style=\"position:relative; left:0px; top:0px;margin:4px;\">\n";
    echo $this->_semanal($data);    
    echo "</div>";
    
    // Agenda Mensal (Tab 3)
    echo "<div name=\"p3\" id=\"p3\" style=\"position:relative; left:0px; top:0px;margin:4px;\">\n";
    echo $this->_mensal($data);    
    echo "</div>";
    
    echo "</td>";
    
    // Coluna com mini-calendario
    echo "<td class=\"agenda1\" style=\"width:210px;\">";
    
    echo $this->_minical($data);
    
    echo "</td>";
    
    echo "</tr>";
    
    echo "</table>";
    
    echo "</form>\n";
    
    // Javascript para controlar abas
    echo "<script language=\"JavaScript\">\n";
    echo "function pag(p)\n";
    echo "{\n";
    echo "  for(var i = 1; i <= $pg; i++) {\n";
    echo "    var divObj = document.getElementById('p' + i);\n";
    echo "    var t = document.getElementById('t' + i);\n";
    echo "    if (i == p) {\n";
    echo "      divObj.style.display = '';\n";
    echo "      t.className = 'mnusel';\n";
    echo "      nwx_store(i, 'aba');\n";
    echo "    } else {\n";
    echo "      divObj.style.display = 'none';\n";
    echo "      t.className = 'mnu';\n";
    echo "    }\n";
    echo "  }\n";
    echo "}\n";
    echo "pag($_p);\n";
    echo "</script>\n";
    
  }

  /**
   * Monta mini calendario
   */
  private function _minical($data = '') {

    if (!$data) $data = date(nwx_time::date_format());
    
    $st = nwx_qsta('csa_agenda');
    $ic = nwx_qico('csa_agenda');
    $hoje = date(nwx_time::date_format());
    
    $index = NWX_IDX;
    $home = NWX_IDX . "?blc=csa_agenda&d=$hoje&col=1&seq=10&sta=$st&ico=$ic";
    $iso = nwx_time::data_iso($data, false);
    $iso1 = substr($iso, 0, 8) . '01';    
    $dia = adodb_date2('d', $iso);
    $mes = adodb_date2('m', $iso);  
    $ano = adodb_date2('Y', $iso);  
    $w = adodb_date2('w', $iso1) - 1;
    if ($w < 0) $w = 6;  
    $my = "/$mes/$ano";

    if ($mes == '01') {
      $mes1 = '12';
      $ano1 = intval($ano) - 1;
      $d1 = date(nwx_time::date_format(), adodb_mktime(0,0,0,$mes1,1,$ano1));
    } else {
      $mes1 = intval($mes) - 1;
      $mes1 = substr('0'. $mes1, -2);
      $d1 = date(nwx_time::date_format(), adodb_mktime(0,0,0,$mes1,1,$ano));
    }
    if ($mes == '12') {
      $mes1 = '01';
      $ano1 = intval($ano) + 1;
      $d2 = date(nwx_time::date_format(), adodb_mktime(0,0,0,$mes1,1,$ano1));
    } else {
      $mes1 = intval($mes) + 1;
      $mes1 = substr('0'. $mes1, -2);
      $d2 = date(nwx_time::date_format(), adodb_mktime(0,0,0,$mes1,1,$ano));
    }
    $ma = "<a href=\"$index?d=$d1\"><img src=\"/nwx/img/prev.gif\" border=\"0\"></a>&nbsp;&nbsp;";
    $md = "&nbsp;&nbsp;<a href=\"$index?d=$d2\"><img src=\"/nwx/img/next.gif\" border=\"0\"></a>";
    $exten = nwx_time::mes_extenso($mes);
    $s = nwx_time::date_format('/');
    $di = nwx_time::date_format('d');
    $mi = nwx_time::date_format('m');
    $ai = nwx_time::date_format('a');
    $xi = array();
    $xi[$di] = $dia;
    $xi[$mi] = $exten;
    $xi[$ai] = $ano;
    $dataext = '';
    for ($i = 0; $i <= 2; ++$i) {
      $dataext .= $xi[$i];
      if ($i < 2) $dataext .= " $s ";       
    }
    $sem = array();
    $sm = array('&nbsp;','&nbsp;','&nbsp;','&nbsp;','&nbsp;','&nbsp;','&nbsp;');
    $sem[] = $sm;
    $sem[] = $sm;
    $sem[] = $sm;
    $sem[] = $sm;
    $sem[] = $sm;
    $sem[] = $sm;
        
    $df = '01';
    $s = 0;
    $d = 1;
    
    while (nwx_time::data_valida($df.$my, true)) {
      while (nwx_time::data_valida($df.$my, true) && $w < 7) {
        $sem[$s][$w] = $df;
        ++$w;
        ++$d;
        $df = substr('0'.$d, -2);
      }
      $w = 0;
      ++$s;
    }
    
    $cal = "<table width=\"100%\" class=\"minical\" cellspacing=\"1\">\n"
         . "<tr>"
         . "<td class=\"calmes\">$ma</td>"
         . "<td colspan=\"5\" class=\"calmes\">$dataext</td>"
         . "<td class=\"calmes\">$md</td>"
         . "</tr>"
         . "<tr>"
         . "<td class=\"calcab\">"._("Seg")."</td><td class=\"calcab\">"._("Ter")."</td><td class=\"calcab\">"._("Qua")."</td><td class=\"calcab\">"._("Qui")."</td>"
         . "<td class=\"calcab\">"._("Sex")."</td><td class=\"calcab\">"._("Sab")."</td><td class=\"calcab\">"._("Dom")."</td>"    
         . "</tr>";
    foreach ($sem as $sm) {
      foreach ($sm as $n => $d) {
        if ($d == $dia) {
          $c[$n] = 'a';
        } else {
          $c[$n] = '';
        }
        $_d = $d;
        $_m = substr($my,1,2);
        $_a = substr($my,4);
        $odia = date(nwx_time::date_format(), adodb_mktime(0,0,0,$_m,$_d,$_a));
        if ($d && $d != '&nbsp;') {
          $a[$n] = "<a href=\"$index?d=$odia\">";
          $e[$n] = "</a>";
        } else {
          $a[$n] = "";
          $e[$n] = "";
        }
      }
      
      $cal .= "<tr>"
            . "<td class=\"caldia$c[0]\">$a[0]$sm[0]$e[0]</td><td class=\"caldia$c[1]\">$a[1]$sm[1]$e[1]</td><td class=\"caldia$c[2]\">$a[2]$sm[2]$e[2]</td><td class=\"caldia$c[3]\">$a[3]$sm[3]$e[3]</td>"
            . "<td class=\"caldia$c[4]\">$a[4]$sm[4]$e[4]</td><td class=\"caldia$c[5]\">$a[5]$sm[5]$e[5]</td><td class=\"caldia$c[6]\">$a[6]$sm[6]$e[6]</td>"    
            . "</tr>";
    }
    $cal .= "<tr><td colspan=\"7\" class=\"calmes\"><a class=\"nav2\" href=\"$home\">&nbsp;"._("Hoje")."&nbsp;</a></td></tr>";
    $cal .= "</table>";

    return $cal;   
    
  }

  /**
   * Calendario do Dia
   */
  private function _compromissos($data) {
    
    $bsc = csa_param('BSC');
    
    $db = nwx_db::conexao();
    $comps = array();

    $data1 = nwx_time::data_iso(nwx_time::mes_inicio($data));
    $data2 = nwx_time::data_iso(nwx_time::mes_fim($data));
    
    // Conformidade
    $rs = $db->execute("select a.* from csa_cfmd_ocr a inner join csa_cfmd b on (a.id_cfm = b.id_cfm) where a.dt_lim between ? and ? and b.indicador is null", array($data1, $data2));
    while (!$rs->EOF) {
      // Se nao for do usuario corrente, pula
      $rs1 = $db->execute("select * from csa_cfmd_usr where id_cfm = ? and id_usr = ?", array($rs->fields['id_cfm'], $_SESSION['nwx_usr']));
      if ($rs1->EOF) {
        $rs->MoveNext();
        continue;
      }
      // Indicador de termino
      if ($rs->fields['dt_ocr']) 
        $ok = true;
      else
        $ok = false;  
      $rs2 = $db->execute("select * from csa_cfmd where id_cfm = ?", array($rs->fields['id_cfm']));
      $comps[] = array(1
                      ,nwx_time::date_db($rs->fields['dt_lim'])
                      ,$rs2->fields['hora'] ? $rs2->fields['hora'] : '99:99'
                      ,$rs2->fields['descricao']
                      ,array($rs->fields['id_cfm'], $rs->fields['id_ocr'])
                      ,$ok
                      );
      $rs->MoveNext();
    }
    // Indicadores BSC
    if ($bsc) {
      require_once(NWX_BAS . DIRECTORY_SEPARATOR . "bsc_util.php");
      $rs = $db->execute("select * from bsc_medida where dt_med between ? and ?", array($data1, $data2));
      while (!$rs->EOF) {
        // Se nao for do usuario corrente, pula
        if (!bsc_respon($rs->fields['id_ind'], $_SESSION['nwx_usr'])) {
          $rs->MoveNext();
          continue;
        }
        // Indicador de termino
        if ($rs->fields['vl_med']) 
          $ok = true;
        else
          $ok = false;  
        $rs2 = $db->execute("select * from bsc_indica where id_ind = ?", array($rs->fields['id_ind']));
        $comps[] = array(4
                        ,nwx_time::date_db($rs->fields['dt_med'])
                        ,'99:99'
                        ,$rs2->fields['nome']
                        ,array($rs->fields['id_ind'], substr($rs->fields['dt_med'],0,10))
                        ,$ok
                        );
        $rs->MoveNext();
      }
    }
    // Indicadores
    $rs = $db->execute("select a.* from csa_cfmd_ocr a inner join csa_cfmd b on (a.id_cfm = b.id_cfm) where a.dt_lim between ? and ? and b.indicador is not null", array($data1, $data2));
    while (!$rs->EOF) {
      // Se nao for do usuario corrente, pula
      $rs1 = $db->execute("select * from csa_cfmd_usr where id_cfm = ? and id_usr = ?", array($rs->fields['id_cfm'], $_SESSION['nwx_usr']));
      if ($rs1->EOF) {
        $rs->MoveNext();
        continue;
      }
      // Indicador de termino
      if ($rs->fields['dt_ocr']) 
        $ok = true;
      else
        $ok = false;  
      $rs2 = $db->execute("select * from csa_cfmd where id_cfm = ?", array($rs->fields['id_cfm']));
      $comps[] = array(3
                      ,nwx_time::date_db($rs->fields['dt_lim'])
                      ,$rs2->fields['hora'] ? $rs2->fields['hora'] : '99:99'
                      ,$rs2->fields['descricao']
                      ,array($rs->fields['id_cfm'], $rs->fields['id_ocr'])
                      ,$ok
                      );
      $rs->MoveNext();
    }
    // Se parametro nao mostra todo intervalo, apenas data de termino aparece
    $todos = csa_param('AGENDA_INT');
    if (!$todos) {
      // Planos de Ao
      $rs = $db->execute("select * from csa_plan_act where dt_fim_p between ? and ?", array($data1, $data2));
      while (!$rs->EOF) {
        // Apenas Planos ativos
        $rs1 = $db->execute("select id_sit from csa_plan where id_uni = ? and id_pla = ?", 
                            array($rs->fields['id_uni'], $rs->fields['id_pla']));
        if ($rs1->fields['id_sit'] != 3) {
          $rs->MoveNext();
          continue;
        }
        // Se nao for do usuario corrente, pula
        if ($rs->fields['usr_resp'] && ($rs->fields['usr_resp'] != $_SESSION['nwx_usr'])) {
          $rs1 = $db->execute("select * from nw_mbr where grupo = ? and usr = ?", array($rs->fields['usr_resp'], $_SESSION['nwx_usr']));
          if ($rs1->EOF) {
            $rs->MoveNext();
            continue;
          }
        }
        
        // Indicador de termino
        if ($rs->fields['dt_fim']) 
          $ok = true;
        else
          $ok = false;  
        $comps[] = array(2
                         ,nwx_time::date_db($rs->fields['dt_fim_p'])
                         ,'99:99'
                         ,$rs->fields['descricao']
                         ,array($rs->fields['id_uni'], $rs->fields['id_pla'], $rs->fields['id_act'])
                         ,$ok
                         );
        $rs->MoveNext();
      }
    // Mostra todo intervalo
    } else {
      $acts = array();
      $rs = $db->execute("select a.id_uni, a.id_pla, a.id_act, a.descricao, a.usr_resp, a.dt_fim, a.dt_ini_p, a.dt_fim_p 
                            from csa_plan_act a
                           inner join csa_plan p on (a.id_uni = p.id_uni and a.id_pla = p.id_pla)
                           where a.dt_ini_p <= ? and a.dt_fim_p >= ? and p.id_sit = 3", array($data2, $data1));
      while (!$rs->EOF) {
        // Se nao for do usuario corrente, pula
        if ($rs->fields['usr_resp'] && ($rs->fields['usr_resp'] != $_SESSION['nwx_usr'])) {
          $rs1 = $db->execute("select * from nw_mbr where grupo = ? and usr = ?", array($rs->fields['usr_resp'], $_SESSION['nwx_usr']));
          if ($rs1->EOF) {
            $rs->MoveNext();
            continue;
          }
        }
        $acts[] = array($rs->fields['id_uni'], $rs->fields['id_pla'], $rs->fields['id_act'], 
                        $rs->fields['dt_ini_p'], $rs->fields['dt_fim_p'], $rs->fields['dt_fim'],
                        $rs->fields['descricao']);
        $rs->MoveNext();
      }
      $dm = substr($data1, 0, 8);
      $d1 = intval(substr($data1, 8));
      $d2 = intval(substr($data2, 8));
      for ($d = $d1; $d <= $d2; $d++) {
        $dta1 = $dm . substr('0'.$d,-2);
        $w = adodb_date2('w', $dta1);
        if ($w == '0' || $w == '6') continue;
        foreach($acts as $act) {
          if ($act[3] <= $dta1 && $act[4] >= $dta1) {
            // Indicador de termino
            if ($act[5]) 
              $ok = true;
            else
              $ok = false;  
            if (!$ok || $act[5] >= $dta1) { 
              $comps[] = array(2
                              ,nwx_time::date_db($dta1)
                              ,'99:99'
                              ,$act[6]
                              ,array($act[0], $act[1], $act[2])
                              ,$ok
                              );
            }
          }
        }
      }
    }
    // Tarefas avulsas
    $rs = $db->execute("select * from nw_tarefas where id_usr = ? and dt_tar between ? and ? and id_sit in (0,1)", array($_SESSION['nwx_usr'], $data1, $data2));
    while (!$rs->EOF) {
      // Indicador de termino
      if ($rs->fields['id_sit'] == 1) 
        $ok = true;
      else
        $ok = false;  
      $comps[] = array(0
                      ,nwx_time::date_db($rs->fields['dt_tar'])
                      ,$rs->fields['hora'] ? $rs->fields['hora'] : '99:99'
                      ,$rs->fields['descricao']
                      ,array($rs->fields['id_usr'], $rs->fields['id_tar'])
                      ,$ok
                      );
      $rs->MoveNext();
    }
    
    // Ordena array de compromissos por hora
    usort($comps, array('csa_agenda','_sort'));    
    return $comps;
    
  }
  
  /**
   * Ordenar array de compromissos diarios
   */
  private function _sort($lin1, $lin2) {
    if ($lin1[2] < $lin2[2]) return -1;
    if ($lin1[2] > $lin2[2]) return 1;
    if ($lin1[3] < $lin2[3]) return -1;
    if ($lin1[3] > $lin2[3]) return 1;
    return 0;
  }
  
  /**
   * Calendario do Dia
   */
  private function _diario($data = '') {
    
    if (!$data) $data = date(nwx_time::date_format());

    $oris = array(_('Tarefa'), _('Conf.'), _('Plano'), _('Conf.'), _('Indic.'));
         
    $index = NWX_IDX;
    $iso = nwx_time::data_iso($data, false);
    $dia = adodb_date2('d', $iso);
    $mes = adodb_date2('m', $iso);  
    $ano = adodb_date2('Y', $iso);  
    //$dataext = $dia . ' de ' . nwx_time::mes_extenso($mes) . ' de '. $ano;
    $exten = nwx_time::mes_extenso($mes);
    $s = nwx_time::date_format('/');
    $di = nwx_time::date_format('d');
    $mi = nwx_time::date_format('m');
    $ai = nwx_time::date_format('a');
    $xi = array();
    $xi[$di] = $dia;
    $xi[$mi] = $exten;
    $xi[$ai] = $ano;
    $dataext = '';
    for ($i = 0; $i <= 2; ++$i) {
      $dataext .= $xi[$i];
      if ($i < 2) $dataext .= " $s ";       
    }
    
    $ret = "<div style=\"background-color:#ccf;padding:2px 2px 2px 0px;\">";
    $ret .= "<table width=\"100%\" class=\"layout\" cellspacing=\"1\">\n";
    $ret .= "<tr><td colspan=\"3\" class=\"calmes\">$dataext</td></tr>"
          . "<tr>"
          . "<td class=\"calcab\" width=\"40px;\">"._("Hora")."</td>
             <td class=\"calcab\" width=\"20px;\"><img src=\"/nwx/img/tchk.png\"></td>
             <td class=\"calcab\">Tarefas/Atividades</td>
             </tr>";
    
    $nc = 0;
    $sis = NWX_SIS;
    foreach ($this->comps as $cpm) { 
      if ($cpm[1] == $data) {
        $hr = $cpm[2] == '99:99' ? '&nbsp;' : $cpm[2];
        $ori = $oris[$cpm[0]];
        ++$nc;
        if ($cpm[0] == 1) {
          $q = $cpm[4][0];
          $r = $cpm[4][1];
          $a = "<a href=\"" . NWX_IDX . "?blc=csa_cfmm_ocr&p=$q&r=$r&col=1&seq=10&sta=2&ico=check.gif\">";
          if ($cpm[5]) {
            $sta = '<img src="/nwx/img/ok.gif">';
            $sty = 'style="background-color:#ddd;"';
          } else {
            $sta = '<img src="/nwx/img/nok.gif">';
            $sty = '';
          }
        } else if ($cpm[0] == 2) {
          $u = $cpm[4][0];
          $q = $cpm[4][1];
          $r = $cpm[4][2];
          $a = "<a href=\"" . NWX_IDX . "?blc={$sis}_plan_act&p=$u.$q&r=$r&col=1&seq=10&sta=2&ico=check.gif\">";
          if ($cpm[5]) {
            $sta = '<img src="/nwx/img/ok.gif">';
            $sty = 'style="background-color:#ddd;"';
          } else {
            $sta = '<img src="/nwx/img/nok.gif">';
            $sty = '';
          }
        } else if ($cpm[0] == 0) {
          $r = $cpm[4][1];
          $a = "<a href=\"" . NWX_IDX . "?blc=nw_tarefas&p=$r&col=1&seq=10&sta=2&ico=check.gif\">";
          if ($cpm[5]) {
            $sta = '<img src="/nwx/img/ok.gif">';
            $sty = 'style="background-color:#ddd;"';
          } else {
            $sta = '<img src="/nwx/img/nok.gif">';
            $sty = '';
          }
        } else if ($cpm[0] == 3) {
          $q = $cpm[4][0];
          $r = $cpm[4][1];
          $a = "<a href=\"" . NWX_IDX . "?blc=csa_cfmm_val&p=$q&r=$r&col=1&seq=10&sta=2&ico=check.gif\">";
          if ($cpm[5]) {
            $sta = '<img src="/nwx/img/ok.gif">';
            $sty = 'style="background-color:#ddd;"';
          } else {
            $sta = '<img src="/nwx/img/nok.gif">';
            $sty = '';
          }
        } else if ($cpm[0] == 4) {
          $q = $cpm[4][0];
          $r = $cpm[4][1];
          $a = "<a href=\"" . NWX_IDX . "?blc=bsc_medida&p=$q&r=$r&col=1&seq=10&sta=2&ico=check.gif\">";
          if ($cpm[5]) {
            $sta = '<img src="/nwx/img/ok.gif">';
            $sty = 'style="background-color:#ddd;"';
          } else {
            $sta = '<img src="/nwx/img/nok.gif">';
            $sty = '';
          }
        }        
        $ret .= "<tr> 
                 <td class=\"calhora1\" width=\"40px;\">$hr</td>
                 <td class=\"calhora1\" style=\"text-align:center;\">$sta</td>
                 <td class=\"calhora2\" $sty>${a}$cpm[3]</a></td>
                 </tr>";
      }
    } 
    if (!$nc) {
      $ret .= "<tr>
               <td class=\"calhora1\">&nbsp;</td><td class=\"calhora1\">&nbsp;</td>
               <td class=\"calhora2\">"._("Nenhum registro")."</td>
               </tr>";
    }
    
    $ret .= "</table></div>";
    
    return $ret;
    
  }

  /**
   * Calendario da semana
   */
  private function _semanal($data = '') {
    
    if (!$data) $data = date(nwx_time::date_format());
    
    $sis = NWX_SIS;
    $oris = array(_('Compromisso'), _('Conformidade'), _('Plano'), _('Conformidade'), _('Indicador'));
         
    $data1 = nwx_time::semana_inicio($data);
    $data2 = nwx_time::semana_fim($data);
    $dt1 = nwx_time::data_iso($data1,false);
    $dt2 = nwx_time::data_iso($data2,false);
    
    $index = NWX_IDX;
    $dias = array();
    $lnk = array();
    $dias[] = $data1;
    $lnk[] = "<a href=\"$index?d=$data1\" style=\"color:#fff;\">";
    for ($n = 1; $n <= 6; ++$n) {
      $d = nwx_time::soma_dias($data1, $n);
      $dias[] = $d;
      $lnk[] = "<a href=\"$index?d=$d\" style=\"color:#fff;\">";
    }
    $iso = nwx_time::data_iso($data1, false);
    $dia1 = adodb_date2('d', $iso);
    $m1 = adodb_date2('m', $iso);
    $iso = nwx_time::data_iso($data2, false);
    $dia2 = adodb_date2('d', $iso);
    $m2 = adodb_date2('m', $iso);

    $s = nwx_time::date_format('/');
    $di = nwx_time::date_format('d');
    $mi = nwx_time::date_format('m');

    if ($di < $mi) {
      $dataext = "$dia1 $s " . nwx_time::mes_extenso($m1) . " - $dia2 $s " . nwx_time::mes_extenso($m2);
    } else {
      $dataext = nwx_time::mes_extenso($m1) . " $s $dia1 - " . nwx_time::mes_extenso($m2) . " $s $dia2";
    }
    
    //$dataext = _("Semana") . " $dia1 - $dia2 / " . nwx_time::mes_extenso($m1);
    //$dataext = "$dia1 - $dia2 / " . nwx_time::mes_extenso($m1);
    
    $ret = "<div style=\"background-color:#ccf;padding:2px 2px 2px 0px;\">";
    $ret .= "<table width=\"100%\" class=\"layout\" cellspacing=\"1\">\n";
    $ret .= "<tr><td colspan=\"8\" class=\"calmes\">$dataext</td></tr>"
          . "<tr>"
          . "<td class=\"calcab\" width=\"40px;\">"._("Hora")."</td>
             <td class=\"calcab\">$lnk[0]"._("Segunda")."</a><br>$dias[0]</td>
             <td class=\"calcab\">$lnk[1]"._("Tera")."</a><br>$dias[1]</td>
             <td class=\"calcab\">$lnk[2]"._("Quarta")."</a><br>$dias[2]</td>
             <td class=\"calcab\">$lnk[3]"._("Quinta")."</a><br>$dias[3]</td>
             <td class=\"calcab\">$lnk[4]"._("Sexta")."</a><br>$dias[4]</td>
             <td class=\"calcab\">$lnk[5]"._("Sbado")."</a><br>$dias[5]</td>
             <td class=\"calcab\">$lnk[6]"._("Domingo")."</a><br>$dias[6]</td>
             </tr>";
    
    $linhas = array();
    foreach ($this->comps as $cpm) { 
      $dt = nwx_time::data_iso($cpm[1],false);
      if ($dt >= $dt1 && $dt <= $dt2) {
        $hr = $cpm[2] == '99:99' ? '&nbsp;' : $cpm[2];
        $linhas[$hr] = array('','','','','','','');
      }
    }
    
    $nc = 0;
    foreach ($this->comps as $cpm) { 
      $dt = nwx_time::data_iso($cpm[1],false);
      if ($dt >= $dt1 && $dt <= $dt2) {
        $hr = $cpm[2] == '99:99' ? '&nbsp;' : $cpm[2];
        $ori = $oris[$cpm[0]];
        ++$nc;
        if ($cpm[0] == 1) {
          $q = $cpm[4][0];
          $r = $cpm[4][1];
          $rf = "";
          $a = "<a " . nwx_hctl(_('Descrio'), $cpm[3]) . " href=\"" . NWX_IDX . "?blc=csa_cfmm_ocr&p=$q&r=$r&col=1&seq=10&sta=2&ico=check.gif\">";
          if ($cpm[5]) {
            $sta = '<img src="/nwx/img/ok.gif">';
          } else {
            $sta = '<img src="/nwx/img/nok.gif">';
          }
        } else if ($cpm[0] == 2) {
          $u = $cpm[4][0];
          $q = $cpm[4][1];
          $r = $cpm[4][2];
          $rf = " $q.$r";
          $a = "<a " . nwx_hctl(_('Descrio'), $cpm[3]) . " href=\"" . NWX_IDX . "?blc={$sis}_plan_act&p=$u.$q&r=$r&col=1&seq=10&sta=2&ico=check.gif\">";
          if ($cpm[5]) {
            $sta = '<img src="/nwx/img/ok.gif">';
          } else {
            $sta = '<img src="/nwx/img/nok.gif">';
          }
        } else if ($cpm[0] == 0) {
          $r = $cpm[4][1];
          $rf = "";
          $a = "<a ".nwx_hctl(_('Descrio'), $cpm[3])." href=\"" . NWX_IDX . "?blc=nw_tarefas&p=$r&col=1&seq=10&sta=2&ico=check.gif\">";
          if ($cpm[5]) {
            $sta = '<img src="/nwx/img/ok.gif">';
          } else {
            $sta = '<img src="/nwx/img/nok.gif">';
          }
        } else if ($cpm[0] == 3) {
          $q = $cpm[4][0];
          $r = $cpm[4][1];
          $rf = "";
          $a = "<a " . nwx_hctl(_('Descrio'), $cpm[3]) . " href=\"" . NWX_IDX . "?blc=csa_cfmm_val&p=$q&r=$r&col=1&seq=10&sta=2&ico=check.gif\">";
          if ($cpm[5]) {
            $sta = '<img src="/nwx/img/ok.gif">';
          } else {
            $sta = '<img src="/nwx/img/nok.gif">';
          }
        } else if ($cpm[0] == 4) {
          $q = $cpm[4][0];
          $r = $cpm[4][1];
          $rf = "";
          $a = "<a " . nwx_hctl(_('Descrio'), $cpm[3]) . " href=\"" . NWX_IDX . "?blc=bsc_medida&p=$q&r=$r&col=1&seq=10&sta=2&ico=check.gif\">";
          if ($cpm[5]) {
            $sta = '<img src="/nwx/img/ok.gif">';
          } else {
            $sta = '<img src="/nwx/img/nok.gif">';
          }
        }        
        $i = array_search($cpm[1],$dias);
        $br = ($linhas[$hr][$i] == '') ? '' : '<br>';
        $linhas[$hr][$i] .= $br . $sta . $a . $ori . $rf. '</a>';  
      }
    } 
    
    foreach ($linhas as $h => $lin) {
      $it = array();
      foreach ($lin as $ln) {
        if ($ln == '') {
          $it[] = '&nbsp;';
        } else {
          $it[] = $ln;
        }
      }
      $ret .= "<tr> 
               <td class=\"calhora1\" width=\"40px;\">$h</td>
               <td class=\"caldia1\">$it[0]</a></td>
               <td class=\"caldia1\">$it[1]</a></td>
               <td class=\"caldia1\">$it[2]</a></td>
               <td class=\"caldia1\">$it[3]</a></td>
               <td class=\"caldia1\">$it[4]</a></td>
               <td class=\"caldia1\">$it[5]</a></td>
               <td class=\"caldia1\">$it[6]</a></td>
               </tr>";
    }
    
    if (!$nc) {
      $ret .= "<tr>
               <td class=\"calhora1\">&nbsp;</td>
               <td colspan=\"7\" class=\"calhora2\">"._("Nenhum registro")."</td>
               </tr>";
    }
    
    $ret .= "</table></div>";
    
    return $ret;

  }
  
  /**
   * Calendario do mes
   */
  private function _mensal($data = '') {
    
    if (!$data) $data = date('d/m/Y');
    
    $sis = NWX_SIS;
    $oris = array(_('Compromisso'), _('Conformidade'), _('Plano'), _('Conformidade'), _('Indicador'));
    $index = NWX_IDX;
         
    $iso = nwx_time::data_iso($data, false);
    $mes = adodb_date2('m', $iso);  
    $ano = adodb_date2('Y', $iso);  
    $dataext = nwx_time::mes_extenso($mes) . ' '. $ano;

    $iso = nwx_time::data_iso($data, false);
    $iso1 = substr($iso, 0, 8) . '01';    
    $dia = adodb_date2('d', $iso);
    $mes = adodb_date2('m', $iso);  
    $ano = adodb_date2('Y', $iso);  
    $w = adodb_date2('w', $iso1) - 1;
    if ($w < 0) $w = 6;  
    $my = "/$mes/$ano";

    if ($mes == '01') {
      $mes1 = '12';
      $ano1 = intval($ano) - 1;
    } else {
      $mes1 = intval($mes) - 1;
      $mes1 = substr('0'. $mes1, -2);
    }
    if ($mes == '12') {
      $mes1 = '01';
      $ano1 = intval($ano) + 1;
    } else {
      $mes1 = intval($mes) + 1;
      $mes1 = substr('0'. $mes1, -2);
    }
    
    $sem = array();
    $sm = array('&nbsp;','&nbsp;','&nbsp;','&nbsp;','&nbsp;','&nbsp;','&nbsp;');
    $sem[] = $sm;
    $sem[] = $sm;
    $sem[] = $sm;
    $sem[] = $sm;
    $sem[] = $sm;
    $sem[] = $sm;
        
    $df = '01';
    $s = 0;
    $d = 1;
    
    while (nwx_time::data_valida($df.$my, true)) {
      while (nwx_time::data_valida($df.$my, true) && $w < 7) {
        $_m = substr($my,1,2);
        $_a = substr($my,4);
        $odia = date(nwx_time::date_format(), adodb_mktime(0,0,0,$_m,$df,$_a));
        $sem[$s][$w] = "<div class=\"caldia\"><a href=\"$index?d=$odia\">$df</a></div>";
        $ni = 0;
        foreach ($this->comps as $cpm) { 
          $_m = substr($my,1,2);
          $_a = substr($my,4);
          $odia = date(nwx_time::date_format(), adodb_mktime(0,0,0,$_m,$df,$_a));
          if ($cpm[1] == $odia) {
            $hr = $cpm[2] == '99:99' ? '&nbsp;' : $cpm[2];
            $ori = $oris[$cpm[0]];
            if ($cpm[0] == 1) {
              $q = $cpm[4][0];
              $r = $cpm[4][1];
              $rf = "";
              $a = "<a " . nwx_hctl(_('Descrio'), $cpm[3]) . " href=\"" . NWX_IDX . "?blc=csa_cfmm_ocr&p=$q&r=$r&col=1&seq=10&sta=2&ico=check.gif\">";
              if ($cpm[5]) {
                $sta = '<img src="/nwx/img/ok.gif">';
              } else {
                $sta = '<img src="/nwx/img/nok.gif">';
              }
            } else if ($cpm[0] == 2) {
              $u = $cpm[4][0];
              $q = $cpm[4][1];
              $r = $cpm[4][2];
              $rf = " $q.$r";
              $a = "<a " . nwx_hctl(_('Descrio'), $cpm[3]) . " href=\"" . NWX_IDX . "?blc={$sis}_plan_act&p=$u.$q&r=$r&col=1&seq=10&sta=2&ico=check.gif\">";
              if ($cpm[5]) {
                $sta = '<img src="/nwx/img/ok.gif">';
              } else {
                $sta = '<img src="/nwx/img/nok.gif">';
              }
            } else if ($cpm[0] == 0) {
              $r = $cpm[4][1];
              $rf = "";
              $a = "<a ".nwx_hctl(_('Descrio'), $cpm[3])." href=\"" . NWX_IDX . "?blc=nw_tarefas&p=$r&col=1&seq=10&sta=2&ico=check.gif\">";
              if ($cpm[5]) {
                $sta = '<img src="/nwx/img/ok.gif">';
              } else {
                $sta = '<img src="/nwx/img/nok.gif">';
              }
            } else if ($cpm[0] == 3) {
              $q = $cpm[4][0];
              $r = $cpm[4][1];
              $rf = "";
              $a = "<a " . nwx_hctl(_('Descrio'), $cpm[3]) . " href=\"" . NWX_IDX . "?blc=csa_cfmm_val&p=$q&r=$r&col=1&seq=10&sta=2&ico=check.gif\">";
              if ($cpm[5]) {
                $sta = '<img src="/nwx/img/ok.gif">';
              } else {
                $sta = '<img src="/nwx/img/nok.gif">';
              }
            } else if ($cpm[0] == 4) {
              $q = $cpm[4][0];
              $r = $cpm[4][1];
              $rf = "";
              $a = "<a " . nwx_hctl(_('Descrio'), $cpm[3]) . " href=\"" . NWX_IDX . "?blc=bsc_medida&p=$q&r=$r&col=1&seq=10&sta=2&ico=check.gif\">";
              if ($cpm[5]) {
                $sta = '<img src="/nwx/img/ok.gif">';
              } else {
                $sta = '<img src="/nwx/img/nok.gif">';
              }
            }        
            $sem[$s][$w] .= $sta . $a . $ori . $rf. '</a><br>';
            ++$ni;
          } 
        }
        if ($ni == 0) {
          $sem[$s][$w] .= '<br>';
        }
        ++$w;
        ++$d;
        $df = substr('0'.$d, -2);
      }
      $w = 0;
      ++$s;
    }
    
    $ret = "<div style=\"background-color:#ccf;padding:2px 2px 2px 0px;\">";
    $ret .= "<table width=\"100%\" class=\"layout\" cellspacing=\"1\">\n";
    $ret .= "<tr><td colspan=\"7\" class=\"calmes\">$dataext</td></tr>"
          . "<tr>"
          . "<td width=\"16%\" class=\"calcab\">"._("Segunda")."</td>
             <td width=\"16%\" class=\"calcab\">"._("Tera")."</td>
             <td width=\"16%\" class=\"calcab\">"._("Quarta")."</td>
             <td width=\"16%\" class=\"calcab\">"._("Quinta")."</td>
             <td width=\"16%\" class=\"calcab\">"._("Sexta")."</td>
             <td width=\"10%\" class=\"calcab\">"._("Sbado")."</td>
             <td width=\"10%\" class=\"calcab\">"._("Domingo")."</td>
             </tr>";

    foreach ($sem as $sm) {
      $ret .= "<tr>
               <td class=\"caldia1\">$sm[0]</td>
               <td class=\"caldia1\">$sm[1]</td>
               <td class=\"caldia1\">$sm[2]</td>
               <td class=\"caldia1\">$sm[3]</td>
               <td class=\"caldia1\">$sm[4]</td>
               <td class=\"caldia1\">$sm[5]</td>
               <td class=\"caldia1\">$sm[6]</td>    
               </tr>";
    }

    $ret .= "</table></div>";
    
    return $ret;
    
  }
  
  
}
// vim:et:sw=2:ts=2:nowrap:
