<?php
/**
 * Alteracao de parametros do sistema
 *
 * @author Gonalo Franco
 * @version $Id$
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_form.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");
require_once("File/Archive.php");

/**
 * Define formulario para alteracao do perfil
 *
 */
class nw_apl_form extends nwx_form {

	function carrega() {
		if ($this->oper == 'INS')
			return null;
		$arquivo = file(NWX_BAS . DIRECTORY_SEPARATOR . NWX_APL . ".php");
		foreach ($arquivo as $lin) {
			$linha = trim($lin);
			if (substr($linha, 0, 8) == "define('") {
				$a = "'";
				$ok = true;
			} else if (substr($linha, 0, 8) == 'define("') {
				$a = '"';
				$ok = true;
			} else {
				$ok = false;
			}
			if ($ok) {
				$pars = explode($a, $linha);
				$param = $pars[1];
				$n = strpos($linha, ',');
				$val1 = substr($linha, $n + 1);
				$vals = explode(")", $val1);
				$valor = str_replace('"','',$vals[0]);
				$valor = trim(str_replace("'",'',$valor));
				if ($valor == 'true')
					$valor = 1;
				else if ($valor == 'false')
					$valor = 0;
				//$this->valor($param, $valor);
				if ($param != 'NWX_DSN') {
					$this->valor($param, $valor);
				} else {
					if (substr($valor,0,1) != '0') {
						$this->valor($param, nwx_crypt($valor));
					} else {
						$this->valor($param, $valor);
					}
				}
			}
		}
	}

	/**
	 * Verifica se entradas corretas
	 */
	function verifica() {

		if ($this->oper == 'Atualizar') {
			// Dados para importacao da planilha
			if (isset($_FILES['arquivo'])) {
				$arq = $_FILES['arquivo']['name'];
				$tmp = $_FILES['arquivo']['tmp_name'];
			} else {
				$this->erro(_('Nenhum arquivo foi informado'));
				return;
			}
			// Upload da planilha para o servidor no diretorio import
			if (!move_uploaded_file($tmp, NWX_RAIZ . "/nwx/upload/$arq")) {
				$this->erro(_('Erro na copia do arquivo para o servidor'));
			}
			return;
		}
		
		if ($this->post('NWX_SESSIONS_DB') && $this->post('NWX_SESSIONS_MC')) {
			$this->erro(_('Sesses em cache e DB ao mesmo tempo'));
		}
		if ($this->post('NWX_SESSIONS_DB') && $this->post('NWX_SESSIONS_EA')) {
			$this->erro(_('Sesses em eaccelerator e DB ao mesmo tempo'));
		}
		if ($this->post('NWX_SESSIONS_MC') && $this->post('NWX_SESSIONS_EA')) {
			$this->erro(_('Sesses em eaccelerator e memcache ao mesmo tempo'));
		}
		if ($this->post('NWX_SESSIONS_MC') && (!$this->post('NWX_SESSIONS_HOST') || !$this->post('NWX_SESSIONS_PORT'))) {
			$this->erro(_('Faltam informaes sobre o servidor de sesses (memcached)'));
		}
		
	}
	
	function processa($_sair) {

		// Opcao de atualizar sistema
		if ($this->oper == 'Atualizar') {
			// Arquivo zip enviado
			$arquivo = $_FILES['arquivo']['name'];
			$origem = NWX_RAIZ . "/nwx/upload/$arquivo";
			$pi = pathinfo($origem);
			if (strtolower($pi['extension']) == 'sql') {
        $orisql = NWX_RAIZ . "/nwx/upload/$arquivo";
				$db = nwx_db::conexao();
				nwx_db::begin_trans();
				$erros = script_sql($db, $orisql);
				if ($erros == -1) {
					nwx_alerta(_("Permisso insuficiente para script $arquivo")); 
				} else if ($erros == -2) {
					nwx_alerta(_("Assinatura invlida para script $arquivo")); 
				} else if (!$erros) {
					nwx_alerta(_("Sistema foi atualizado com script $arquivo")); 
					nwx_db::audita("Atualizar DB ($arquivo)", 'nw_apl');
				} else {
					nwx_alerta(_("Erros ao rodar o script $arquivo: $erros")); 
					nwx_db::fail_trans();
				}
				nwx_db::end_trans();
				$this->sair = true;
				nwx_repaginar();
				return;
			}
			// Expande no diretorio base dos sistema
			$destino = dirname(NWX_RAIZ);
      if (false && class_exists('ZipArchive')) {
        $zip = new ZipArchive();
        if ($zip->open($origem) === TRUE) {
          $zip->extractTo($destino);
          $zip->close();
          nwx_alerta(_("Sistema foi atualizado com conteudo de $arquivo"));
        } else {
          nwx_alerta(_("Erro ao expandir arquivo $arquivo"));
        }
			  $this->sair = true;
			  nwx_db::audita('Atualizar Sistema', 'nw_apl');
			  nwx_repaginar();
			  return;
      } else {
        $origem .= '/';
        File_Archive::extract($origem, $destino);
        nwx_alerta(_("Sistema foi atualizado com conteudo de $arquivo"));
 			  $this->sair = true;
        nwx_repaginar();
        return;
      }
      
		}                                  
		
		// Parametros tipo string
		$strs = array('NWX_SESSIONS_HOST'
								 ,'NWX_DOMINIO'
								 ,'NWX_DOMCONTROL'
								 ,'NWX_LIC'
								 ,'NWX_COPYRIGHT'
								 ,'NWX_DESCRICAO'
								 ,'NWX_ESTILO'
								 ,'NWX_SERIE'
								 );
		
		// Le o arquivo de configuracao
		$arquivo = file_get_contents(NWX_BAS . DIRECTORY_SEPARATOR . NWX_APL . ".php");
		
		// Grava arquivo de configuracao como backup;
		file_put_contents(NWX_BAS . DIRECTORY_SEPARATOR . NWX_APL . "_bkp.php", $arquivo);
		
		// Percorre conteudo, alterando parametros
		foreach ($this->tabs as $c) {
			foreach ($c[1] as $campo) {
				if ($campo->id != 'NWX_DSN') {
					$nome = $campo->id;
					$valor = $this->post($nome);
					if (in_array($nome, $strs)) $valor = "'$valor'";
					if (!in_array($nome, $strs) && !$valor) $valor = "0";
					if (substr($nome, 0, 4) == 'NWX_' && strpos($arquivo, $nome) === false) {
						$arquivo .= "\n\ndefine('$nome', $valor);";
					} else {
						$arquivo = preg_replace("/(define\\(['\"]{$nome}['\"],)(.*)(\\);)/", "$1 $valor$3", $arquivo);
					}
				}
			}
		}
		
		// Regrava arquivo de configuracao;
		file_put_contents(NWX_BAS . DIRECTORY_SEPARATOR . NWX_APL . ".php", $arquivo);
		
		nwx_db::audita('Atualizar', 'nw_apl');
		$this->sair = $_sair;
		nwx_repaginar();

	}

}

/**
 * Define quadro contendo formulario de perfil
 *
 * @author Goncalo Franco
 */
class nw_apl extends nwx_quadro {

	/**
	 * Construtor: ajusta o titulo e tipo
	 */
	function __construct($id) {
		
		textdomain('nwx');
		parent::__construct($id);
		$this->titulo = _("Parametros do Sistema");
		$this->fixo = 0;

	} //__construct
	
	function monta() {
		
		$form = new nw_apl_form("nw_apl","nw_apl");
		
		$f1 = new nwx_form_check('NWX_SESSIONS_DB','N',10,0,true, false);
		$f2 = new nwx_form_check('NWX_SESSIONS_MC','N',1,0,true, false);
		$f3 = new nwx_form_text('NWX_SESSIONS_HOST','C',100,0,true, false);
		$f4 = new nwx_form_text('NWX_SESSIONS_PORT','C',100,0,true, false);
		$f5 = new nwx_form_text('NWX_SESSIONS_LIFE','N',10,0,false, false);
		$f6 = new nwx_form_check('NWX_LOGIN','N',10,0,true, false);
		$f7 = new nwx_form_check('NWX_PREFS','N',10,0,true, false);
		$f8 = new nwx_form_check('NWX_LOGOUT','N',10,0,true, false);
		$f10 = new nwx_form_check('NWX_LOGIN_USR','N',10,0,true, false);
		$f11 = new nwx_form_check('NWX_CRIA_USR','N',10,0,true, false);
		$f12 = new nwx_form_text('NWX_DOMINIO','C',100,0,true, false);
		$f13 = new nwx_form_text('NWX_DOMCONTROL','C',100,0,true, false);
		$f14 = new nwx_form_check('NWX_AUDIT','N',10,0,true, false);
		$f19 = new nwx_form_text('NWX_DSN','C',4000,0,true, true);
		
		$f16 = new nwx_form_text('NWX_DESCRICAO','C',100,0,true, false);
		
		$f17 = new nwx_form_lista('NWX_ESTILO','C',100,0,true, false);
		$f20 = new nwx_form_upload('arquivo', 'C',100,0,true,false);
		$f21 = new nwx_form_check('NWX_MANUAL','N',10,0,true, false);
		$f22 = new nwx_form_text('NWX_SESSIONS_TIME','N',10,0,true, false);
		$f23 = new nwx_form_check('NWX_SESSIONS_EA','N',1,0,true, false);
		$f24 = new nwx_form_text('NWX_TMS','N',10,0,true, false);
		$f25 = new nwx_form_check('NWX_SUBSIS','N',10,0,true, false);
	 
		$f17->opcoes = $this->pag->estilos();

		$f1->ajuda = _("Sesses mantidas no Banco de Dados");
		$f2->ajuda = _("Sesses mantidas em memria (Servidor memcached)");
		$f3->ajuda = _("Nome ou endereo do servidor de cache (memcached)");
		$f4->ajuda = _("Porta de escuta do servidor de cache (memcached)");
		$f5->ajuda = _("Tempo mximo em segundos das sesses");
		$f6->ajuda = _("Usurios autenticados internamente, sem integrao com sistema opercional.");
		$f7->ajuda = _("Ativar opo de preferencias para os usurios");
		$f8->ajuda = _("Ativar opo de desconexo para os usurios");
		$f10->ajuda = _("Forar a autenticao explcita dos usurios");
		$f11->ajuda = _("Criar novos usurios automaticamente, se no existirem");
		$f12->ajuda = _("Nome do domnio LDAP");
		$f13->ajuda = _("Nome ou endereo do servidor LDAP ou de domnio");
		$f14->ajuda = _("Ativar funes de auditoria no sistema");
		$f16->ajuda = _("Descrio do sistema");
		$f17->ajuda = _("Estilo de apresentao default");
		$f20->ajuda = _("Arquivo com atualizaes");
		$f21->ajuda = _("Mostra link para manual do usurio");
		$f22->ajuda = _("Intervalo para regenerao das sesses");
		$f23->ajuda = _("Sesses mantidas em memria (eAccelerator)");
		$f24->ajuda = _("Intervalo de tempo em segundos para verificar mensagens recebidas (0=Sem verificao)");
		$f25->ajuda = _("Mostra link para sub-sistema");
		
		$c1 = new nwx_form_cabec(_('Controle de Sesses'));
		$c1a = new nwx_form_cabec(_('Configurao do Cache'));
		$c2 = new nwx_form_cabec(_('Autenticao de Usurios'));
		$c2a = new nwx_form_cabec(_('Configurao LDAP'));
		$c2b = new nwx_form_cabec(_('Configurao do Banco de Dados'));
		$c3 = new nwx_form_cabec(_('Parmetros Diversos'));
		$c4 = new nwx_form_cabec(_('Informaes de Licena'));
		$c5 = new nwx_form_cabec(_('Atualizao do sistema'));
		
		$form->oper = 'ALT';
		$form->cabec = _('Parametros do Sistema');
		$form->operacao(_('Atualizar'),_('Atualizao do sistema'),'');
		
		$form->upload();
		$form->reset = '';
		
		$form->tab('tab1', _('Sesses'));
		$form->tab('tab2', _('Autenticao'));
		$form->tab('tab3', _('Parmetros'));
		$form->tab('tab5', _('Atualizao'));
		
		$form->input_tab('tab1',$c1);
		$form->input_tab('tab1',$f1,_('Sesses no Banco de Dados'),'','',true);
		$form->input_tab('tab1',$f23,_('Sesses em Cache (eAccelerator)'),'','',true);
		$form->input_tab('tab1',$f2,_('Sesses em Cache (memcached)'),'','',true);
		$form->input_tab('tab1',$f5,_('Tempo mximo das sesses'),'','size="10"',true);
		$form->input_tab('tab1',$f22,_('Tempo para regerar sesses'),'','size="10"',true);
		$form->input_tab('tab1',$c1a);
		$form->input_tab('tab1',$f3,_('Host ou endereo do Cache (memcached)'),'','size="80"',true);
		$form->input_tab('tab1',$f4,_('Porta do Cache (memcached)'),'','size="20"',true);
		
		$form->input_tab('tab2',$c2);
		$form->input_tab('tab2',$f6,_('Autenticao interna'),'','',true);
		$form->input_tab('tab2',$f10,_('Forar autenticao'),'','',true);
		$form->input_tab('tab2',$f11,_('Criar usurios automaticamente'),'','',true);
		$form->input_tab('tab2',$f14,_('Ativar funes de auditoria'),'','',true);
		$form->input_tab('tab2',$c2b);
		$form->input_tab('tab2',$f19,_('Conexo'),'','size="120"',true);
		$form->input_tab('tab2',$c2a);
		$form->input_tab('tab2',$f12,_('Dominio LDAP'),'','size="80"',true);
		$form->input_tab('tab2',$f13,_('Servidor LDAP'),'','size="80"',true);

		$form->input_tab('tab3',$c3);
		$form->input_tab('tab3',$f24,_('Tempo para verificar mensagens'),'','size="10"',true);
		$form->input_tab('tab3',$f7,_('Acessa Preferencias'),'','',true);
		$form->input_tab('tab3',$f8,_('Permite Desconexo'),'','',true);
		$form->input_tab('tab3',$f21,_('Mostra link para manual do usurio'),'','',true);
		$form->input_tab('tab3',$f25,_('Mostra link para sub-sistema'),'','',true);
		$form->input_tab('tab3',$f16,_('Descrio'),'','size="80"',true);
		$form->input_tab('tab3',$f17,_('Estilo Default'),'','size="1"',true);

		$form->input_tab('tab5',$c5);
		$form->input_tab('tab5',$f20,_('Arquivo'),'','size="80"',true);
		
		$form->mostra();
	
	}

}
// vim:et:sw=2:ts=2:nowrap