<?php
/**
 * Relatrio de Auditoria
 *
 * @author Gonalo Franco
 * @version $Id$
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_form.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_grid.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_time.php");

/**
 * Define o quadro para mostrar na tela
 */
class nw_audt_rel extends nwx_quadro {

  /**
   * Construtor: ajusta o titulo e tipo
   */
  function __construct($id) {
    
    parent::__construct($id);
    $this->titulo = _("Trilha de Auditoria");
    $this->fixo = 0;

  }
  
  /**
   * Mostra o quadro na tela
   */
  function monta() {

    $ic = nwx_qico('nw_acs_aud');
    $dat = nwx_time::date_db(nwx_time::current_date());
    
    $_SESSION['nwx_etc']['raud1'] = $dat;
    $_SESSION['nwx_etc']['raud2'] = '';
    $_SESSION['nwx_etc']['raud3'] = '';
    $_SESSION['nwx_etc']['raud4'] = '';
    $_SESSION['nwx_etc']['raud5'] = '';

    // Le o registro
    $db = nwx_db::conexao();
    
    $tit = _("Relatrio de Trilha de Auditoria");

    // Parametro 1 : Data inicial
    $h1 = "<input class=\"form-input\" type=\"text\" id=\"raud1\" name=\"raud1\" size=\"10\" value=\"$dat\" onchange=\"nwx_session('raud_p','raud1');\" onkeypress=\"return focusNext(this.form,'raud1',event);\">\n";
    
    $h1 .= "<img src=\"/nwx/img/calendar.gif\" align=\"top\" id=\"cal_img_raud1\" style=\"cursor:pointer;border:0px;\" title=\"Clique para calendario\">\n";
    $h1 .= "\n<script type=\"text/javascript\">\n";
    $h1 .= "Calendar.setup({\n";
    $h1 .= "inputField     :  \"raud1\",\n";
    $h1 .= "ifFormat       :  \"%d/%m/%Y\",\n";
    $h1 .= "button         :  \"cal_img_raud1\",\n";
    $h1 .= "singleClick    :  true\n";
    $h1 .= "});\n";
    $h1 .= "</script>\n";
    
    // Parametro 2 : Data final
    $h2 = "<input class=\"form-input\" type=\"text\" id=\"raud2\" name=\"raud2\" size=\"10\" value=\"\" onchange=\"nwx_session('raud_p','raud2');\" onkeypress=\"return focusNext(this.form,'raud2',event);\">";
    $h2 .= "<img src=\"/nwx/img/calendar.gif\" align=\"top\" id=\"cal_img_raud2\" style=\"cursor:pointer;border:0px;\" title=\"Clique para calendario\">\n";
    $h2 .= "\n<script type=\"text/javascript\">\n";
    $h2 .= "Calendar.setup({\n";
    $h2 .= "inputField     :  \"raud2\",\n";
    $h2 .= "ifFormat       :  \"%d/%m/%Y\",\n";
    $h2 .= "button         :  \"cal_img_raud2\",\n";
    $h2 .= "singleClick    :  true\n";
    $h2 .= "});\n";
    $h2 .= "</script>\n";

    // Parametro 3 : Menu
    $h3 = "<input class=\"form-input\" type=\"text\" id=\"raud3\" name=\"raud3\" size=\"30\" value=\"\" onchange=\"nwx_session('raud_p','raud3');\" onkeypress=\"return focusNext(this.form,'raud3',event);\">";

    // Parametro 4 : Operacao
    $h4 = "<input class=\"form-input\" type=\"text\" id=\"raud4\" name=\"raud4\" size=\"30\" value=\"\" onchange=\"nwx_session('raud_p','raud4');\" onkeypress=\"return focusNext(this.form,'raud4',event);\">";
    
    // Parametro 5 : Usuario
    $h5 = "<select name=\"raud5\" class=\"sel_opc\" onchange=\"nwx_session('raud_p','raud5');\" onkeypress=\"return focusNext(this.form,'raud5',event);\">" .
    $sql = "select usr, usr || ' - ' || nome as nome from nw_usr order by nome";
    $rh = $db->execute($sql);
    $h5 .= "<option selected value=\"\"></option>";
    while (!$rh->EOF) {
      $c = $rh->fields['usr'];
      $v = $rh->fields['nome'];
      $h5 .= "<option value=\"$c\">$v</option>";
      $rh->MoveNext();
    }
    $h5 .= "</select>";

    // Monta a regiao dos parametros
    $hlp = "<table width=\"100%\" class=\"layout\" cellspacing=\"0\">
    <tr>
        <td class=\"cabmsg1\">"._("Data Inicial")."XXX</td>
        <td class=\"cabmsg1\">"._("Data Final")."</td>
        <td class=\"cabmsg1\">"._("Menu")."</td>
        <td class=\"cabmsg1\">"._("Operao")."</td>
    </tr>
    <tr>
        <td class=\"cabmsg2\">$h1</td>
        <td class=\"cabmsg2\">$h2</td>
        <td class=\"cabmsg2\">$h3</td>
        <td class=\"cabmsg2\">$h4</td>
    </tr>
    <tr>
        <td colspan=\"4\" class=\"cabmsg1\">"._("Usurio")."</td>
    </tr>
    <tr>
        <td colspan=\"4\" class=\"cabmsg2\">$h5</td>
    </tr>
    </table>";  
    
    // Mostra a tela 
    echo "<form id=\"raud_p\" style=\"display:inline;margin:0px;\">\n";
    
    echo "<table width=\"100%\" class=\"layout\" cellspacing=\"0\">\n";
    echo "<tr>";
    echo "<td class=\"rel-cabec\">";
    echo _("Selecionar parametros do relatrio");
    echo "</td>";
    echo "<td class=\"rel-control\">";
    echo bt_fechar("nw_audt_rel");
    echo "</td></tr>";
    echo "<tr><td colspan=\"2\" class=\"cablin\" style=\"border-width:0px 1px 1px 1px;\"\>";
    echo $hlp;
    echo "</td></tr>";
    echo "<tr>";
    echo "<td colspan=\"2\"  class=\"cablin\" style=\"border-width:0px 1px 1px 1px;padding:4px;text-align:right;\">";
    echo bt_comado("Iniciar", "nw_audt_ls", '', 'Iniciar relatrio', 1, 10, 2, $ic);
    echo "</td></tr>";
    echo "</table>";
    
    echo "</form>\n";
    
  }

}
// vim:et:sw=2:ts=2:nowrap
