<?php
/**
 * Relatorio de trilha de auditoria
 *
 * @author Gonalo Franco
 * @version $Id$
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_time.php");

/**
 * Monta a matriz hierarquica de linhas
 */
function monta_tab() {

	$lista = array();

	$db = nwx_db::conexao();

	$p1 = '';
	$p2 = '';
	$p3 = '';
	$p4 = '';
	$p5 = '';
	if (isset($_SESSION['nwx_etc']['raud1'])) {
		$p1 = $_SESSION['nwx_etc']['raud1'];
	}
	if (isset($_SESSION['nwx_etc']['raud2'])) {
		$p2 = $_SESSION['nwx_etc']['raud2'];
	}
	if (isset($_SESSION['nwx_etc']['raud3'])) {
		$p3 = $_SESSION['nwx_etc']['raud3'];
	}
	if (isset($_SESSION['nwx_etc']['raud4'])) {
		$p4 = $_SESSION['nwx_etc']['raud4'];
	}
	if (isset($_SESSION['nwx_etc']['raud5'])) {
		$p5 = $_SESSION['nwx_etc']['raud5'];
	}
	
	if ($p1) {
		if (nwx_time::data_valida($p1)) {
			$d1 = nwx_time::data_iso($p1, false);
		} else {
			$d1 = '1900-01-01';
		}
	}
	if ($p2) {
		if (nwx_time::data_valida($p2)) {
			$d2 = nwx_time::data_iso(nwx_time::data_unix($p2) + 86400, false);
		} else {
			$d2 = '2900-01-01';
		}
	}
	
	$sis = NWX_SIS;
	$w = "a.aplic = '$sis'";
	if ($p1) {
		$w .= " and a.dt_aud >= '$d1'";
	}
	if ($p2) {
		$w .= " and a.dt_aud < '$d2'";
	}
	if ($p3) {
		$w .= " and b.texto like '$p3%'";
	}
	if ($p4) {
		$w .= " and a.oper like '$p4%'";
	}
	if ($p5) {
		$w .= " and a.usr_aud = '$p5'";
	}
	
	$st = "select a.*, b.texto as menu, u.nome as usuario from nw_audt a
					 left join nw_mnu b on (a.aplic = b.aplic and a.id_mnu = b.id)
					 left join nw_usr u on (a.usr_aud = u.usr)
					 where $w order by a.dt_aud";
	//die($st);
	$rs = $db->execute($st);
	$ln = 0;

	while (!$rs->EOF) {
	
		// Linha principal
		$cod = ++$ln; 
		$lin = array();
		$lin[0] = strftime('%d/%m/%Y %H:%M:%S',strtotime($rs->fields['dt_aud']));
		$lin[1] = $rs->fields['usr_aud'];
		$lin[2] = $rs->fields['usuario'];
		$lin[3] = $rs->fields['menu'];
		$lin[4] = $rs->fields['oper'];
		$lin[5] = $rs->fields['ip'];
		$lin[6] = $rs->fields['adm'] ? 'S' : 'N';
		$lin[7] = $rs->fields['bloco'];
		$lin[8] = $rs->fields['id_aud'];
		$lista[] = $lin;

		$rs->MoveNext();

	}

return $lista;

}

/**
 * Cria relatorio
 *
 * @param $rel Se chamado de um relatorio = 'r'
 * @return String com a planilha em HTML
 */
function planilha($rel = false) {

	$titulo = _("Relatrio de Trilha de Auditoria");
	$db = nwx_db::conexao();

	// Monta a matriz de linhas
	$linhas = monta_tab();

	// Monta o cabecalho
	$c = date(nwx_time::date_format());

	$cabec = array();
	$cabec[] = array(_('Nmero'),'5%');
	$cabec[] = array(_('Data'),'13%');
	$cabec[] = array(_('Usurio'),'9%');
	$cabec[] = array(_('Nome'),'18%');
	$cabec[] = array(_('Menu'),'18%');
	$cabec[] = array(_('Operao'),'18%');
	$cabec[] = array(_('Estao'),'8%');
	$cabec[] = array(_('Adm'),'1%');
	$cabec[] = array(_('Bloco'),'10%');

	$p = "<table class=\"layout\" cellspacing=\"0\">";

	// Monta o cabecalho
	$p .= print_head(_("Trilha de Auditoria"), $cabec);

	$p .= "<tbody>";

	$n = 0;
	// Monta a tabela HTML com as linhas da tabela
	foreach ($linhas as $lin) {

		// Colunas com os valores
		$p .= "<tr>".
					"<td class=\"plan\" style=\"border-width:0px 1px 1px 1px;\">$lin[8]&nbsp;</td>".
					"<td class=\"plan\">$lin[0]&nbsp;</td>".
					"<td class=\"plan\">$lin[1]&nbsp;</td>" .
					"<td class=\"plan\">$lin[2]&nbsp;</td>" .
					"<td class=\"plan\">$lin[3]&nbsp;</td>" .
					"<td class=\"plan\">$lin[4]&nbsp;</td>" .
					"<td class=\"plan\">$lin[5]&nbsp;</td>" .
					"<td class=\"plan\">$lin[6]&nbsp;</td>" .
					"<td class=\"plan\">$lin[7]&nbsp;</td>" .
					"</tr>";

	}

	$p .= "</tbody>";
	$p .= "</table>";

	return array($titulo,$p,$linhas);
	
}
// vim:et:sw=2:ts=2:nowrap
