<?php
/**
 * Mostra bloco de avisos iniciais
 *
 * @author Gonalo Franco
 * @version $Id$
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_form.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");

/**
 * Define quadro contendo formulario de perfil
 *
 * @author Goncalo Franco
 */
class nw_aviso extends nwx_quadro {

	/**
	 * Construtor: ajusta o titulo e tipo
	 */
	function __construct($id) {
		
		textdomain('nwx');
		parent::__construct($id);
		$this->titulo = _('Informaes da conexo');
		$this->fixo = 1;
		$this->icone = '/nwx/img/chat.gif';

	} 
	
	function monta() {
		
		$db = nwx_db::conexao();
		$usr = $_SESSION['nwx_usr'];
		$rs = $db->execute("select * from nw_usr where usr = ?", array($usr));
		if (!$rs->EOF) {
			$nome = $rs->fields['nome'];
			$exp = @$rs->fields['xsen'] ? nwx_time::date_db($rs->fields['xsen']) : '';
			$ult = isset($_SESSION['nwx_ulog']) ? $_SESSION['nwx_ulog'] : '';
		} else {
			$nome = '';
			$exp = '';
			$ult = '';
		}
		$mdx = '';
		if ($exp) {
			$dx = nwx_time::diff_dias(date(nwx_time::date_format()), $exp);
			if ($dx == 1) {
				$mdx = "(Amanh)";
			} else if ($dx > 0) {
				$mdx = "($dx dias)";
			}
			 
		}
		$val = '';
		$val1 = '';
		// Se usuario interno, mostra validade da senha
		if ($rs->fields['uex']) {
			$val1 .= "<tr>
					<td class=\"form-cel\">Senha expira em: </td><td class=\"form-cel\" style=\"color:#000;\">$exp $mdx</td>
					</tr>";
		}
		// Verifica se tem mensagens pendentes
		if (nwx_mensagens()) {
			$val1 .= "<tr>"
						. "<td colspan=\"2\" class=\"form-cabec\">"
						. _("Voc tem novas mensagens em sua caixa de entrada")
						. "</td>"
						. "</tr>";
		}
		if (isset($_SESSION['nwx_alr2']) && $_SESSION['nwx_alr2']) {
			$val1 .= "<tr>"
						. "<td colspan=\"2\" class=\"form-cabec\">"
						. $_SESSION['nwx_alr2']
						. "</td>"
						. "</tr>";
			unset($_SESSION['nwx_alr2']);
		}
		if (isset($_SESSION['nwx_conn']) && $_SESSION['nwx_conn'] == 2) {
			$val = "<table class=\"layout\">"
					 . "<tr>"
					 . "<td colspan=\"2\" class=\"form-cabec\">"
					 . _("Usurio incluido automaticamente. Altere seus dados com a funo \"Seu Cadastro\"")
					 . "</td>"
					 . "</tr></table>";
		}
			
		$h = '';
		if ($rs->fields['adm']) {
			$h .= "<br><span class=\"texto\"><img align=\"absmiddle\" src=\"/nwx/img/tchk.png\"> "._("Administrador do Sistema")."</span>";
		}
		if ($rs->fields['sec']) {
			$h .= "<br><span class=\"texto\"><img align=\"absmiddle\" src=\"/nwx/img/tchk.png\"> "._("Administrador de Segurana")."</span>";
		}
		if ($rs->fields['uex']) {
			$h .= "<br><span class=\"texto\"><img align=\"absmiddle\" src=\"/nwx/img/tchk.png\"> "._("Autenticao interna")."</span>";
		} else {
			$h .= "<br><span class=\"texto\"><img align=\"absmiddle\" src=\"/nwx/img/tchk.png\"> "._("Pr-autenticado")."</span>";
		}
		
		// Mostra corpo do quadro
		echo "<table cellspacing=\"4\">
					<tr>
					<td class=\"form-cel\">Usuario: </td><td class=\"form-cel\" style=\"color:#000;\">$usr ($nome)$h</td>
					</tr>
					<tr>
					<td class=\"form-cel\">Ultimo Acesso: </td><td class=\"form-cel\" style=\"color:#000;\">$ult</td>
					</tr>
					$val1
					</table>
					$val
		"; 
	
	}

}
// vim:et:sw=2:ts=2:nowrap
