<?php
/**
 * Manutencao da tabela de blocos fixos
 *
 * @author Gonalo Franco
 * @version $Id: nw_blo.php 904 2006-12-22 21:20:07Z goncalo $
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_form.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_grid.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_time.php");

/**
 * Formulario para Alteracao,Inclusao e Exclusao de grupos
 */
class nw_blo_form extends nwx_form {

  /**
   * Carrega dados do BD nos campos do formulario
   */
  function carrega() {

    if ($this->oper == 'Incluir')
      return null;
    $stmt = "select * from nw_fix where aplic = ? and id = ?";
    $db = nwx_db::conexao();
    if ($this->inicio()) {
      $rs = $db->execute($stmt, array(NWX_SIS, $this->id[0]));
      if (!$rs->EOF) {
        $this->valor('id',$rs->fields['id']);
        $this->valor('aba',$rs->fields['aba']);
        $this->valor('cln',$rs->fields['cln']);
        $this->valor('seq',$rs->fields['seq']);
        $this->valor('bloco',$rs->fields['bloco']);
      }
    }
  }

  /**
   * Chamado ao pressionao botao no grid
   */
  function prepara() {

    $db = nwx_db::conexao();
    $oper = $this->oper;
    
    $rs = $db->execute("select bloco from nw_fix where aplic =? and id = ?", array(NWX_SIS,$this->id[0]));
    $bloco = $rs->fields['bloco'];
    
    $ico = nwx_qico('nw_blo');
    $sta = nwx_qsta('nw_blo');
    if ($ico) {
      $ico = "&ico=$ico";
    } 
    
    if ($oper == 'Acessos') {
      $this->reset_opr();
      header("Location: " . NWX_RDX . NWX_LOC ."?blc=nw_blo_ace&b=$bloco&col=1&seq=10&sta=$sta{$ico}");
    }
    
    return true;
    
  }
  
  /**
   * Processamento do formulario
   */
  function processa($_sair) {

    $db = nwx_db::conexao();
    if ($this->oper == 'Alterar') {
      $stm = "update nw_fix set aba = ?,cln = ?,seq = ?,bloco = ? where aplic = ? and  id = ?";
      $p = array($this->post('aba')
                ,$this->post('cln')
                ,$this->post('seq')
                ,$this->post('bloco')
                ,NWX_SIS
                ,$this->id[0]
      );
      $this->sair = $_sair;
    } elseif ($this->oper == 'Incluir') {
      $stm = "insert into nw_fix(aplic,id,aba,cln,seq,bloco) values(?,?,?,?,?,?)";
      $p = array(NWX_SIS
                ,$db->GenID('nw_fix_seq')
                ,$this->post('aba')
                ,$this->post('cln')
                ,$this->post('seq')
                ,$this->post('bloco')
      );
      $this->sair = false;
    } elseif ($this->oper == 'Excluir') {
      $stm = "delete from nw_fix where aplic = ? and id = ?";
      $p = array(NWX_SIS, $this->id[0]);
      $this->sair = true;
    } else {
      $this->sair = false;
      return;
    }

    // Processamento final no Banco de Dados
    // Se houver erro mostra mensagem do Banco na area de mensagens
    nwx_db::begin_trans();
    if (!$db->execute($stm, $p)) {
      $this->sair = false;
      $this->erro(nwx_db::erro());
      nwx_db::fail_trans();
    }
    else {
      nwx_repaginar();
    }
    nwx_db::audita($this->oper, $this->bloco, $p);
    nwx_db::end_trans();
  }

}


/**
 * Cria o quadro que contem o grid de manutencao
 */
class nw_blo extends nwx_quadro {

  /**
   * Construtor: ajusta o titulo e tipo
   */
  function __construct($id) {
    
    textdomain('nwx');
    parent::__construct($id);
    $this->titulo = _("Mdulos");
    $this->fixo = 0;

  }

  /**
   * Monta o conteudo do quadro
   */
  function monta() {

    $sql = "select a.id as id, a.aba as aba, b.texto as menu, a.cln as cln, a.seq as seq, a.bloco as bloco " .
           " from nw_fix a left join nw_mnu b on a.aplic = b.aplic and a.aba = b.id";

    // Objeto grid
    $grid = new nwx_grid($this,$sql,"a.aplic = '" . NWX_SIS ."'","a.aba, a.cln, a.seq");

    // Prepara os campos de filtro ou busca (campo, nome a mostrar, tipo)
    $grid->filtro = array(array('b.texto',  _('Pgina'), 'C'),
                          array('a.bloco', _('Mdulo'), 'C')
                         );

    // Colunas do grid (campo,label,largura,alinhamento,tipo,formato)
    $grid->colunas = array(array('menu',  _('Pgina'), '20%','E','C',''),
                           array('cln',   _('Coluna'), '8%','E','N',''),
                           array('seq',   _('Seq'),    '8%','E','N',''),
                           array('bloco', _('Mdulo'),  '64%','E','C','')
                          );

    // Nome da coluna que identifica a linha
    $grid->pk = array('id');

    // Numero de linhas por pagina
    $grid->linhas(10,18);

    // Cria o formulario para processamento do registros
    $form = new nw_blo_form("nw_blo_form","nw_blo");

    // Guarda o nome do grid internamente no formulario
    $form->grid = $grid->nome;

    // Cria os campos do formulario e sua representacao
    $f1 = new nwx_form_lista('aba','N',5,0,true,false);
    $f1->opcoes = array(_("Todas"));
    $f1->query = "select id, texto from nw_mnu where aplic = '".NWX_SIS."' and pai is null order by id";
    $f2 = new nwx_form_text('cln',  'N', 5,0,false,false);
    $f3 = new nwx_form_text('seq',  'N', 5,0,false,false);
    $f4 = new nwx_form_text('bloco','C',30,0,false,false);

    $f1->ajuda = _('Pgina onde deve se mostrado');
    $f2->ajuda = _('Coluna na pgina em que deve ser mostrado (Comea com zero: 0,1,2,etc.)');
    $f3->ajuda = _('Numero de sequencia do mdulo na coluna (Qualquer numero para ordenao)');
    $f4->ajuda = _('Nome do mdulo a ativar');
     
    $form->input($f1,_('Pgina'),   '','size="1"',true);
    $form->input($f2,_('Coluna'),   '','size="5"',false);
    $form->input($f3,_('Sequencia'),'','size="5"',false);
    $form->input($f4,_('Mdulo'),    '','size="30"',false);

    // Cria os botoes para funcoes do grid
    // Array indexado pelo label do botao, contendo :
    // (nome da funcao p/ form, o form, se campos read-only, se reg.novo)
    $grid->oper = array('Incluir' => array(_('Incluir'),$form,false,true),
                        'Alterar' => array(_('Alterar'),$form,false,false),
                        'Excluir' => array(_('Excluir'),$form,true,false),
                        'Acessos' => array(_('Acessos'),$form,true,false)
                       );

    // Mostra o grid na pagina
    $grid->mostra($this);
  }

}
// vim:et:sw=2:ts=2:nowrap
