<?php
/**
 * Manutencao da tabela de estilos
 *
 * @file nw_etl.php
 * @author Gonalo Franco
 * @version $Id: nw_etl.php 924 2007-01-11 18:36:37Z goncalo $
 */

require_once("nwx.php");
require_once("nwx_form.php");
require_once("nwx_quadro.php");
require_once("nwx_grid.php");
require_once("nwx_util.php");
require_once("nwx_time.php");

/**
 * Formulario para Alteracao,Inclusao e Exclusao de estilos
 */
class nw_etl_form extends nwx_form {

  /**
   * Carrega dados do BD nos campos do formulario
   */
  function carrega() {

    if ($this->oper == 'Incluir')
      return null;
    $stmt = "select * from nw_etl where estilo = '" . trim($this->id[0]) . "'";
    $DB = nwx_db::conexao();
    if ($this->inicio()) {
      $rs = $DB->execute($stmt);
      if (!$rs->EOF) {
        $this->valor('estilo',$rs->fields['estilo']);
        $this->valor('descricao',$rs->fields['descricao']);
      }
    }
  }

  /**
   * Processamento do formulario
   */
  function processa($_sair) {

    $DB = nwx_db::conexao();
    if ($this->oper == 'Alterar') {
      $stm = "update nw_etl set ".
             "descricao = " . $DB->quote($this->post('descricao')) .
             " where estilo = '" . $this->id[0] . "'";
      $this->sair = $_sair;
    }
    elseif ($this->oper == 'Incluir') {
      $stm = "insert into nw_etl(estilo,descricao)".
             " values(".
             $DB->quote(strtolower($this->post('estilo'))) .
             "," . $DB->quote($this->post('descricao')) .
             ")";
      $this->sair = false;
    }
    elseif ($this->oper == 'Excluir') {
      $stm = "delete from nw_etl where estilo = '" . $this->id[0] . "'";
      $this->sair = true;
    } else {
      $this->sair = false;
      return;
    }

    // Processamento final no Banco de Dados
    // Se houver erro mostra mensagem do Banco na area de mensagens
    if (!$DB->execute($stm)) {
      $this->sair = false;
      $this->erro($DB->errormsg());
    }
    else
      nwx_repaginar();

  }

}


/**
 * Cria o quadro que contem o grid de manutencao
 */
class nw_etl extends nwx_quadro {

  /**
   * Construtor: ajusta o titulo e tipo
   */
  function __construct($id) {
    
    parent::__construct($id);
    $this->titulo = "Estilos";
    $this->fixo = 0;

  } //__construct

  /**
  * Monta o conteudo do quadro
  */
  function monta() {

    // Objeto grid
    $grid = new nwx_grid($this,'select * from nw_etl','','estilo');

    // Prepara os campos de filtro ou busca (campo, nome a mostrar, tipo)
    $grid->filtro = array(array('estilo',    'Estilo', 'C'),
                          array('descricao', 'Descrio', 'C')
                         );

    // Colunas do grid (campo,label,largura,alinhamento,tipo,formato)
    $grid->colunas = array(array('estilo',     'Estilo', '15%','E','C',''),
                           array('descricao',  'Descrio', '85%','E','C','')
                          );

    // Nome da coluna que identifica a linha
    $grid->pk = array('estilo');

    // Numero de linhas por pagina
    $grid->linhas(10,18);

    // Cria o formulario para processamento do registros
    $form = new nw_etl_form("nw_etl_form","nw_etl");

    // Guarda o nome do grid internamente no formulario
    $form->grid = $grid->nome;

    // Cria os campos do formulario e sua representacao
    $f1 = new nwx_form_text('estilo','C',10,0,false,true);
    $f2 = new nwx_form_text('descricao','C',100,0,false,false);

    $form->input($f1,'estilo','','size="20"',true);
    $form->input($f2,'Descrio','','size="70"',false);

    // Cria os botoes para funcoes do grid
    // Array indexado pelo label do botao, contendo :
    // (nome da funcao p/ form, o form, se campos read-only, se reg.novo)
    $grid->oper = array('Incluir' => array('Incluir',$form,false,true),
                        'Alterar' => array('Alterar',$form,false,false),
                        'Excluir' => array('Excluir',$form,true,false)
                       );

    // Mostra o grid na pagina
    $grid->mostra($this);
  }

}
// vim:et:sw=2:ts=2:nowrap
