<?php
/**
 * Montagem do mapa de perfis
 *
 * @author Gonalo Franco
 * @version $Id$
 */

/**
 * Monta a matriz hierarquica de linhas
 */
function monta_sub($pai, $niv, $cod, &$lista, $perfis) {

  $db = nwx_db::conexao();

  $sis = NWX_SIS;
  
  $st = "select * from nw_mnu where aplic = '$sis' and pai = $pai order by ordem, id";
  $rs = $db->execute($st);
  $ln = 0;
  $nivel = $niv + 1;

  while (!$rs->EOF) {
    $id = $rs->fields['id'];
    $nome = $rs->fields['texto'];
    $bloco = $rs->fields['bloco'];
    $cod2 = $cod . '.' . ++$ln; 
    $st2 = "select id from nw_mnu where aplic = '$sis' and pai = $id";
    $rs2 = $db->execute($st2);
    $fil = (!$rs2->EOF);
    $lin = array($nome, $nivel, $cod2, $fil, $bloco);
    foreach ($perfis as $cr) {
      $val = 0;
      if ($bloco) {
        $str = "select id from nw_acs where aplic = '$sis' and bloco = '$bloco' and usr = '$cr'";
        $rsr = $db->execute($str);
        if (!$rsr->EOF) {
          $val = 1;
        }
      }
      $lin[] = $val;
    }
    $lista[] = $lin;
    if ($fil) monta_sub($id, $nivel, $cod2, $lista, $perfis);

    $rs->MoveNext();
  }

  return $lista;

}

/**
 * Monta a matriz hierarquica de linhas
 */
function monta_tab($perfis) {

  $lista = array();

  $db = nwx_db::conexao();
  
  $sis = NWX_SIS;

  $st = "select * from nw_mnu where aplic = '$sis' and pai is null order by ordem, id";
  $rs = $db->execute($st);
  $ln = 0;

  while (!$rs->EOF) {
    $id = $rs->fields['id'];
    $nome = $rs->fields['texto'];
    $bloco = $rs->fields['bloco'];
    $st2 = "select id from nw_mnu where aplic = '$sis' and pai = $id";
    $rs2 = $db->execute($st2);
    $fil = (!$rs2->EOF);
    if (!$fil) {
      $rs->MoveNext();
      continue;
    }
    $cod = ++$ln; 
    $lin = array($nome, 0, $cod, $fil, $bloco);
    foreach ($perfis as $cr) {
      $val = 0;
      if ($bloco) {
        $str = "select 1 from nw_acs where aplic = '$sis' and bloco = '$bloco' and usr = '$cr'";
        $rsr = $db->execute($str);
        if (!$rsr->EOF) {
          $val = 1;
        }
      }
      $lin[] = $val;
    }
    $lista[] = $lin;
    if ($fil) monta_sub($id, 0, $cod, $lista, $perfis);

    $rs->MoveNext();
  }

return $lista;

}

/**
 * Cria relatorio
 *
 * @param $rel Se chamado de um relatorio = 'r'
 * @return String com a planilha em HTML
 */
function planilha($rel = false) {

  $titulo = _("Mapa de Acessos por Perfil");
  
  $db = nwx_db::conexao();

  $ab = '';
  // Se for um submit
  if (isset($_POST['csa_opr'])) { 
    $det = explode('&', $_POST['csa_opr']);
    if (count($det) == 4) {
      if ($det[0] == 1) {
        $nid = $db->GenID("nw_acs_seq");
        $p = array(NWX_SIS, $det[1], $det[2], $nid);
        $db->execute("insert into nw_acs values(?,?,?,?)", $p);
        nwx_db::audita('Ativa acesso', 'nw_grp', $p);
      } else if ($det[0] == 2) {
        $p = array(NWX_SIS, $det[1], $det[2]);
        $db->execute("delete from nw_acs where aplic = ? and bloco = ? and usr = ?", $p);
        nwx_db::audita('Desativa acesso', 'nw_grp', $p);
      }
      $ab = $det[3]; 
    } else if (count($det) == 1) {
      $pagina = $_POST['csa_opr'];  
      $_SESSION['nwx_etc']['nw_map'] = $pagina;
    }
  }
  
  $maxcol = $rel ? 1000 : 8;
  
  $perfis = array();
  $perfis2 = array();
  $helps = array();
  $pags = array();
  $pag_perfis = array();
  $pag_helps = array();
  
  $rs = $db->execute("select codigo,nome from v_nw_grupos where tipo = 'G' 
                         and codigo is not null 
                         and codigo <> 'ANON' 
                       order by codigo");
  $ncol = 0;
  $tcol = 0;
  $pag = 0;
  while (!$rs->EOF) {
    $pag = floor($tcol / $maxcol);
    if (!isset($pag_perfis[$pag])) {
      $pag_perfis[$pag] = array();
      $pag_helps[$pag] = array();
      $pags[$pag] = $rs->fields['codigo'];
    }
    $pag_perfis[$pag][] = $rs->fields['codigo'];
    $pag_helps[$pag][] = $rs->fields['nome'];
    $perfis2[] = $rs->fields['codigo'];
    $rs->MoveNext();  
    ++$tcol;
  }
  
  $maxpag = count($pag_perfis) - 1;
  if (!isset($pagina)) {
    if (isset($_SESSION['nwx_etc']['nw_map'])) {
      $pagina = $_SESSION['nwx_etc']['nw_map'];
    } else {
      $pagina = 0;
    }
  }
  $_SESSION['nwx_etc']['nw_map'] = $pagina;
  
  if ($pagina > $maxpag) $pagina = $maxpag;
  $ncol = count($pag_perfis[$pagina]);
  $perfis = $pag_perfis[$pagina];
  $helps = $pag_helps[$pagina];
  
  // Monta a matriz de linhas
  $linhas = monta_tab($perfis);
  
  // Linhas para planilha excel
  //$linhas2 = monta_tab($perfis2);
  $linhas2 = array();
       
  if ($pagina > 0) {
    $ant = $pagina - 1;
    $a1 = "<a ".nwx_ttip('Pagina anterior')." href=\"javascript:submit_oper('nw_grp_map_01','csa_opr','$ant');\">";
    $prev = $a1 . '<img border=0 src="/nwx/img/prev.gif"></a>';
  } else {
    $prev = '&nbsp;';
  }
  if ($pagina < $maxpag) {
    $ant = $pagina + 1;
    $a1 = "<a ".nwx_ttip('Prxima pagina')." href=\"javascript:submit_oper('nw_grp_map_01','csa_opr','$ant');\">";
    $next = $a1 . '<img border=0 src="/nwx/img/next.gif"></a>';
  } else {
    $next = '&nbsp;';
  }

  // Monta o cabecalho
  $p = "<form id=\"nw_grp_map_01\" method=\"post\" style=\"display:inline;margin:0px;\">\n";
  
  $p .= "<input type=\"hidden\" name=\"csa_opr\" value=\"\">";

  $p .= "<div class=\"titulo\">" .
        _("Mapa de Acessos por Perfil").
        "</div>";

  $p .= "<table id=\"lstcp\" width=\"100%\" class=\"layout\" cellspacing=\"1\">\n";

  $p .= "<tr id=\"t\">".
        "<td width=\"20%\" class=\"hdplanilha\">"._("Funes")."</td>" .
        "<td width=\"1px\" class=\"hdplanilha\">$prev</td>";
  
  // Uma coluna para cada risco
  $i = 0;
  $x = round(80 / $ncol,0);
  foreach ($perfis as $cr) {
    $p .= "<td width=\"$x%\" class=\"hdplanilha\">" .
          "<a ".nwx_ttip($helps[$i])." href=\"#\">$cr</a></td>";    
    ++$i;      
  }
  $p .= "<td width=\"1px\" class=\"hdplanilha\">$next</td>";

  // Monta a tabela HTML com as linhas da tabela
  foreach ($linhas as $lin) {
    $idl = $lin[2];
    // Calcula indentao dependendo do nivel
    $s = ""; 
    for ($i = 0; $i < $lin[1]; ++$i) {
      $s .= "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    // Se existe subnivel, colocar o icone para expandir
    if ($lin[3]) {
      if (!$rel)
        $img="<img id=\"img.t.$idl\" style=\"CURSOR:hand\" onclick=\"Collapse('t.$idl')\" height=\"9\" src=\"/nw/img/plus1.gif\" width=\"9\">&nbsp;";
      else
        $img = "";
    } else {
      $img = "";
    }
    // Cores das linhas
    if (!$lin[4]) {
      if ($lin[1] < 1) {
        $cor = "#ccccdd";
      } else {
        $cor = "#ddddee";
      }
    } else {
      $cor = "#eeeeee";
    }
    
    $corh = "#bbbbff";

    // Javascript para expandir/contrair niveis
    $jsc = "onMouseOver=\"mOver('t.$idl','$corh');\" onMouseOut=\"mOut('t.$idl','$cor');\"";
    

    // Colunas com os valores
    $p .= "<tr bgcolor=\"$cor\" id=\"t.$idl\" $jsc>".
          "<td class=\"planilha\" style=\"vertical-align:middle;\">$s$img$lin[0]</td>".
          "<td class=\"planilha\" style=\"vertical-align:middle;\">&nbsp;</td>";
    
    // Uma coluna para cada perfil
    $ic = 5;
    foreach ($perfis as $cr) {
      if ($lin[4]) {
        $col = $lin[$ic] ? '<img border=0 src="/nwx/img/check2.gif">' : '<img border=0 src="/nwx/img/ucheck2.gif">';
        if ($lin[$ic]) {
          $q = 2;
          $hq = _('Clique para desativar acesso');
        } else {
          $q = 1;
          $hq = _('Clique para ativar acesso');
        }
        if ($_SESSION['nwx_sec'] && !$rel) {
          $a1 = "<a ".nwx_ttip($hq)." href=\"javascript:submit_oper('nw_grp_map_01','csa_opr','{$q}&{$lin[4]}&$cr&$idl');\">";
          $a2 = "</a>";
        } else {
          $a1 = '';
          $a2 = '';
        }
      } else {
        $col = '&nbsp;';
        $a1 = '';
        $a2 = '';
      }
      $p .= "<td class=\"planilha\" style=\"text-align:center;vertical-align:middle;\">{$a1}$col{$a2}</td>";  
      ++$ic;
    }
    $p .=  "<td class=\"planilha\" style=\"vertical-align:middle;\">&nbsp;</td>";
    $p .= "</tr>";
    
  }

  $p .= "</table>";
  $p .= "</form>";

  // Script para colocar a tabela no estado inicial
  // A primeira chamada fecha tudo, ficando apenas o cabecalho. A segunda abre o cabecalho
  if (!$rel) {
    $op = $ab ? "OpenNode('t.$ab','1');\n" : '';
    $p .= "<SCRIPT LANGUAGE=\"javascript\">\n" .
        "//<!--\n".
        "Collapse('t');\n" .
        "Collapse('t');\n" .
        $op .
        "//-->\n" .
        "</SCRIPT>\n";
  }

  return array($titulo,$p,$linhas,$linhas2);
  
}
// vim:et:sw=2:ts=2:nowrap
