<?php
/**
 * Cria Planilhas Excel - mapa dos perfis
 *
 * @author Gonalo Franco
 * @version $Id$
 */

// Salva e desabilita nivel de erro 
$nivelerro = error_reporting(0);

require_once("Spreadsheet/Excel/Writer.php");

$db = nwx_db::conexao();

// Le o ciclo atual para subtitulo

// Pega os dados de tabela na sessao
if (isset($_SESSION['nwx_etc']['relat'])) {
  $lin = $_SESSION['nwx_etc']['relat'];
} else
  $lin = array();

//echo "<pre>";
//print_r($lin);
//echo "</pre>";
//exit;

$titulo = "Titulo";
$exp = '';

// Prepara os titulos, cabecalhos, etc
$cbec = array();
$titulo =  _("Mapa de Acessos por Perfil");

$cbec[] = _("Funes");

$rs = $db->execute("select codigo,nome from v_nw_grupos where tipo = 'G' 
                       and codigo is not null 
                       and codigo <> 'ANON' 
                     order by codigo");
$tcol = 0;
while (!$rs->EOF) {
  $cbec[] = $rs->fields['codigo'];
  $rs->MoveNext();  
  ++$tcol;
}

// Cria planilha e preenche com os dados

$xls =& new Spreadsheet_Excel_Writer();
$xls->send("planilha.xls");
$wrk =& $xls->addWorksheet(_("Planilha"));
$wrk->setPaper(9);
$wrk->setLandscape();

// Cria os formatos a utilizar
$fmt1 =& $xls->addFormat(array('Size' => 12) );
$fmt1->setBold();

$fmt2 =& $xls->addFormat(array('Size' => 8,
                               'FgColor' => 31,
                               'Bold' => 1,
                               'Align' => 'center'
                               ) );
$fmt2->setTextWrap();
$fmt2->setBorder(1);
$fmt2->setBorderColor('silver');
$fmt2->setAlign('vcenter');

$fmt2a =& $xls->addFormat(array('Size' => 8,
                               'FgColor' => 26,
                               'Bold' => 0,
                               'Align' => 'left'
                               ) );
$fmt2a->setTextWrap();
$fmt2a->setBorder(1);
$fmt2a->setBorderColor('silver');

$fmt2b =& $xls->addFormat(array('Size' => 8,
                               'Bold' => 0,
                               'Align' => 'right'
                               ) );
$fmt2b->setTextWrap();
$fmt2b->setBorder(1);
$fmt2b->setBorderColor('silver');

$fmt2c =& $xls->addFormat(array('Size' => 8,
                               'FgColor' => 27,
                               'Bold' => 0,
                               'Align' => 'left'
                               ) );
$fmt2c->setTextWrap();
$fmt2c->setBorder(1);
$fmt2c->setBorderColor('silver');

$fmt2e =& $xls->addFormat(array('Size' => 8,
                               'FgColor' => 27,
                               'Bold' => 0,
                               'Align' => 'right'
                               ) );
$fmt2e->setTextWrap();
$fmt2e->setBorder(1);
$fmt2e->setBorderColor('silver');

$fmt2f =& $xls->addFormat(array('Size' => 8,
                               'FgColor' => 27,
                               'Bold' => 0,
                               'Align' => 'left'
                               ) );
$fmt2f->setBorder(1);
$fmt2f->setBorderColor('silver');


$fmt2d =& $xls->addFormat(array('Size' => 8,
                               'FgColor' => 42,
                               'Bold' => 1,
                               'Align' => 'left'
                               ) );
$fmt2d->setTextWrap();
$fmt2d->setBorder(1);
$fmt2d->setBorderColor('silver');

$fmt3 =& $xls->addFormat(array('Size' => 8,
                               'Bold' => 1,
                               'Align' => 'left'
                               ) );

// Escreve o titulo e subtitulo
$wrk->write(0,0,$titulo,$fmt1);
$wrk->write(1,0,$subtitulo,$fmt3);

// Linha de cabecalho
$i = 0;
foreach ($cbec as $c) {
  if ($i == 0) {
    $wrk->setColumn($i,$i,50);
  } else {
    $wrk->setColumn($i,$i,12);
  }
  $wrk->write(3,$i,$c,$fmt2);
  ++$i;
}


$j = 4;
    
// Monta as linhas da planilha

// Percorre as linhas
foreach ($lin as $ln) {

  // Calcula o recuo da primeira coluna
  $s = ""; 
  for ($i = 0; $i < $ln[1]; ++$i) {
    $s .= "    ";
  }
  
  // Formata e envia as colunas
  if ($ln[4]) { 
    $f = $fmt2a;  
  } else {
    $f = $fmt2c;  
  }
  $wrk->setColumn(0,0,50);
  $wrk->write($j,0,$s.$ln[0],$f);
  $k = 1;
  for ($i = 0; $i < $tcol; ++$i) {
    if ($ln[4]) {
      $c = $ln[5+$i]; 
    } else {
      $c = '';
    }
    $wrk->write($j,$k,$c,$f);
    ++$k;
  }
  ++$j;

}

$xls->close();

// Volta nivel de erro
error_reporting($nivelerro);
// vim:et:sw=2:ts=2:nowrap
