<?php
/**
 * Manutencao da tabela de jobs
 *
 * @author Gonalo Franco
 * @version $Id: nw_jobs.php 884 2006-12-09 14:56:22Z goncalo $
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_form.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_grid.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_time.php");

/**
 * Formulario para Alteracao,Inclusao e Exclusao de grupos
 */
class nw_jobs_form extends nwx_form {

  /**
   * Carrega dados do BD nos campos do formulario
   */
  function carrega() {

    if ($this->oper == 'Incluir')
      return null;
    $stmt = "select * from nw_jobs where id_job = ?";
    $db = nwx_db::conexao();
    if ($this->inicio()) {
      $rs = $db->execute($stmt, array($this->id[0]));
      if (!$rs->EOF) {
        $this->valor('id_job',$rs->fields['id_job']);
        $this->valor('comando',$rs->fields['comando']);
        $this->valor('descricao',$rs->fields['descricao']);
        $this->valor('stat',$rs->fields['stat']);
        $this->valor('prx',$rs->fields['prx']);
        $this->valor('interv',$rs->fields['interv']);
        $this->valor('unid',$rs->fields['unid']);
      }
    }
  }

  /**
   * Carrega dados do BD nos campos do formulario
   */
  function prepara() {

    $oper = $this->oper;
    $que = $this->id[0];
    $sta = nwx_qsta('nw_jobs');
    
    $ico = '';
    $prm = nwx_qval($this->bloco);
    $ico = nwx_qico($this->bloco);
    $ico = $ico ? "&ico=$ico" : '';

    if ($oper == 'Historico') {
      $this->reset_opr();
      header("Location: " . NWX_RDX . NWX_APL . "/" . NWX_IDX . "?blc=nw_jobs_log&p=$que&col=1&seq=10&sta=$sta{$ico}");
    }

    return true;

  }

  
  /**
   * Processamento do formulario
   */
  function processa($_sair) {

    $db = nwx_db::conexao();

    $data = $this->post('prx');
    //$novo = nwx_time::data_unix($data); 
    //$unid = $this->post('unid');
    //$intrv = $this->post('interv');
    //if ($unid == 'S') {
    //  $delta = $intrv;
    //} elseif ($unid == 'M') {
    //  $delta = $intrv * 60;
    //} elseif ($unid == 'H') {
    //  $delta = $intrv * 3600;
    //}
    //$novo = $novo + $delta;
    //$nova_data = nwx_time::data_iso($novo);
    $nova_data = nwx_time::data_iso($data);
    if ($this->oper == 'Alterar') {
      $stm = "update nw_jobs set descricao = ?,comando = ?,prx = ?,interv = ?,unid = ?,stat = ? where id_job = ?";
      $p = array($this->post('descricao')
                ,$this->post('comando')
                ,$nova_data
                ,$this->post('interv')
                ,$this->post('unid')
                ,($this->post('stat') ? 1 : 0)
                ,$this->id[0]
      );
      $this->sair = $_sair;
    } elseif ($this->oper == 'Incluir') {
      $stm = "insert into nw_jobs values(?,?,?,?,?,?,?)";
      $p = array($db->GenID('nw_jobs_seq')
                ,$this->post('descricao')
                ,$this->post('comando')
                ,$nova_data
                ,$this->post('interv')
                ,$this->post('unid')
                ,($this->post('stat') ? 1 : 0)
      );
      $this->sair = false;
    } elseif ($this->oper == 'Excluir') {
      $stm = "delete from nw_jobs where id_job = ?";
      $p = array($this->id[0]);
      $this->sair = true;
    } else {
      $this->sair = false;
      return;
    }

    // Processamento final no Banco de Dados
    // Se houver erro mostra mensagem do Banco na area de mensagens
    nwx_db::begin_trans();
    if (!$db->execute($stm, $p)) {
      $this->sair = false;
      $this->erro(nwx_db::erro());
      nwx_db::fail_trans();
    } else {
      nwx_repaginar();
    }
    nwx_db::audita($this->oper, $this->bloco, $p);
    nwx_db::end_trans();
  }

} // class nw_jobs_form

/**
 * Cria o quadro que contem o grid de manutencao
 */
class nw_jobs extends nwx_quadro {

  /**
   * Construtor: ajusta o titulo e tipo
   */
  function __construct($id) {
    
    textdomain('nwx');
    parent::__construct($id);
    $this->titulo = _("Tarefas");
    $this->fixo = 0;

  }

  /**
   * Monta o conteudo do quadro
   */
  function monta() {

    // Objeto grid
    $grid = new nwx_grid($this,"select * from nw_jobs",'','descricao');

    // Prepara os campos de filtro ou busca (campo, nome a mostrar, tipo)
    $grid->filtro = array(array('descricao', _('Descrio'), 'C'),
                          array('comando',   _('Comando'), 'C')
                         );

    // Colunas do grid (campo,label,largura,alinhamento,tipo,formato)
    $grid->colunas = array(array('descricao', _('Descrio'), '50%','E','C',''),
                           array('comando',   _('Comando'),   '25%','E','C',''),
                           array('prx',       _('Execuo'),  '20%','E','D','%d/%m/%Y %H:%M'),
                           array('stat',      _('Ativo'),     '5%','c','C',array('-','S'))
                          );

    // Nome da coluna que identifica a linha
    $grid->pk = array('id_job');

    // Numero de linhas por pagina
    $grid->linhas(10,18);

    // Cria o formulario para processamento do registros
    $form = new nw_jobs_form("nw_jobs_form","nw_jobs");

    // Guarda o nome do grid internamente no formulario
    $form->grid = $grid->nome;

    // Cria os campos do formulario e sua representacao
    //$f1 = new nw_form_text('id','N',5,0,false,true);
    $f1 = new nwx_form_text('descricao','C',100,0,false,false);
    $f2 = new nwx_form_text('comando','C',100,0,false,false);
    $f3 = new nwx_form_check('stat','N',10,0,true,false);
    $f4 = new nwx_form_text('interv','N',10,0,false,false);
    $f5 = new nwx_form_lista('unid','C',1,0,true,false);
    $f6 = new nwx_form_text('prx','T',10,0,false,false);

    $f5->opcoes = array('S' => _('Segundos'), 'M' => _('Minutos'), 'H' => _('Horas'));
    
    $form->input($f1,_('Descrio'),'','size="50"',true);
    $form->input($f2,_('Comando'),'','size="80"',true);
    $form->input($f6,_('Execuo (dia e/ou hora)'),'','',false);
    $form->input($f4,_('Intervalo'),'','',false);
    $form->input($f5,_('Unidade'),'','size="1"',true);
    $form->input($f3,_('Ativo'),'','',false);

    // Cria os botoes para funcoes do grid
    // Array indexado pelo label do botao, contendo :
    // (nome da funcao p/ form, o form, se campos read-only, se reg.novo)
    $grid->oper = array('Incluir' => array(_('Incluir'),$form,false,true),
                        'Alterar' => array(_('Alterar'),$form,false,false),
                        'Historico' => array(_('Histrico'),$form,false,false),
                        'Excluir' => array(_('Excluir'),$form,true,false)
                       );

    // Mostra o grid na pagina
    $grid->mostra($this);
  }

}
// vim:et:sw=2:ts=2:nowrap
