<?php
/**
 * Consulta logs de execuao de tarefas
 *
 * @author Gonalo Franco
 * @version $Id: nw_jobs_log.php 884 2006-12-09 14:56:22Z goncalo $
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_form.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_grid.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_time.php");

/**
 * Formulario para Alteracao,Inclusao e Exclusao
 */
class nw_jobs_log_frm extends nwx_form {

  /**
   * Carrega dados do BD nos campos do formulario
   */
  function carrega() {

    $prm = nwx_qval($this->bloco);
    $pai = $prm['p'];
    $stmt = "select * from nw_jobs_log where id_job = ? and id_log = ?";
    $DB = nwx_db::conexao();
    if ($this->inicio()) {
      $rs = $DB->execute($stmt, array($pai, $this->id[0]));
      if (!$rs->EOF) {
        $this->valor('id_job',$rs->fields['id_job']);
        $this->valor('id_log',$rs->fields['id_log']);
        $this->valor('msg',$rs->fields['msg']);
      }
    }
  }

  /**
   * Processamento do formulario
   */
  function processa($_sair) {

    nwx_repaginar();

  }

} // class nw_jobs_log_frm


/**
 * Cria o quadro que contem o grid de manutencao
 */
class nw_jobs_log extends nwx_quadro {

  /**
   * Construtor: ajusta o titulo e tipo
   */
  function __construct($id) {
    
    textdomain('nwx');
    parent::__construct($id);
    $this->titulo = _("Histrico de execuo");
    $this->fixo = 0;

  } //__construct

  /**
   * Monta o conteudo do quadro
   */
  function monta() {

    $prm = nwx_qval('nw_jobs_log');
    $pai = $prm['p'];
 
    // Objeto grid
    $grid = new nwx_grid($this,"select * from nw_jobs_log","id_job = $pai","id_log");

    // Prepara os campos de filtro ou busca (campo, nome a mostrar, tipo)
    $grid->filtro = array(array('msg', _('Mensagem'), 'C')
                         );

    // Colunas do grid (campo,label,largura,alinhamento,tipo,formato)
    $grid->colunas = array(array('msg', _('Mensagem'), '100%','E','C','')
                          );

    // Nome da coluna que identifica a linha
    $grid->pk = array('id_log');

    // Ordem descendente
    $grid->descend();
    
    // Numero de linhas por pagina
    $grid->linhas(10,18);

    // Cria o formulario para processamento do registros
    $form = new nw_jobs_log_frm("nw_jobs_log_frm","nw_jobs_log");

    // Guarda o nome do grid internamente no formulario
    $form->grid = $grid->nome;

    // Cria os campos do formulario e sua representacao
    $f1 = new nwx_form_text('msg','C',200,0,false,false);

    $form->input($f1,_('Mensagem'),'','size="100"',true);

    $db = nwx_db::conexao();
    $rs = $db->execute('select descricao from nw_jobs where id_job = ' . $pai);
    if (!$rs->EOF) {
      $grid->mensagem = _('Comando').' :&nbsp;' . $rs->fields['descricao'];
      $form->mensagem = _('Comando').' :&nbsp;' . $rs->fields['descricao'];
    }
    $rs->close();
    
    // Cria os botoes para funcoes do grid
    // Array indexado pelo label do botao, contendo :
    // (nome da funcao p/ form, o form, se campos read-only, se reg.novo)
    $grid->oper = array('Consultar' => array(_('Consultar'),$form,true,false)
                       );

    // Mostra o grid na pagina
    $grid->mostra($this);

  }

} // class nw_jobs_log
// vim:et:sw=2:ts=2:nowrap