<?php
/**
 * Criaao de menus e submenus
 *
 * @author Gonalo Franco
 * @version $Id: nw_menu.php 883 2006-12-08 17:37:50Z goncalo $
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "TreeMenu.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_acesso.php");

/**
 * Define o quadro para o menu
 */
class nw_menu extends nwx_quadro {

  /**
   * Monta os menus recursivamente
   */
  function monta_sub($tab, &$pai) {

    $nicon = 'folder.gif';
    $nicon2 = 'page.gif';
    $xicon = 'folder-expanded.gif';

    // Se tem o menu em cache, usa-lo para nao acessar banco de dados
    if (isset($_SESSION['nwx_cache'][NWX_SIS]['mnu'])) {
      foreach ($_SESSION['nwx_cache'][NWX_SIS]['mnu'] as $reg) {
        if ($reg['pai'] == $tab) {
          $id = $reg['id'];
          $txt = ' '._($reg['texto']);
          $blc = $reg['bloco'];
          $des = $reg['destino'];
          $tgt = $reg['targ'];
          $cln = $reg['cln'];
          $seq = $reg['seq'];
          $sta = $reg['sta'];
          $hlp = $reg['descricao'] ? htmlentities(_($reg['descricao'])) : '';
          if ($des == '' && $blc == '')
            $ico = empty($reg['img']) ? $nicon : $reg['img'];
          else
            $ico = empty($reg['img']) ? $nicon2 : $reg['img'];
          $icox = empty($reg['imgx']) ? $xicon : $reg['imgx'];
          if ($des) {
            $node = $pai->addItem(new HTML_TreeNode(array('text' => $txt, 'link' => $des, 'linkTarget' => $tgt, 'icon' => $ico, 'expandedIcon' => $icox, 'tooltip' => $hlp, 'bloco' => $blc)));
          } else if ($blc && nwx_acesso::bloco($blc)) {
            $node = $pai->addItem(new HTML_TreeNode(array('text' => $txt, 'link' => NWX_RDX . NWX_APL . '/index.php?blc='.$blc.'&col='.$cln.'&seq='.$seq.'&sta='.$sta.'&ico='.$ico,'icon' => $ico, 'expandedIcon' => $icox, 'tooltip' => $hlp, 'bloco' => $blc)));
          } else {
            if (!$blc) { 
              $node = $pai->addItem(new HTML_TreeNode(array('text' => $txt, 'icon' => $ico, 'expandedIcon' => $icox, 'tooltip' => $hlp)));
            } else {
              continue;
            }
          }
          $this->monta_sub($id, $node);
        }
      }
      return;
    }    
    
    // Menu nao esta em cache: Le do banco de dados
    $db = nwx_db::conexao();
    $st = "select * from nw_mnu where aplic = ? and pai = ? order by ordem,id";
    $rs = $db->execute($st, array(NWX_SIS, $tab));
    while ($reg = $rs->fetchrow()) {
      if ($reg['modulo'] == '1') continue;
      $id = $reg['id'];
      $txt = ' '._($reg['texto']);
      $blc = $reg['bloco'];
      $des = $reg['destino'];
      $tgt = $reg['targ'];
      $cln = $reg['cln'];
      $seq = $reg['seq'];
      $sta = $reg['sta'];
      $hlp = $reg['descricao'] ? htmlentities(_($reg['descricao'])) : '';
      if ($des == '' && $blc == '')
        $ico = empty($reg['img']) ? $nicon : $reg['img'];
      else
        $ico = empty($reg['img']) ? $nicon2 : $reg['img'];
      $icox = empty($reg['imgx']) ? $xicon : $reg['imgx'];

      if ($des) {
        $node = $pai->addItem(new HTML_TreeNode(array('text' => $txt, 'link' => $des, 'linkTarget' => $tgt, 'icon' => $ico, 'expandedIcon' => $icox, 'tooltip' => $hlp, 'bloco' => $blc)));
      } else if ($blc && nwx_acesso::bloco($blc)) {
        $node = $pai->addItem(new HTML_TreeNode(array('text' => $txt, 'link' => NWX_RDX . NWX_APL . '/index.php?blc='.$blc.'&col='.$cln.'&seq='.$seq.'&sta='.$sta.'&ico='.$ico,'icon' => $ico, 'expandedIcon' => $icox, 'tooltip' => $hlp, 'bloco' => $blc)));
      } else {
        if (!$blc) { 
          $node = $pai->addItem(new HTML_TreeNode(array('text' => $txt, 'icon' => $ico, 'expandedIcon' => $icox, 'tooltip' => $hlp)));
        } else {
          continue;
        }
      }

      $this->monta_sub($id, $node);
    }

  }

  /**
   * Monta o menu Javascript com tabela nw_mnu
   */
  function monta_menu($tab) {

    $nicon = 'folder.gif';
    $nicon2 = 'page.gif';
    $xicon = 'folder-expanded.gif';
    $menu = new HTML_TreeMenu();
    $n = 0;

    // Se tem o menu em cache, usa-lo para nao acessar banco de dados
    if (isset($_SESSION['nwx_cache'][NWX_SIS]['mnu'])) {
      foreach ($_SESSION['nwx_cache'][NWX_SIS]['mnu'] as $reg) {
        if ($reg['pai'] == $tab) {
          $id = $reg['id'];
          $txt = ' '._($reg['texto']);
          $blc = $reg['bloco'];
          $des = $reg['destino'];
          $cln = $reg['cln'];
          $sta = $reg['sta'];
          $seq = $reg['seq'];
          $hlp = $reg['descricao'] ? htmlentities(_($reg['descricao'])) : '';
          if ($des == '' && $blc == '')
            $ico = empty($reg['img']) ? $nicon : $reg['img'];
          else
            $ico = empty($reg['img']) ? $nicon2 : $reg['img'];
          $icox = empty($reg['imgx']) ? $xicon : $reg['imgx'];
          $node = 'node'.$n;
          if ($des) {
            $$node = new HTML_TreeNode(array('text' => $txt, 'link' => $des,'icon' => $ico, 'expandedIcon' => $icox, 'tooltip' => $hlp, 'bloco' => $blc));
          } else if ($blc && nwx_acesso::bloco($blc)) {
            $$node = new HTML_TreeNode(array('text' => $txt, 'link' => NWX_RDX . NWX_APL . '/index.php?blc='.$blc.'&col='.$cln.'&seq='.$seq.'&sta='.$sta.'&ico='.$ico,'icon' => $ico, 'expandedIcon' => $icox, 'tooltip' => $hlp, 'bloco' => $blc));
          } else {
            if (!$blc) { 
              $$node = new HTML_TreeNode(array('text' => $txt, 'icon' => $ico, 'expandedIcon' => $icox, 'tooltip' => $hlp));
            } else {
              continue;
            }
          }
          $this->monta_sub($id, $$node);
          $menu->addItem($$node);
          ++$n;
        }
      }
      $treeMenu = new HTML_TreeMenu_DHTML($menu, array('images' => '/nwx/img', 'defaultClass' => 't0i','usePersistence' => true));
      return $treeMenu;
    }
    
    // Menu nao esta em cache: Le do banco de dados
    $db = nwx_db::conexao();
    $st = "select * from nw_mnu where aplic = ? and pai = ? order by ordem,id";
    $rs = $db->execute($st, array(NWX_SIS, $tab));
    $n = 0;
    while ($reg = $rs->fetchrow()) {
      if ($reg['modulo'] == '1') continue;
      $id = $reg['id'];
      $txt = ' '._($reg['texto']);
      $blc = $reg['bloco'];
      $des = $reg['destino'];
      $cln = $reg['cln'];
      $sta = $reg['sta'];
      $seq = $reg['seq'];
      $hlp = $reg['descricao'] ? htmlentities(_($reg['descricao'])) : '';
      if ($des == '' && $blc == '')
        $ico = empty($reg['img']) ? $nicon : $reg['img'];
      else
        $ico = empty($reg['img']) ? $nicon2 : $reg['img'];
      $icox = empty($reg['imgx']) ? $xicon : $reg['imgx'];
      $node = 'node'.$n;
      if ($des) {
        $$node = new HTML_TreeNode(array('text' => $txt, 'link' => $des,'icon' => $ico, 'expandedIcon' => $icox, 'tooltip' => $hlp, 'bloco' => $blc));
      } else if ($blc && nwx_acesso::bloco($blc)) {
        $$node = new HTML_TreeNode(array('text' => $txt, 'link' => NWX_RDX . NWX_APL . '/index.php?blc='.$blc.'&col='.$cln.'&seq='.$seq.'&sta='.$sta.'&ico='.$ico,'icon' => $ico, 'expandedIcon' => $icox, 'tooltip' => $hlp, 'bloco' => $blc));
      } else {
        if (!$blc) { 
          $$node = new HTML_TreeNode(array('text' => $txt, 'icon' => $ico, 'expandedIcon' => $icox, 'tooltip' => $hlp));
        } else {
          continue;
        }
      }

      $this->monta_sub($id, $$node);
      $menu->addItem($$node);
      ++$n;
    }

  $treeMenu = new HTML_TreeMenu_DHTML($menu, array('images' => '/nwx/img', 'defaultClass' => 't0i','usePersistence' => true));
  return $treeMenu;

  }

  /**
   * Retira os nodos sem filhos
   */
  function trim_menu(&$nodo) {

    foreach ($nodo->items as $k => $n) {
      if (empty($n->link) && (!is_array($n->items) || count($n->items) == 0))
        unset($nodo->items[$k]);
      elseif (empty($n->link))
        $this->trim_menu($nodo->items[$k]);
    }
    foreach ($nodo->items as $k => $n) {
      if (empty($n->link) && (!is_array($n->items) || count($n->items) == 0))
        unset($nodo->items[$k]);
    }

  }

  /**
   * Cria objeto HTML_TreeMenu (PEAR) e mostra no quadro
   */
  function monta() {

    $dom = textdomain(null);
    textdomain(NWX_SIS);
    $tm = $this->monta_menu($_SESSION[NWX_SIS . '_tab']);
    textdomain($dom);

    if (is_array($tm->menu->items)) {
      foreach ($tm->menu->items as $k => $n) {
        if (empty($n->link) && (!is_array($n->items) || count($n->items) == 0))
          unset($tm->menu->items[$k]);
        elseif (empty($n->link))
          $this->trim_menu($tm->menu->items[$k]);
      }
      foreach ($tm->menu->items as $k => $n)
        if (empty($n->link) && (!is_array($n->items) || count($n->items) == 0))
          unset($tm->menu->items[$k]);
    }
    echo "<table width=\"100%\" cellspacing=\"0\"><tr><td class=\"form-cabec\">";
    $dom = textdomain(null);
    textdomain('nwx');
    echo _("Opes");
    textdomain($dom);
    echo "</td></tr></table>";
    echo "<div style=\"margin:4px\">";
    echo $tm->toHTML($_SESSION[NWX_SIS . '_tab']);
    echo "</div>";

  }

}
// vim:et:sw=2:ts=2:nowrap