<?php
/**
 * Alteracao do perfil pelo usuario
 *
 * @author Gonalo Franco
 * @version $Id$
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_form.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");

/**
 * Define formulario para alteracao do perfil
 *
 */
class nw_perfil_form extends nwx_form {

	function carrega() {
		if ($this->oper == 'INS')
			return null;
		$stmt = "select * from nw_usr where usr = ?";
		$db = nwx_db::conexao();
		if ($this->inicio()) {
			$rs = $db->execute($stmt, array($_SESSION['nwx_usr']));
			if (!$rs->EOF) {
				$this->valor('usr',$rs->fields['usr']);
				$this->valor('nome',$rs->fields['nome']);
				$this->valor('email',$rs->fields['email']);
			}
		}
	}

	function processa($_sair) {

		$db = nwx_db::conexao();
		if ($this->oper == 'ALT') {
			$stm = "update nw_usr set nome = ?,email = ? where usr = ?";
			$p = array($this->post('nome')
								,$this->post('email')
								,$_SESSION['nwx_usr']
			);
			$this->sair = $_sair;
		} else {
			$this->sair = true;
			return;
		}

		nwx_db::begin_trans();
		if (!$db->execute($stm, $p)) {
			$this->sair = false;
			$this->erro(nwx_db::erro());
			nwx_db::fail_trans();
		} else {
			$_SESSION['nwx_nom'] = $this->post('nome');
			nwx_repaginar();
		}
		nwx_db::audita("Alterar", $this->bloco, $p);
		nwx_db::end_trans();

	}

}

/**
 * Define quadro contendo formulario de perfil
 *
 * @author Goncalo Franco
 */
class nw_perfil extends nwx_quadro {

	/**
	 * Construtor: ajusta o titulo e tipo
	 */
	function __construct($id) {
		
		textdomain('nwx');
		parent::__construct($id);
		$this->titulo = _("Seu Cadastro");
		$this->fixo = 0;

	} 
	
	function monta() {
		
		$form = new nw_perfil_form("nw_perfil","nw_perfil");
		
		$db = nwx_db::conexao();
		$ru = $db->execute("select usr from nw_usr where usr = ?", array($_SESSION['nwx_usr'])); 
		if ($ru->EOF) {
			$form->cabec = _('Usurio no cadastrado');
			$c1 = new nwx_form_cabec(_('Sua identificao de usurio no existe no sistema'));
			$form->input($c1);
			$form->mostra();
			return;
		}
		
		$form->oper = 'ALT';
		$f1 = new nwx_form_text('usr','C',20,0,false,true);
		$f2 = new nwx_form_text('nome','C',100,0,false,false);
		$f9 = new nwx_form_text('email','EMAIL',50,'',true,false);
		$form->cabec = _('Altere seus dados pessoais');
		$form->input($f1,_('Codigo'),'','size="10"',true);
		$form->input($f2,_('Nome'),'','size="80"',true);
		$form->input($f9,_('E-Mail'),'','size="50"',false);
		$form->mostra();
	
	}

}
// vim:et:sw=2:ts=2:nowrap
