<?php
/**
 * Manutencao da tabela de paginas
 *
 * @author Gonalo Franco
 * @version $Id: nw_pgn.php 904 2006-12-22 21:20:07Z goncalo $
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_form.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_grid.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_time.php");

/**
 * Formulario para Alteracao,Inclusao e Exclusao de grupos
 */
class nw_pgn_form extends nwx_form {

  /**
   * Carrega dados do BD nos campos do formulario
   */
  function carrega() {

    if ($this->oper == 'Incluir')
      return null;
    $stmt = "select * from nw_mnu where aplic = ? and id = ?";
    $db = nwx_db::conexao();
    if ($this->inicio()) {
      $rs = $db->execute($stmt, array(NWX_SIS, $this->id[0]));
      if (!$rs->EOF) {
        $this->valor('id',$rs->fields['id']);
        $this->valor('texto',$rs->fields['texto']);
        $this->valor('descricao',$rs->fields['descricao']);
        $this->valor('col0',$rs->fields['col0']);
        $this->valor('col1',$rs->fields['col1']);
        $this->valor('col2',$rs->fields['col2']);
        $this->valor('col3',$rs->fields['col3']);
        $this->valor('col4',$rs->fields['col4']);
        $this->valor('ordem',$rs->fields['ordem']);
        $this->valor('modulo',$rs->fields['modulo']);
      }
    }
  }

  /**
   * Chamado ao pressionao botao no grid
   */
  function prepara() {

    $oper = $this->oper;
    $id = $this->id[0];

    $ico = nwx_qico('nw_pgn');
    $sta = nwx_qsta('nw_pgn');
    if ($ico) {
      $ico = "&ico=$ico";
    } 
    
    if ($oper == 'Menus') {
      $this->reset_opr();
      header("Location: " . NWX_RDX . NWX_LOC ."?blc=nw_pgn_mnu&p=$id&col=1&seq=10&sta=$sta{$ico}");
    }
    
    return true;
    
  }
  
  /**
   * Processamento do formulario
   */
  function processa($_sair) {

    $db = nwx_db::conexao();
    if ($this->oper == 'Alterar') {
      $stm = "update nw_mnu set texto = ?,descricao = ?,modulo=?,ordem = ?,col0 = ?,col1 = ?,col2 = ?,col3 = ?,col4 = ? 
               where aplic = ? and id = ?";
      $p = array($this->post('texto')
                ,$this->post('descricao')
                ,$this->post('modulo') ? '1' : null
                ,$this->post('ordem')
                ,$this->post('col0')
                ,$this->post('col1')
                ,$this->post('col2')
                ,$this->post('col3')
                ,$this->post('col4')
                ,NWX_SIS
                ,$this->id[0]
                );
      $this->sair = $_sair;
    }
    elseif ($this->oper == 'Incluir') {
      $stm = "insert into nw_mnu(aplic,id,texto,descricao,modulo,ordem,col0,col1,col2,col3,col4) values(?,?,?,?,?,?,?,?,?,?,?)";
      $p = array(NWX_SIS
                ,$db->GenId('nw_mnu_seq')
                ,$this->post('texto')
                ,$this->post('descricao')
                ,$this->post('modulo') ? '1' : null
                ,$this->post('ordem')
                ,$this->post('col0')
                ,$this->post('col1')
                ,$this->post('col2')
                ,$this->post('col3')
                ,$this->post('col4')
                );
      $this->sair = false;
    }
    elseif ($this->oper == 'Excluir') {
      $stm = "delete from nw_mnu where aplic = ? and id = ?";
      $p = array(NWX_SIS, $this->id[0]);
      $this->sair = true;
    } else {
      $this->sair = false;
      return;
    }

    // Processamento final no Banco de Dados
    // Se houver erro mostra mensagem do Banco na area de mensagens
    nwx_db::begin_trans();
    if (!$db->execute($stm, $p)) {
      $this->sair = false;
      $this->erro(nwx_db::erro());
      nwx_db::fail_trans();
    } else {
      nwx_repaginar();
    }
    nwx_db::audita($this->oper, $this->bloco, $p);
    nwx_db::end_trans();
  }

}

/**
 * Cria o quadro que contem o grid de manutencao
 */
class nw_pgn extends nwx_quadro {

  /**
   * Construtor: ajusta o titulo e tipo
   */
  function __construct($id) {
    
    textdomain('nwx');
    parent::__construct($id);
    $this->titulo = _("Pginas");
    $this->fixo = 0;

  } //__construct

  /**
   * Monta o conteudo do quadro
   */
  function monta() {

    // Objeto grid
    $grid = new nwx_grid($this,"select * from nw_mnu","pai is null and aplic = '" . NWX_SIS ."'",'ordem');

    // Prepara os campos de filtro ou busca (campo, nome a mostrar, tipo)
    $grid->filtro = array(array('ordem',     _('Ordem'), 'N'),
                          array('texto',     _('Texto'), 'C'),
                          array('descricao', _('Descrio'), 'C')
                         );

    // Colunas do grid (campo,label,largura,alinhamento,tipo,formato)
    $grid->colunas = array(array('ordem',     _('Ordem'),     '10%','E','N',''),
                           array('texto',     _('Texto'),     '20%','E','C',''),
                           array('descricao', _('Descrio'), '70%','E','C','')
                          );

    // Nome da coluna que identifica a linha
    $grid->pk = array('id');

    // Numero de linhas por pagina
    $grid->linhas(10,18);

    // Cria o formulario para processamento do registros
    $form = new nw_pgn_form("nw_pgn_form","nw_pgn");

    // Guarda o nome do grid internamente no formulario
    $form->grid = $grid->nome;

    // Cria os campos do formulario e sua representacao
    $f1 = new nwx_form_text('ordem','N',5,0,false,false);
    $f2 = new nwx_form_text('texto','C',200,0,false,false);
    $f3 = new nwx_form_text('descricao','C',200,0,false,false);
    $f4 = new nwx_form_check('modulo','C',100,0,true,false);
    $f5 = new nwx_form_text('col0','C',100,0,true,false);
    $f6 = new nwx_form_text('col1','C',100,0,true,false);
    $f7 = new nwx_form_text('col2','C',100,0,true,false);
    $f8 = new nwx_form_text('col3','C',100,0,true,false);
    $f9 = new nwx_form_text('col4','C',100,0,true,false);
    
    $f1->ajuda = _('Numero de ordem da pgina (Qualquer nmero apenas para ordenao)');
    $f2->ajuda = _('Texto na etiqueta da pgina (Obrigatrio)');
    $f3->ajuda = _('Texto descritivo da pgina (Obrigatrio)');
    $f4->ajuda = _('Pgina no aparece para nenhum usurio');
    $f9->ajuda = _('Definio de layout das colunas (Opcional)');

    $c1 = new nwx_form_cabec(_('Informaes sobre a pgina'));
    $c2 = new nwx_form_cabec(_('Lay-out das colunas'));
    
    $form->tab("tab1",_("Detalhes"));
    $form->tab("tab2",_("Layout"));
    
    $form->input($f1,_('Ordem'),'','size="10"',true);
    
    $form->input_tab('tab1',$c1);
    $form->input_tab('tab1',$f2,_('Texto'),'','size="50"',true);
    $form->input_tab('tab1',$f3,_('Descrio'),'','size="80"',true);
    $form->input_tab('tab1',$f4,_('Desativada'),'','',true);
    
    $form->input_tab('tab2',$c2);
    $form->input_tab('tab2',$f5,_('Coluna 1'),'','size="50"',false);
    $form->input_tab('tab2',$f6,_('Coluna 2'),'','size="50"',true);
    $form->input_tab('tab2',$f7,_('Coluna 3'),'','size="50"',false);
    $form->input_tab('tab2',$f8,_('Coluna 4'),'','size="50"',true);
    $form->input_tab('tab2',$f9,_('Coluna 5'),'','size="50"',false);
    
    // Cria os botoes para funcoes do grid
    // Array indexado pelo label do botao, contendo :
    // (nome da funcao p/ form, o form, se campos read-only, se reg.novo)
    $grid->oper = array('Incluir' => array(_('Incluir'),$form,false,true),
                        'Alterar' => array(_('Alterar'),$form,false,false),
                        'Excluir' => array(_('Excluir'),$form,true,false),
                        'Menus' => array(_('Menus'),$form,true,false)
                       );

    // Mostra o grid na pagina
    $grid->mostra($this);
  }

}
// vim:et:sw=2:ts=2:nowrap
