<?php
/**
 * Manutenao da arvore de menus 
 *
 * @author Gonalo Franco
 * @version $Id$
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "TreeMenu.php");

/**
 * Define o quadro para mostrar na tela
 */
class nw_pgn_mnu extends nwx_quadro {

  /**
   * Construtor: ajusta o titulo e tipo
   */
  function __construct($id) {
    
    textdomain('nwx');
    parent::__construct($id);
    $this->titulo = _("Menus da pgina");
    $this->fixo = 0;

  }

  /**
   * Monta a arvore de unidades recursivamente
   */
  function monta_sub($pro, &$pai, $niv = 0) {

    $p = nwx_qval('nw_pgn_mnu',$_SESSION[NWX_SIS . '_tab']);
    if (isset($_SESSION['nwx_etc']['nwx_mv'])) {
      $mv = $_SESSION['nwx_etc']['nwx_mv'];    
    } else {
      $mv = 0;
    }
    $nicon = 'folder.gif';
    $nicon2 = 'page.gif';
    $xicon = 'folder-expanded.gif';
    $s = nwx_qsta('nw_pgn_mnu');
    $ic = nwx_qico('nw_pgn_mnu');
    ++$niv;
    $db = nwx_db::conexao();

    // Le o nivel do menu (tab)
    $st = "select id, texto, img, imgx, bloco from nw_mnu where aplic = ? and pai = ? order by ordem, id";
    $rs = $db->execute($st, array(NWX_SIS, $pro));
    while (!$rs->EOF) {
      $id = $rs->fields['id'];
      $txt = ' '._($rs->fields['texto']);
      $bl = $rs->fields['bloco'];
      $des = NWX_IDX . "?blc=nw_pgn_mnu_det&p=1&i=" . $rs->fields['id'] . "&col=1&seq=10&sta=$s&ico=$ic";
      $tgt = '';
      if ($bl == '') {
        $ico = empty($rs->fields['img']) ? $nicon : $rs->fields['img'];
        $icox = empty($rs->fields['imgx']) ? $xicon : $rs->fields['imgx'];
      } else {
        $ico = empty($rs->fields['img']) ? $nicon2 : $rs->fields['img'];
        $icox = empty($rs->fields['imgx']) ? $ico : $rs->fields['imgx'];
      }
      $node =& $pai->addItem(new HTML_TreeNode(array('text' => $txt, 'link' => $des, 'linkTarget' => $tgt, 'icon' => $ico, 'expandedIcon' => $icox)));
      $this->monta_sub($id, $node, $niv);
      $rs->MoveNext();
    }
    $des = NWX_IDX . "?blc=nw_pgn_mnu_det&p=0&i=$pro&col=1&seq=10&sta=$s&ico=$ic";
    $txt = ' '._('Novo');
    $tgt = '';
    $ico = 'add.gif';
    $icox = 'add.gif';
    $node =& $pai->addItem(new HTML_TreeNode(array('text' => $txt, 'link' => $des, 'linkTarget' => $tgt, 'icon' => $ico, 'expandedIcon' => $icox)));
    // Se tem menu a colar  
    if ($mv && !menu_subordinado($mv, $pro)) {
      $des = NWX_IDX . "?blc=nw_pgn_mnu&p={$p['p']}&mv=$pro.$mv&col=1&seq=10&sta=$s&ico=$ic";
      $txt = ' '._('Colar');
      $tgt = '';
      $ico = 'flexa1.gif';
      $icox = 'flexa1.gif';
      $node =& $pai->addItem(new HTML_TreeNode(array('text' => $txt, 'link' => $des, 'linkTarget' => $tgt, 'icon' => $ico, 'expandedIcon' => $icox)));
    }
  
  }

  /**
   * Monta a arvore de unidades recursivamente
   */
  function monta_menu($pro) {

    $nicon = 'folder.gif';
    $nicon2 = 'page.gif';
    $xicon = 'folder-expanded.gif';
    $menu = new HTML_TreeMenu();

    $db = nwx_db::conexao();

    // Le o nivel do menu (tab)
    $st = "select * from nw_mnu where aplic = ? and id = ?";
    $rs = $db->execute($st, array(NWX_SIS, $pro));
    $n = 0;
    while (!$rs->EOF) {
      $id = $rs->fields['id'];
      $txt = rtrim(' '._($rs->fields['texto']));
      $des = '';
      $ico = 'sfoldrx.gif';
      $icox = 'sfoldrx.gif';
      $node = 'node'.$n;
      $$node = new HTML_TreeNode(array('text' => $txt, 'link' => $des,'icon' => $ico, 'expandedIcon' => $icox));
      $this->monta_sub($id, $$node);
      $menu->addItem($$node);
      $rs->MoveNext();
      ++$n;
    }

  $treeMenu = &new HTML_TreeMenu_DHTML($menu, array('images' => "/nwx/img", 'defaultClass' => 't0i','usePersistence' => true));
  return $treeMenu;

  }

  /**
   * Mostra o quadro na tela
   */
  function monta() {

    $p = nwx_qval('nw_pgn_mnu',$_SESSION[NWX_SIS . '_tab']);
    $pai = $p['p'];
    
    // Le o registro
    $db = nwx_db::conexao();
    
    if (isset($_GET['mv'])) {
      $pr = explode('.',$_GET['mv']);
      if (count($pr) == 2) {
        $db->execute("update nw_mnu set pai = ? where aplic = ? and id = ?", array($pr[0], NWX_SIS, $pr[1]));
        unset($_SESSION['nwx_etc']['nwx_mv']);
      }
    } else if (isset($_GET['cm'])) {
      unset($_SESSION['nwx_etc']['nwx_mv']);
    }
    
    // Monta a arvore de titulos
    $tm = $this->monta_menu($pai);
    
    $rs = $db->execute("select * from nw_mnu where aplic = ? and id = ?", array(NWX_SIS, $pai));
    
    $arvore = $tm->toHTML('nw_pgn_mnu');
    
    echo "<table width=\"100%\" class=\"layout\" cellspacing=\"0\">\n";
    echo "<tr>";
    echo "<td class=\"rel-cabec\">";
    echo _("Manuteno de Menus (Pgina")." {$rs->fields['texto']})";
    echo "</td>";
    echo "<td class=\"rel-control\">";
    echo bt_fechar("nw_pgn_mnu");
    echo "</td></tr>";
    echo "</table>";
    
    echo "<div style=\"margin:4px\">";
    echo $arvore;
    echo "</div>";
    
    echo "<form method=\"post\" name=\"nw_pgn_mnu\">\n";
    echo "<input type=\"hidden\" name=\"nw_opr\" value=\"\">";
    echo "</form>";
    
  }

}
// vim:et:sw=2:ts=2:nowrap
