<?php
/**
 * Manutencao da tabela de menus
 *
 * @author Gonalo Franco
 * @version $Id$
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_form.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");

/**
 * Formulario para Alteracao,Inclusao e Exclusao
 */
class nw_pgn_mnu_det_frm extends nwx_form {

	/**
	 * Carrega dados do BD nos campos do formulario
	 */
	function carrega() {

		$aplic = NWX_SIS;
		if ($this->oper == 'i')
			return null;
		$stmt = "select * from nw_mnu where aplic = ? and id = ?";
		$DB = nwx_db::conexao();
		if ($this->inicio()) {
			$rs = $DB->execute($stmt, array(NWX_SIS, $this->id[0]));
			if (!$rs->EOF) {
				$this->valor('id',$rs->fields['id']);
				$this->valor('texto',$rs->fields['texto']);
				$this->valor('descricao',$rs->fields['descricao']);
				$this->valor('destino',$rs->fields['destino']);
				$this->valor('pai',$rs->fields['pai']);
				$this->valor('bloco',$rs->fields['bloco']);
				$this->valor('cln',$rs->fields['cln']);
				$this->valor('seq',$rs->fields['seq']);
				$this->valor('sta',$rs->fields['sta']);
				$this->valor('targ',$rs->fields['targ']);
				$this->valor('img',$rs->fields['img']);
				$this->valor('imgx',$rs->fields['imgx']);
				$this->valor('ordem',$rs->fields['ordem']);
				$this->valor('modulo',$rs->fields['modulo']);
			}
		}
	}

	/**
	* Verificacao dos campos para confirmacao
	*/
	function verifica() {

		foreach ($this->campos as $campo) {
			$valor = $this->post($campo->id);
			switch ($campo->id) {
				case 'cln':
					if ($valor < 0 || $valor > 4)
						$this->erro(_("Coluna deve estar entre 0 e 4"));
					break;
				case 'seq':
					if ($valor < 0)
						$this->erro(_("Sequencia no pode ser nr. negativo"));
					break;
			}
		}
		
		if ($this->oper != _('Excluir'))
			return;

		// Verifica se existe registro apontando
		$db = nwx_db::conexao();
		$id = $this->id[0];
		
		$st = "select id from nw_mnu where aplic = ? and pai = ?";
		$rs = $db->execute($st, array(NWX_SIS, $id));
		if (!$rs->EOF) {
			$this->erro(_("Excluso Invlida - Item contm sub-itens"));
		}

	}
	
	/**
	 * Processamento do formulario
	 */
	function processa($_sair) {

		$aplic = NWX_SIS;
		$tab = $_SESSION['nwx_tab'];
		$p = nwx_qval('nw_pgn_mnu_det');
		$pai = $p['i'];
		
		$DB = nwx_db::conexao();
		if ($this->oper == 'a') {
			$o = "Alterar Menu";
			$stm = "update nw_mnu set texto = ?,descricao = ?,destino = ?,bloco = ?,cln = ?,seq = ?,sta = ?,targ = ?
						 ,img = ?,imgx = ?,ordem = ?,modulo = ? where aplic = ? and id = ?";
			$p = array($this->post('texto')
								,nwx_db::nulo($this->post('descricao'))
								,nwx_db::nulo($this->post('destino'))
								,nwx_db::nulo($this->post('bloco'))
								,nwx_db::nulo($this->post('cln'))
								,nwx_db::nulo($this->post('seq'))
								,nwx_db::nulo($this->post('sta'))
								,nwx_db::nulo($this->post('targ'))
								,nwx_db::nulo($this->post('img'))
								,nwx_db::nulo($this->post('imgx'))
								,nwx_db::nulo($this->post('ordem'))
                ,$this->post('modulo') ? '1' : null
								,NWX_SIS
								,$this->id[0]
			);
			$this->sair = $_sair;
		}
		elseif ($this->oper == 'i') {
			$o = "Incluir Menu";
			$stm = "insert into nw_mnu(aplic,id,texto,descricao,destino,pai,bloco,cln,seq,sta,targ,img,imgx,ordem,modulo)
								values(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
			$p = array(NWX_SIS
								,$DB->GenID('nw_mnu_seq')
								,$this->post('texto')
								,nwx_db::nulo($this->post('descricao'))
								,nwx_db::nulo($this->post('destino'))
								,$pai
								,nwx_db::nulo($this->post('bloco'))
								,nwx_db::nulo($this->post('cln'))
								,nwx_db::nulo($this->post('seq'))
								,nwx_db::nulo($this->post('sta'))
								,nwx_db::nulo($this->post('targ'))
								,nwx_db::nulo($this->post('img'))
								,nwx_db::nulo($this->post('imgx'))
								,nwx_db::nulo($this->post('ordem'))
                ,$this->post('modulo') ? '1' : null
			);
			$this->sair = true;
		} elseif ($this->oper == _('Excluir')) {
			$o = "Excluir Menu";
			$bloco = $this->post('bloco');
			if ($bloco) {
				$DB->execute("delete from nw_acs where bloco = ?", array($bloco));
				$DB->execute("delete from nw_mnu_mdl where aplic = ? and bloco = ?", array(NWX_SIS, $bloco));
			}
			$stm = "delete from nw_mnu where aplic = ? and id = ?";
			$p = array(NWX_SIS, $this->id[0]);
			$this->sair = true;
		} elseif ($this->oper == _('Copiar')) {
			$_SESSION['nwx_etc']['nwx_mv'] = $this->id[0];    
			$this->sair = true;
			nwx_repaginar();
			return;      
		} else {
			$this->sair = true;
			nwx_repaginar();
			return;      
		}

		// Processamento final no Banco de Dados
		// Se houver erro mostra mensagem do Banco na area de mensagens
		nwx_db::begin_trans();
		if (!$DB->execute($stm, $p)) {
			$this->sair = false;
			$this->erro(nwx_db::erro());
			nwx_db::fail_trans();
		} else {
			nwx_repaginar();
		}
		nwx_db::audita($o, 'nw_pgn', $p);
		nwx_db::end_trans();

	}

}

/**
 * Cria o quadro que contem o grid de manutencao
 */
class nw_pgn_mnu_det extends nwx_quadro {

	/**
	 * Construtor: ajusta o titulo e tipo
	 */
	function __construct($id) {
		
		textdomain('nwx');
		parent::__construct($id);
		$this->titulo = _("Menus da pgina");
		$this->fixo = 0;

	} //__construct

	/**
	 * Monta o conteudo do quadro
	 */
	function monta() {

		unset($_SESSION['nwx_etc']['nwx_mv']);
		
		$tab = $_SESSION[NWX_SIS . '_tab'];
		//$ida = explode('.',$_SESSION['nw_abre'][$tab]['nw_pgn_mnu_det'][3]);
		
		$ida = nwx_qval('nw_pgn_mnu_det');
		
		$db = nwx_db::conexao();

		$id = $ida['i'];
		$id_opr = ($ida['p'] == 1) ? 'a' : 'i';
		
		// Cria o formulario para processamento do registros
		$form = new nw_pgn_mnu_det_frm("nw_pgn_mnu_det","nw_pgn_mnu_det");

		// Cria os campos do formulario e sua representacao
		// Cria os campos do formulario e sua representacao
		$f0 = new nwx_form_text('ordem','N',10,0,true,false);
		$f1 = new nwx_form_text('texto','C',200,0,false,false);
		$f2 = new nwx_form_text('descricao','C',100,0,true,false);
		$f4 = new nwx_form_text('bloco','C',30,0,true,false);
		$f5 = new nwx_form_text('cln','N',9,0,true,false);
		$f6 = new nwx_form_text('seq','N',9,0,true,false);
		$f7 = new nwx_form_lista('sta','N',9,0,true,false);
		$f8 = new nwx_form_text('destino','C',200,0,true,false);
		$f9 = new nwx_form_lista('targ','C',100,0,true,false);
		$f10 = new nwx_form_text('img','C',100,0,true,false);
		$f11 = new nwx_form_text('imgx','C',30,0,true,false);
    $f12 = new nwx_form_check('modulo','C',100,0,true,false);
		$c1 = new nwx_form_cabec(_('Mdulo a ativar'));
		$c2 = new nwx_form_cabec(_('Pgina externa a chamar'));

		$f7->opcoes = array("0" => _("Normal"),
												"1" => _("Minimizado"),
												"2" => _("Maximizado")
											 );
		$f9->opcoes = array(""  => _("Mesma Janela"),
												"_blank" => _("Nova Janela"),
												"_parent" => _("Janela Pai")
												);

		$f1->ajuda = _('Nome do item como aparece no menu (Obrigatrio)');
		$f0->ajuda = _('Numero de ordem do item (Qualquer nmero para ordenao)');
		$f2->ajuda = _('Texto descritivo para mostrar como dica no menu (Opcional)');                    
		$f4->ajuda = _('Nome do mdulo a ativar (Opcional)');
		$f5->ajuda = _('Coluna na pgina em que deve ser mostrado (Comea com zero: 0,1,2,etc.)');
		$f6->ajuda = _('Numero de sequencia do mdulo na coluna (Qualquer numero para ordenao)');
		$f7->ajuda = _('Estado inicial do mdulo');
		$f8->ajuda = _('Endereo de uma pgina externa a chamar (Opcional)');
		$f9->ajuda = _('Destino da pgina chamada em relao  janela atual');
		$f10->ajuda = _('Nome do arquivo de imagem a mostrar no menu (Opcional)');
		$f11->ajuda = _('Nome do arquivo de imagem a mostrar no menu quando o item for expandido (Opcional)'); 
    $f12->ajuda = _('Mdulo no aparece para nenhum usurio');
			
		$form->input($f1,_('Item'),'','size="50"',false);
		$form->input($f0,_('Numero'),'','size="10"',true);
		$form->input($f2,_('Descrio'),'','size="80"',true);
		$form->input($f10,_('Imagem'),'','size="30"',false);
		$form->input($f11,_('Expandida'),'','size="30"',true);
		$form->input($c1);
		$form->input($f4,_('Mdulo'),'','size="30"',false);
		$form->input($f5,_('Coluna'),'','size="9"',false);
		$form->input($f6,_('Sequencia'),'','size="9"',false);
		$form->input($f7,_('Status inicial'),'','size="1"',true);
		$form->input($c2);
		$form->input($f8,_('URL Destino'),'','size="50"',false);
		$form->input($f9,_('Janela'),'','size="1"',false);
    $form->input($f12,_('Desativado'),'','',false);

		if ($id_opr == 'a') {
			$form->id = array($id);
			$form->detalhe(_('Acessos'),'nw_mnu_ace',true);
			$form->detalhe(_('Mdulos'),'nw_mnu_mdl',true);
			$form->detalhe(_('Funes'),'nw_mnu_sub',true);
			$form->detalhe(_('Auditoria'),'nw_mnu_aud',true);
			$form->operacao(_('Excluir'),_('Excluir registro'),_('Confirme excluso'));
			$form->operacao(_('Copiar'),_('Copiar para mover'),'');
		} else {
			$form->salvar = '';
		}
		$form->reset = '';  
		$form->oper = $id_opr;

		$operacao = array('a' => _('(Manuteno)'), 'i' => _('(Incluso)'));
		$form->cabec = _("Item de Menu") . ' ' . $operacao[$id_opr];
		
		$p = nwx_qval('nw_pgn_mnu',$_SESSION[NWX_SIS . '_tab']);
		$pai = $p['p'];
		$rs = $db->execute("select * from nw_mnu where aplic = ? and id = ?", array(NWX_SIS, $pai));
		
		if (!$rs->EOF) {
			$form->mensagem = _("Pgina").": {$rs->fields['texto']}";
		}
		
		// Mostra o formulario
		$form->mostra();
	
	}

}
// vim:et:sw=2:ts=2:nowrap
