<?php
/**
 * Manutencao da tabela de Sub Processos
 *
 * @author Gonalo Franco
 * @version $Id$
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_form.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_time.php");
require_once(NWX_BAS . DIRECTORY_SEPARATOR . "csa_util.php");

/**
 * Formulario para Alteracao,Inclusao e Exclusao
 */
class nw_tarefas_frm extends nwx_form {

  /**
   * Carrega dados do BD nos campos do formulario
   */
  function carrega() {

    if ($this->oper == 'i') {
      $par = nwx_qval('nw_tarefas');
      if (isset($par['d'])) {
        $this->valor('dt_tar', nwx_time::data_iso($par['d']));
      }
      return null;
    }
    $stmt = "select * from nw_tarefas where id_usr = ? and id_tar = ?";
    $db = nwx_db::conexao();
    if ($this->inicio()) {
      $rs = $db->execute($stmt, $this->id);
      if (!$rs->EOF) {
        $this->valor('id_usr',$rs->fields['id_usr']);
        $this->valor('id_tar',$rs->fields['id_tar']);
        $this->valor('dt_tar',$rs->fields['dt_tar']);
        $this->valor('hora',$rs->fields['hora']);
        $this->valor('descricao',$rs->fields['descricao']);
        $this->valor('id_sit',$rs->fields['id_sit']);
        $this->valor('email',$rs->fields['email']);
        $this->valor('ds_ant',$rs->fields['ds_ant']);
        $this->valor('hr_ant',$rs->fields['hr_ant']);
      }
    }
  }

  /**
  * Verificacao dos campos para confirmacao
  */
  function verifica() {
  }
  
  /**
   * Processamento do formulario
   */
  function processa($_sair) {

    $tab = $_SESSION[NWX_SIS . '_tab'];
    
    $db = nwx_db::conexao();
    if ($this->oper == 'a') {
      $o = 'Alterar';
      $id_pro = $this->id[0];
      $stm = "update nw_tarefas set dt_tar = ?, hora = ?, descricao = ?, id_sit = ?, email = ?, ds_ant = ?, hr_ant = ? where id_usr = ? and id_tar = ?";
      $p = array(nwx_time::data_iso($this->post('dt_tar'))
                ,nwx_db::nulo($this->post('hora'))
                ,$this->post('descricao')
                ,$this->post('id_sit')
                ,$this->post('email') ? 1 : 0
                ,nwx_db::nulo($this->post('ds_ant'))
                ,nwx_db::nulo($this->post('hr_ant'))
                ,$this->id[0]
                ,$this->id[1]
      );       
      $this->sair = $_sair;
    } elseif ($this->oper == 'i') {
      $o = 'Incluir';
      $id_tar = $db->GenID('nw_tarefas_seq');
      $stm = "insert into nw_tarefas values(?,?,?,?,?,?,?,?,?)";
      $p = array($_SESSION['nwx_usr']
                ,$id_tar
                ,nwx_time::data_iso($this->post('dt_tar'))
                ,nwx_db::nulo($this->post('hora'))
                ,$this->post('descricao')
                ,$this->post('id_sit')
                ,$this->post('email') ? 1 : 0
                ,nwx_db::nulo($this->post('ds_ant'))
                ,nwx_db::nulo($this->post('hr_ant'))
      );       
      $this->sair = true;
    } elseif ($this->oper == 'Excluir') {
      $o = 'Excluir';
      $stm = "delete from nw_tarefas where id_usr = ?  and id_tar = ?";
      $p = $this->id;
      $this->sair = true;
    } else {
      $this->sair = true;
      nwx_repaginar();
      return;      
    }

    // Processamento final no Banco de Dados
    // Se houver erro mostra mensagem do Banco na area de mensagens
    nwx_db::begin_trans();
    if (!$db->execute($stm, $p)) {
      $this->sair = false;
      $this->erro(nwx_db::erro());
      nwx_db::fail_trans();
    } else {
      nwx_repaginar();
    }
    nwx_db::audita('Agenda');
    nwx_db::end_trans();
    
  }

}

/**
 * Cria o quadro que contem o grid de manutencao
 */
class nw_tarefas extends nwx_quadro {

  /**
   * Construtor: ajusta o titulo e tipo
   */
  function __construct($id) {
      
    textdomain('nwx');
    parent::__construct($id);
    $this->titulo = _("Agendamento de compromissos");
    $this->fixo = 0;
  
  }
  
  /**
   * Monta o conteudo do quadro
   */
  function monta() {

    $cic = sessao_ciclo();
    
    $db = nwx_db::conexao();
    
    $par = nwx_qval('nw_tarefas');
    if (isset($par['p'])) {
      $id_tar = $par['p'];
      $id_opr = 'a';
    } else {
      $id_opr = 'i';
    }
    
    // Cria o formulario para processamento do registros
    $form = new nw_tarefas_frm("nw_tarefas","nw_tarefas");

    // Cria os campos do formulario e sua representacao
    $f1 = new nwx_form_text('dt_tar',          'D',10,0,false,false);
    $f2 = new nwx_form_text('hora',            'H',5,0,true,false);
    $f3 = new nwx_form_textarea('descricao', 'C',0,0,false,false);
    $f4 = new nwx_form_lista('id_sit',         'N',10,0,false,false);
    $f5 = new nwx_form_check('email',       'N',10,0,true,false);
    $f6 = new nwx_form_text('ds_ant',       'N',10,0,true,false);
    $f7 = new nwx_form_text('hr_ant',       'N',10,0,true,false);

    $f1->ajuda = _("Data do compromisso (Obrigatrio)");
    $f2->ajuda = _("Hora de incio do compromisso (Opcional)");
    $f3->ajuda = _("Descrio do compromisso (Obrigatria)");
    $f4->ajuda = _("Situao");
    $f5->ajuda = _("Indica se deve enviar e-mail de aviso (Opcional)");
    $f6->ajuda = _("Dias antes para envio de e-mail (Opcional)");
    $f7->ajuda = _("Horas antes para envio de e-mail (Opcional)");
    
    $f3->linhas = 8;
    $f4->opcoes = array(_("Em aberto"), _("Terminado"), _("Cancelado"));
    
    $form->input($f1,_('Data'), '','size="10"',false);
    $form->input($f2,_('Hora'), '','size="6"',false);
    $form->input($f4,_('Situao'), '','size="1"',true);
    $form->input($f3,_('Descrio do compromisso'),'','',true);
    //$form->input($f5,_('Enviar e-mail de notificao'), '','',true);
    //$form->input($f6,_('Dias para envio do e-mail'), '','size="10"',false);
    //$form->input($f7,_('Horas para envio do e-mail'), '','size="10"',true);
    
    if ($id_opr == 'a') {
      $form->id = array($_SESSION['nwx_usr'], $id_tar);
      $form->operacao('Excluir',_('Excluir registro'),_('Confirme excluso'));
    } else {
      $form->salvar = '';
    }
    $form->reset = '';  
    $form->oper = $id_opr;

    $operacao = array('a' => _('(Manuteno)'), 'i' => _('(Incluso)'));
    
    $form->cabec = _("Agendamento de compromissos")." " . $operacao[$id_opr];
    
    // Mostra o formulario
    $form->mostra();
  
  }

}
// vim:et:sw=2:ts=2:nowrap
