<?php
/**
 * Manutencao da tabela de usuarios
 *
 * @file nw_usr.php
 * @author Gonalo Franco
 * @version $Id: nw_usr.php 884 2006-12-09 14:56:22Z goncalo $
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_form.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_grid.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_time.php");

/**
 * Funcao para filtrar registros do grid
 */
function nw_usr_filtro($reg) {
  
  $db = nwx_db::conexao();

  if ($_SESSION['nwx_adm']) return true;

  $emp = $_SESSION['nwx_emp'];

  $rs = $db->execute("select emp from nw_usr_emp where usr=? and emp=?", array($reg['usr'], $emp));
  if (!$rs->EOF) {
    return true;
  }   
  
  if ($_SESSION['nwx_adm2']) {
    $rs = $db->execute("select * from nw_usr_emp where usr=?", $reg['usr']);
    while (!$rs->EOF) {
      $ru = $db->execute("select id_uni from csa_unidades where id_emp = ?", array($rs->fields['id_emp']));
      $id = $ru->fields['id_uni'];
      if ($id && subordinada($id_uni, $id)) {
        return true;
      }
      $rs->MoveNext();
    }
  }
  
  return false;
  
}

/**
 * Formulario para Alteracao,Inclusao e Exclusao de usuarios
 */
class nw_usr_form extends nwx_form {

  /**
   * Carrega dados do BD nos campos do formulario
   */
  function carrega() {

    if ($this->oper == 'Incluir') {
      if (nwx_param('PASS_EXP')) {
        $this->valor('xsen',nwx_time::current_date(), true);
      }
      return null;
    }
    $stmt = "select * from nw_usr where usr = ?";
    $db = nwx_db::conexao();
    $rs = $db->execute($stmt, $this->id);
    if (!$rs->EOF) {
      $this->valor('usr',$rs->fields['usr']);
      $this->valor('nome',$rs->fields['nome']);
      $this->valor('email',$rs->fields['email']);
      $this->valor('adm',$rs->fields['adm']);
      $this->valor('grupos',$rs->fields['usr']);
      $this->valor('uex',$rs->fields['uex']);
      $this->valor('bloq',$rs->fields['bloq']);
      $this->valor('xsen',$rs->fields['xsen']);
      $this->valor('nerr',$rs->fields['nerr']);
      $this->valor('ulog',$rs->fields['ulog']);
      $this->valor('sec',$rs->fields['sec']);
    }
  
  }

  /**
   * Chamado ao pressionao botao no grid
   */
  function prepara() {

    $oper = $this->oper;
    $db = nwx_db::conexao();
    
    $usr = $this->id[0];
    $st = nwx_qsta('nw_usr');
    $ic = nwx_qico('nw_usr');
    
    if ($oper == 'Senha') {
      $rs = $db->execute("select adm from nw_usr where usr = ?", $this->id);
      if ($rs->fields['adm'] && !$_SESSION['nwx_adm']) {
        nwx_alerta(_("Senha de usurio administrador s pode ser reiniciada por outro administrador"));
        return false;
      }
      // Exclui linhas incluidas anteriormente com este nome de planilha
      $stm = "update nw_usr set senha=?,xsen=?,nerr=?,bloq=? where usr = ?";
      $p = array(md5($this->id[0])
                ,nwx_time::current_date() 
                ,0
                ,0
                ,$this->id[0]
                );
      if ($db->execute($stm, $p)) {
        nwx_db::audita("Reset senha", "nw_usr", $p);
        nwx_alerta(_("Senha foi reiniciada para usurio"));
      } else {
        nwx_alerta(_("Erro na reinicializao da senha"));
      }
      return false;
    }
    return true;
    
  }
  
  /**
   * Verificacao dos campos para confirmacao
   */
  function verifica() {

    $db = nwx_db::conexao();
    if ($this->oper == 'Alterar') {
      if ($this->id[0] == $_SESSION['nwx_usr'] && !$this->post('sec')) {
        $this->erro(_("Usurio no pode alterar seu prprio status de administrador de segurana"));
      }
      if ($this->id[0] == $_SESSION['nwx_usr'] && $this->post('bloq')) {
        $this->erro(_("Usurio no pode bloquear a si mesmo"));
      }
      return;
    }
    if ($this->oper != 'Excluir') {
      return;
    }
    if ($this->id[0] == $_SESSION['nwx_usr']) {
      $this->erro(_("Usurio no pode excluir a si mesmo"));
    }
    $rs = $db->execute("select adm from nw_usr where usr = ?", $this->id);
    if ($rs->fields['adm'] && !$_SESSION['nwx_adm']) {
      $this->erro(_("Usurio administrador s pode ser excluido por outro administrador"));
    }
    if ($rs->fields['sec'] && !$_SESSION['nwx_adm']) {
      $this->erro(_("Usurio administrador s pode ser excluido por outro administrador"));
    }
  
  }

  /**
   * Processamento do formulario
   */
  function processa($_sair) {

    $db = nwx_db::conexao();
    if ($this->oper == 'Alterar') {
      $id_usr = $this->id[0];
      $stm = "update nw_usr set nome = ?,email = ?,adm = ?,uex = ?,bloq = ?,sec = ? where usr = ?";
      $p = array($this->post('nome')
                ,nwx_db::nulo($this->post('email'), strtolower($this->post('email')))
                ,$this->post('adm') ? 1 : 0 
                ,$this->post('uex') ? 1 : 0 
                ,$this->post('bloq') ? 1 : 0 
                ,$this->post('sec') ? 1 : 0 
                ,$id_usr
      );
      $this->sair = $_sair;
    } elseif ($this->oper == 'Incluir') {
      $id_usr = strtoupper($this->post('usr'));
      $stm = "insert into nw_usr values(?,?,?,?,?,?,?,?,?,?,?)";
      $p = array($id_usr
                ,$this->post('nome')
                ,md5($id_usr)
                ,$this->post('adm') ? 1 : 0 
                ,nwx_db::nulo($this->post('email'), strtolower($this->post('email')))
                ,$this->post('uex') ? 1 : 0 
                ,$this->post('bloq') ? 1 : 0 
                ,nwx_db::nulo($this->post('xsen'), nwx_time::data_iso($this->post('xsen')))
                ,0
                ,null
                ,$this->post('sec') ? 1 : 0 
      );
      $this->sair = false;
    } elseif ($this->oper == 'Excluir') {
      $id_usr = $this->id[0];
      $stm = "delete from nw_usr where usr = ?";
      $p = array($this->id[0]);
      $this->sair = true;
    } else {
      $this->sair = false;
      return;
    }

    // Processamento final no Banco de Dados
    // Se houver erro mostra mensagem do Banco na area de mensagens
    nwx_db::begin_trans();
    if (!$db->execute($stm, $p)) {
      $this->sair = false;
      $this->erro(nwx_db::erro());
      nwx_db::fail_trans();
    } else {
      // Verifica se tem grupos do usuario a acertar
      $stm = "delete from nw_mbr where usr = ?";
      $db->execute($stm, array($id_usr));
      $lst = $this->post('grupos_lst');
      if (!empty($lst)) {
        $sep = substr($lst,0,1);
        $grp = explode($sep,substr($lst,1));
        if (is_array($grp) && count($grp) > 0) {
          foreach ($grp as $g) {
            $stm = "insert into nw_mbr(usr,grupo) values (?,?)";
            $db->execute($stm, array($id_usr, $g));
          }
        }
      }
      nwx_repaginar();
    }
    nwx_db::audita($this->oper, $this->bloco, $p);
    nwx_db::end_trans();

  }

}

/**
 * Cria o quadro que contem o grid de manutencao
 */
class nw_usr extends nwx_quadro {

  /**
   * Construtor: ajusta o titulo e tipo
   */
  function __construct($id) {
    
    textdomain('nwx');
    parent::__construct($id);
    $this->titulo = _("Usurios");
    $this->fixo = 0;

  }

  /**
   * Monta o conteudo do quadro
   */
  function monta() {

    // Objeto grid
    $grid = new nwx_grid($this,'select * from nw_usr','','usr');

    // Prepara os campos de filtro ou busca (campo, nome a mostrar, tipo)
    $grid->filtro = array(array('usr',    _('Cdigo'), 'C'),
                          array('nome',   _('Nome'),   'C'),
                          array('email',  _('E-Mail'), 'C')
                         );

    // Colunas do grid (campo,label,largura,alinhamento,tipo,formato)
    $grid->colunas = array(array('usr',    _('Cdigo'), '14%','E','C',''),
                           array('nome',   _('Nome'),   '48%','E','C',''),
                           array('email',  _('E-Mail'), '26%','E','C',''),
                           array('adm',    _('Adm.Sis'),  '6%','C','C',array('-','S')),
                           array('sec',    _('Adm.Seg'),  '6%','C','C',array('-','S'))
                          );

    // Nome da coluna que identifica a linha
    $grid->pk = array('usr');

    // Numero de linhas por pagina
    $grid->linhas(10,18);

    // Funcao de filtragem
    if (defined('NWX_EMPRESAS') && NWX_EMPRESAS) {
      $grid->funcao = 'nw_usr_filtro';
    }
    
    // Cria o formulario para processamento do registros
    $form = new nw_usr_form("nw_usr_form","nw_usr");

    // Guarda o nome do grid internamente no formulario
    $form->grid = $grid->nome;

    $ro = $_SESSION['nwx_sec'] ? false : true;
    
    // Cria os campos do formulario e sua representacao
    $f1 = new nwx_form_text('usr','C',20,0,false,true);
    $f2 = new nwx_form_text('nome','C',100,0,false,$ro);
    $f3 = new nwx_form_text('email','EMAIL',100,'',true,$ro);
    $f4 = new nwx_form_check('adm','C',1,0,true,$ro);
    $f5 = new nwx_form_check('uex','C',1,0,true,$ro);
    $f6 = new nwx_form_lista('grupos','C',10,0,true,$ro);
    $f7 = new nwx_form_check('bloq','C',1,0,true,$ro);
    $f8 = new nwx_form_text('xsen','D',10,'',true,true);
    $f9 = new nwx_form_text('ulog','T',10,'',true,true);
    $f10 = new nwx_form_check('sec','C',1,0,true,$ro);
    
    $f4->automatico = true;
    $f8->automatico = true;
    $f9->automatico = true;
    $f7->automatico = true;
    $f10->automatico = true;

    $db = nwx_db::conexao();
    $c1 = $db->concat("grupo","' - '");
    $c1 = $db->concat($c1, "descricao");
    $f6->query = "select grupo, $c1 as descricao from nw_grp where grupo in (select grupo from nw_mbr where usr = ?) order by grupo";
    $lov = new nwx_lov($this->id,'Grupos','select * from nw_grp','','grupo');
    $lov->filtro = array(array('grupo',    _('Cdigo'), 'C'),
                         array('descricao',_('Nome'),   'C')
                        );
    $lov->colunas = array(array('grupo',      _('Cdigo'), '5%','E','C',''),
                          array('descricao',  _('Nome'),   '95%','E','C','')
                         );
    $lov->pk = 'grupo';
    $lov->linhas = 8;
    $lov->height = 300;
    $lov->query2 = "select grupo, $c1 as descri from nw_grp where grupo = ?";
    $lov->lista = 'descri';
    $f6->lov = $lov;
    
    $f1->ajuda = _('Cdigo que identifica o usurio (Obrigatrio)');
    $f2->ajuda = _('Nome completo do usurio (Obrigatrio)');
    $f3->ajuda = _('E-mail do usurio (Opcional)');
    $f4->ajuda = _('Indicar se o usurio  administrador do sistema');
    $f5->ajuda = _('Indicar se usurio interno (No cadastrado na rede)');
    $f6->ajuda = _('Grupos de que o usurio  membro (Pode adicionar vrios)');
    $f7->ajuda = _('Usurio bloqueado');
    $f8->ajuda = _('Data de expirao da senha');
    $f9->ajuda = _('Data/Hora da ultima conexo');
    $f10->ajuda = _('Indicar se o usurio  administrador de segurana');
    
    $form->tab('tab1', _('Informaes'));
    $form->tab('tab2', _('Segurana'));
    $form->tab('tab3', _('Perfis'));
    
    $form->input($f1,_('Codigo'),'','size="20"',true);
    $form->input($f2,_('Nome'),'','size="80"',true);
    $form->input_tab('tab1', $f3,_('E-Mail'),'','size="80"',true);
    $form->input_tab('tab1', $f9,_('Ultima conexo'),'','size="20"',true);
    $form->input_tab('tab1', $f8,_('Senha expira em'),'','size="10"',true);
    $form->input_tab('tab2', $f7,_('Usurio bloqueado'),'','',true);
    $form->input_tab('tab2', $f4,_('Administrador do sistema'),'','',true);
    $form->input_tab('tab2', $f10,_('Administrador de segurana'),'','',true);
    $form->input_tab('tab2', $f5,_('Usurio Interno'),'','',true);
    $form->input_tab('tab3', $f6,_('Grupos'),'','size="5" multiple="yes"',false);

    // Cria os botoes para funcoes do grid
    // Array indexado pelo label do botao, contendo :
    // (nome da funcao p/ form, o form, se campos read-only, se reg.novo)
    if (!$ro) {
      $grid->oper = array('Incluir' => array(_('Incluir'),$form,false,true,_("Incluir novo registro")),
                          'Alterar' => array(_('Alterar'),$form,false,false,_("Alterar registro")),
                          'Senha' => array(_('Reiniciar Senha'),$form,true,false,_("Reiniciar senha"), _("Confirme reinicializao de senha")),
                          'Excluir' => array(_('Excluir'),$form,true,false,_("Excluir registro"))
                         );
    } else {
      $grid->oper = array('Consultar' => array(_('Consultar'),$form,true,false,_("Consultar registro"))
                         );
    }
                       

    // Mostra o grid na pagina
    $grid->mostra($this);
  
  }

} //class nw_usr

// vim:et:sw=2:ts=2:nowrap
