<?php
/**
 * Arquivo de inclusao para usar biblioteca PHP.
 *
 * Define o ambiente e os arquivos de inclusao necessarios
 * para usar a biblioteca PHP padrao.
 *
 * @author Gonalo Franco
 * @version $Id: nwx.php 884 2006-12-09 14:56:22Z goncalo $
 */

ob_start();
//header('Content-type: text/html; charset=UTF-8');

// Constantes diversas
require_once("nwx_inc.php");

// Se nao pode determinar diretorio raiz, nao pode continuar
if (NWX_HTD == '') {
  die("ERRO - Impossvel determinar diretorio do sistema");
}

if (!defined('NWX_RDX')) define('NWX_RDX', '/');

if ('/' == NWX_RDX) {
  define('NWX_RAIZ', dirname(NWX_HTD));
} else {
  define('NWX_RAIZ', dirname(dirname(NWX_HTD)));
}

$base2 = str_replace('/', DIRECTORY_SEPARATOR, NWX_RDX);

if (!defined('NWX_SIS')) define('NWX_SIS',NWX_APL);

// Diretorio base do aplicativo corrente
// Parametros especificos do aplicativo
if (defined('NWX_REF')) {
  define('NWX_BAS', dirname(NWX_DIR) . DIRECTORY_SEPARATOR . 'app' . DIRECTORY_SEPARATOR . NWX_REF);
  require_once(NWX_BAS . $base2 . NWX_SIS . ".php");
} else {  
  define('NWX_BAS', dirname(NWX_DIR) . DIRECTORY_SEPARATOR . 'app' . DIRECTORY_SEPARATOR . NWX_SIS);
  require_once(NWX_BAS . $base2 . NWX_APL . ".php");
}

// Agendamento de tarefas
if (!defined('NWX_AGENDAMENTO')) define('NWX_AGENDAMENTO',false);

// Tempo de expiracao dos cookies
define('NWX_COOKIE', 60*60*24*3650);

// Log e utilitarios
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_log.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_util.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_widg.php");

// Gerenciamento de sessoes
nwx::session_start();

// Regenerar id de sessao a cada NWX_SESSION_TIME segundos (default 300: 5 minutos)
if (!defined('NWX_SESSIONS_TIME')) define('NWX_SESSIONS_TIME', 300);
if (NWX_SESSIONS_TIME) {
  if (!isset($_SESSION['time'])) {
    $_SESSION['time'] = time();
  }
  if ($_SESSION['time'] + NWX_SESSIONS_TIME < time()) {
    session_regenerate_id(true);
    $_SESSION['time'] = time();
  }
}

// I18N (Internacionalizacao)
// Se gettext esta carregado, prepara locale
if (function_exists('textdomain')) {
  if (!isset($_SESSION['nwx_locale']) || !$_SESSION['nwx_locale']) {
    if (isset($_COOKIE['nwx_locale'])) {
      $_lang = $_COOKIE['nwx_locale'];
    } else {
      $_lang = "pt_BR";
    }
    $_SESSION['nwx_locale'] = $_lang;
    setcookie('nwx_locale',$_lang,time()+NWX_COOKIE);
  } else {
    $_lang = $_SESSION['nwx_locale'];
  }
  setlocale(LC_ALL, nwx_locale($_lang));
  putenv('LANG='.$_lang);
  bindtextdomain('nwx', NWX_LANGDIR);
  bindtextdomain(NWX_SIS, NWX_LANGDIR);
  textdomain(NWX_SIS);
  $lc = localeconv();
  // Ponto decimal e separador de milhar 
  define('NWX_DEC',$lc['decimal_point']);
  define('NWX_SEP',$lc['thousands_sep']);
// Se gettext nao esta carregado, define as funcoes basicas
} else {
  function _($txt) { return $txt; }
  function textdomain($dom) {return null;}
  setlocale(LC_ALL, "pt_BR");
  $_SESSION['nwx_locale'] = "pt_BR";
  // Ponto decimal e separador de milhar 
  define('NWX_DEC',',');
  define('NWX_SEP','.');
}

// Licenciamento
$nwx_lic = false;
$nwx_own = false;
$nwx_ser = false;
$nwx_dem = false;
$nwx_exp = false;
$nwx_ver = false;
$nwx_emp = false;
if (function_exists('sg_get_const')) {
  $nwx_lic = sg_get_const('nwx_lic');
  $nwx_own = sg_get_const('nwx_copyright');
  $nwx_ser = sg_get_const('nwx_serie');
  $nwx_dem = sg_get_const('nwx_demo');
  $nwx_exp = sg_get_const('expire_date');
  $nwx_ver = sg_get_const('encode_date');
  $nwx_emp = sg_get_const('nwx_empresas');
}
if (!$nwx_lic) $nwx_lic = NWX_LIC;
if (!$nwx_own) $nwx_own = NWX_COPYRIGHT;
if (!$nwx_ser) $nwx_ser = NWX_SERIE;
if (!$nwx_emp && defined('NWX_EMPRESAS_TST')) $nwx_emp = trim(NWX_EMPRESAS_TST);
define('NWX_LICENCEE', $nwx_lic);
define('NWX_OWNER', $nwx_own);
define('NWX_SERIAL', $nwx_ser);
define('NWX_DEMO', $nwx_dem);
define('NWX_EMPRESAS', $nwx_emp);
if ($nwx_exp) {
  define('NWX_EXP', date(nwx_time::date_format(), $nwx_exp));  
} else {
  define('NWX_EXP', '');  
}
if ($nwx_ver) {
  define('NWX_VER', date('ymd.Hi', $nwx_ver));  
} else {
  define('NWX_VER', '');  
}
// Login integrado com SO e ainda nao logado
if (!NWX_LOGIN && !isset($_SESSION['nwx_usr']) && !isset($_SESSION['nwx_uex'])) {
  header("Location: /login/index_login.php?d=".NWX_APL."&s=".NWX_SIS."&p=".NWX_BAS);
  exit;
}

// Se fora login de usuario
if (defined("NWX_LOGIN_USR")) {
  $nwx_login_usr = NWX_LOGIN_USR;
} else {
  $nwx_login_usr = 0;
  define('NWX_LOGIN_USR',0);
}
// Se cria novo usuario automaticamente
if (defined("NWX_CRIA_USR"))
  $nwx_cria_usr = NWX_CRIA_USR;
else {
  $nwx_cria_usr = 0;
  define('NWX_CRIA_USR',0);
}

if (!isset($_SESSION['nwx_logout'])) {
  $_SESSION['nwx_logout'] = 0;
}
if (!$nwx_login_usr && !isset($_SESSION['nwx_usr']) && !$_SESSION['nwx_logout']) {
  $_SESSION['nwx_usr'] = 'CIS';
}

// Processa usuario encontrado ou novo
if ((isset($_SESSION['nwx_usr']) && !isset($_SESSION['nwx_adm'])) || 
    (isset($_SESSION['nwx_usr']) && (!isset($_SESSION['nwx_sis']) || $_SESSION['nwx_sis'] != NWX_SIS ))) {
  $usr = $_SESSION['nwx_usr'];
  $db = nwx_db::conexao();
  $stm = "select * from nw_usr where usr = ?";
  $rs = $db->execute($stm, array($usr));
  if (!$rs->EOF) {
    if ($rs->fields['bloq']) {
      unset($_SESSION['nwx_usr']);
      unset($_SESSION['nwx_adm']);
      $_SESSION['nwx_uex'] = 1;
      $_SESSION['nwx_logout'] = 1;
      $_SESSION['nwx_rdx'] = NWX_RDX;
    } else {    
    	$_SESSION['nwx_ulog'] = $rs->fields['ulog'] ? nwx_time::datetime_db($rs->fields['ulog']) : '';
    	$_SESSION['nwx_usr'] = $usr;
    	$_SESSION['nwx_adm'] = $rs->fields['adm'];
    	$_SESSION['nwx_sec'] = $rs->fields['sec'];
    	$_SESSION['nwx_uex'] = $rs->fields['uex'];
    	$_SESSION['nwx_nom'] = $rs->fields['usr'] . ' (' .$rs->fields['nome'].')';
    	$_SESSION['nwx_ini'] = date('d/m/Y H:i');
    	$_SESSION['nwx_conn'] = 1;
    	$_SESSION['nwx_logout'] = 0;
    	$_SESSION['nwx_rdx'] = NWX_RDX;
    	$db->execute("update nw_usr set ulog = ? where usr = ?",array(nwx_time::current_time(), $usr));
    	nwx_db::audita('Conexo');
    }
  } elseif (!$nwx_login_usr) {
    $usr = strtoupper($usr);
    $_SESSION['nwx_usr'] = $usr;
    $_SESSION['nwx_adm'] = 0;
    $_SESSION['nwx_sec'] = 0;
    $senha = md5(strtoupper($usr));
    if ($nwx_cria_usr) {
      $p = array($usr, "Usurio $usr", $senha, 0, null, 0, 0, null, 0, nwx_time::current_time(), 0);
      if ($db->execute("insert into nw_usr values(?,?,?,?,?,?,?,?,?,?,?)", $p)) { 
        $_SESSION['nwx_conn'] = 2;
      }
    }
    $_SESSION['nwx_nom'] = "Usurio $usr" . ' (' .$usr.')';
    $_SESSION['nwx_ini'] = date('d/m/Y H:i');
    $_SESSION['nwx_logout'] = 0;
    $_SESSION['nwx_rdx'] = NWX_RDX;
    nwx_db::audita('Conexo/Criao');
  } else {
    unset($_SESSION['nwx_usr']);
    $_SESSION['nwx_uex'] = 1;    
  }
  $_SESSION['nwx_sis'] = NWX_SIS;    
    
}
// vim:et:sw=2:ts=2:nowrap
