<?php
/**
 * Arquivo de inclusao para usar biblioteca PHP.
 *
 * Define o ambiente e os arquivos de inclusao necessarios
 * para usar a biblioteca PHP padrao.
 *
 * @author Gonalo Franco
 * @version $Id: nwx.php 884 2006-12-09 14:56:22Z goncalo $
 */

setlocale(LC_ALL,"pt_BR");

//define('NWX_DIR', dirname(__FILE__));
//define('NWX_BAS', dirname(NWX_DIR) . DIRECTORY_SEPARATOR . 'app' . DIRECTORY_SEPARATOR . NWX_SIS);

// Constantes diversas
require_once("nwx_inc.php");

define('NWX_COOKIE', 60*60*24*3650);

if (!defined('NWX_RDX')) define('NWX_RDX', '/');

$base2 = str_replace('/', DIRECTORY_SEPARATOR, NWX_RDX);

if (!defined('NWX_SIS')) define('NWX_SIS',NWX_APL);

// Diretorio base do aplicativo corrente
// Parametros especificos do aplicativo
if (defined('NWX_REF')) {
  define('NWX_BAS', dirname(NWX_DIR) . DIRECTORY_SEPARATOR . 'app' . DIRECTORY_SEPARATOR . NWX_REF);
  require_once(NWX_BAS . $base2 . NWX_SIS . ".php");
} else {  
  define('NWX_BAS', dirname(NWX_DIR) . DIRECTORY_SEPARATOR . 'app' . DIRECTORY_SEPARATOR . NWX_SIS);
  require_once(NWX_BAS . $base2 . NWX_APL . ".php");
}

// Utilitarios
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_util.php");

// I18N (Internacionalizacao)
// Se gettext esta carregado, prepara locale
if (function_exists('textdomain')) {
	if (!isset($_SESSION['nwx_locale']) || !$_SESSION['nwx_locale']) {
		if (isset($_COOKIE['nwx_locale'])) {
			$_lang = $_COOKIE['nwx_locale'];
		} else {
			$_lang = "pt_BR";
		}
		$_SESSION['nwx_locale'] = $_lang;
		setcookie('nwx_locale',$_lang,time()+NWX_COOKIE);
	} else {
		$_lang = $_SESSION['nwx_locale'];
	}
	setlocale(LC_ALL, nwx_locale($_lang));
	putenv('LANG='.$_lang);
	bindtextdomain('nwx', NWX_LANGDIR);
	bindtextdomain(NWX_SIS, NWX_LANGDIR);
	textdomain(NWX_SIS);
	$lc = localeconv();
	// Ponto decimal e separador de milhar 
	define('NWX_DEC',$lc['decimal_point']);
	define('NWX_SEP',$lc['thousands_sep']);
// Se gettext nao esta carregado, define as funcoes basicas
} else {
	function _($txt) { return $txt; }
	function textdomain($dom) {return null;}
	setlocale(LC_ALL, "pt_BR");
	$_SESSION['nwx_locale'] = "pt_BR";
	// Ponto decimal e separador de milhar 
	define('NWX_DEC',',');
	define('NWX_SEP','.');
}

// vim:et:sw=2:ts=2:nowrap:
