<?php
/**
 * Definiao de blocos HTML nas paginas
 *
 * @file nwx_bloco.php
 * @author Gonalo Franco
 * @version $Id: nwx_bloco.php 924 2007-01-11 18:36:37Z goncalo $
 */

/**
 * Blocos basicos para paginas HTML
 *
 * Define um bloco ou componente para exibiao em uma pagina HTML.<br>
 * Uma pagina HTML e montada com paginas tab ou menus, colunas e blocos nas<br>
 * colunas (classes descendentes de nwx_bloco ou com mesma interface).
 */
abstract class nwx_bloco {

  public $id;
  public $tab;
  public $col;
  public $seq;
  public $pag;
  
  /**
   * Construtor : Cria um novo objeto bloco
   *
   * @param $id Identificaao do bloco na pagina
   */
  function __construct($id) {

    $this->id = $id;
    
  }

  /**
   * Mostra o bloco na pagina  
   *
   * Metodo chamado pelo objeto nw_pag para mostrar o
   * conteudo do bloco na pagina.
   *
   */
  function mostra() {
    
    $this->monta();
    
  }

  /**
   * Monta o conteudo do bloco  
   *
   * Chamado pelo metodo 'mostra()' do bloco, tendo como funao
   * retornar o conteudo html a mostrar. Este metodo e abstrato
   * e deve ser subclassificado no aplicativo.
   *
   */
  abstract function monta(); 

} //class nwx_bloco   
// vim:et:sw=2:ts=2:nowrap:
