<?php
/**
 * Modulo de autenticacao Sumitomo (BSMB_ACS)
 *
 * @author Gonalo Franco
 * @version $Id$
 */

// Apelido do sistema a ser acessado
define('BSMB_SIS', 'M2I');

/**
 * Verifica se submenu tem algum bloco liberado para uso
 *
 * @param $usr Usuario
 * @param $senha Senha
 * @param $mensagem Mensagem a retornar
 * @return 0 OK >0 Erro
 */
function nwx_ext_login($usr, $senha, &$mensagem) { 
 
	$sis = BSMB_SIS.strtoupper(NWX_SIS);
	try {
		$com = new COM('BSMB_ACS.Conecta');
		if ($com) {
			$erro = $com->VerificaLogin($sis, $usr, $senha);
			$mensagem = $com->Mensagem;
			if (!$erro) {
				$login = array('uid' => $com->Usuario
											,'pwd' => $com->Senha
											,'Server' => $com->Servidor
											,'Database' => $com->Banco 
											);
				$_SESSION['bsmb'] = nwx_crypt($login);                
			}
		} else {
			$erro = 1;
			$mensagem = "Impossvel instanciar classe BSMB_ACS.Conecta";
		}
	} catch (Exception $e) {
		$erro = 1;
		$mensagem = $e->getMessage();
	}
	if (!$erro) {
		$adm = 0;
		$sec = 0;
		$com2 = new COM('BSMB_ACS.Acesso');
		if ($com2) {
			$bloq = $com2->VerificaAcesso($com->Usuario_sistema, $sis, 'Sistema', 'sysadm');
			$adm = !$bloq ? 1 : 0;  
			$bloq = $com2->VerificaAcesso($com->Usuario_sistema, $sis, 'Sistema', 'secadm');
			$sec = !$bloq ? 1 : 0;  
      //if (strtoupper($usr) == 'GFRANCO') $adm = 1;
		}
		$db = nwx_db::conexao();
		$rs = $db->execute("select ulog from nw_usr where usr=?", array($com->Usuario_sistema));
		if ($rs->EOF) {
			$senha = $com->Usuario_sistema;
			$nome_usr = $com->Nome_usuario ? $com->Nome_usuario : "Usuario ".$com->Usuario_sistema;
			$p = array($com->Usuario_sistema, $nome_usr, $senha, $adm, null, 0, 0, null, 0, nwx_time::current_time(), $sec);
			$db->execute("insert into nw_usr values(?,?,?,?,?,?,?,?,?,?,?)", $p);
			$_SESSION['nwx_ulog'] = '';
		} else {
			$_SESSION['nwx_ulog'] = $rs->fields['ulog'] ? nwx_time::datetime_db($rs->fields['ulog']) : '';
			$db->execute("update nw_usr set ulog = ? where usr = ?",array(nwx_time::current_time(), $com->Usuario_sistema));
		} 
		session_regenerate_id(true);      
		$_SESSION['nwx_usr'] = $com->Usuario_sistema;
		$_SESSION['nwx_adm'] = $adm;
		$_SESSION['nwx_sec'] = $sec;
		$_SESSION['nwx_uex'] = 0;
		$_SESSION['nwx_nom'] = $com->Usuario_sistema . ' (' . $com->Nome_usuario . ')';
		$_SESSION['nwx_ini'] = date('d/m/Y H:i');
		$_SESSION['nwx_conn'] = 1;
	}
	return $erro;
}

/**
 * Altera senha do sistema
 *
 * @param $usr Usuario
 * @param $senha Senha
 * @param $senha2 Nova senha
 * @param $mensagem Mensagem a retornar
 * @return 0 OK >0 Erro
 */
function nwx_ext_senha($usr, $senha, $senha2, &$mensagem) { 
 
	try {
		$com = new COM('BSMB_ACS.Senha');
		if ($com) {
			$erro = $com->AlteraSenha($usr, $senha, $senha2);
			$mensagem = $com->Mensagem;
		} else {
			$erro = 1;
			$mensagem = "Impossvel instanciar classe BSMB_ACS.Senha";
		}
	} catch (Exception $e) {
		$erro = 1;
		$mensagem = $e->getMessage();
	}
	return $erro;

}
// vim:et:sw=2:ts=2:nowrap:
