<?php
/**
 * Implementaao de scheduler tipo crontab
 *
 * @author Gonalo Franco
 * @version $Id: nwx_cron.php 877 2006-12-05 20:34:59Z goncalo $
 */

$nivelerro = error_reporting(0);

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_util.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_time.php");

/**
 * Cria log do job
 */
function log_job($db, $job, $msg) {
  $log  = $db->GenID('nw_jobs_log_seq');
  $db->execute("insert into nw_jobs_log values(?,?,?)", array($job, $log, $msg));
}

/**
 * Percorre lista de jobs
 */
function obter_jobs($db) {

  // Percorre os jobs ativos
  $st = "select * from nw_jobs where stat = 1";
  $rs = $db->execute($st);
  $file = array();
  $jobs = Array();
  while (!$rs->EOF) {
    $jobs[$rs->fields['id_job']] = array($rs->fields['comando'],$rs->fields['prx'],$rs->fields['descricao'],$rs->fields['interv'],$rs->fields['unid']);
    $rs->MoveNext();
  }

  return $jobs;

}

/**
 * Percorre lista de jobs
 */
function run_job($db, $id, $job) {

  // Percorre os jobs ativos
  $agora = time();
  $cmd = $job[0];
  $hora = $db->UnixTimeStamp($job[1]);
  $nome = $job[2];
  $intrv = $job[3];
  $unid = $job[4];

  if ($hora < $agora) {
    $arq = NWX_BAS . DIRECTORY_SEPARATOR . $cmd;
    if (!file_exists($arq))  {
      log_job($db, $id, "Arquivo no encontrado: $arq");
    } else {
      @include_once($arq);
      if ($unid == 'S') {
        $delta = $intrv;
      } elseif ($unid == 'M') {
        $delta = $intrv * 60;
      } elseif ($unid == 'H') {
        $delta = $intrv * 3600;
      }
      $novo = $hora;
      while ($novo < $agora) {
        $novo += $delta;
      }
      $hora_fmt = strftime('%d/%m/%Y %H:%M', $agora);
      $novo_fmt = strftime('%d/%m/%Y %H:%M', $novo);
      $novo_db = $db->DBTimeStamp($novo);
      $db->execute("update nw_jobs set prx = ? where id_job = ?", array($novo_db, $id));
      log_job($db, $id, "Executado: $hora_fmt, Prxima: $novo_fmt");
    }
  }

}

/**
 * Percorre lista de jobs
 */
function bloqueia_jobs($db) {

  $expiry = time() + 3600;
  if ($db->execute("insert into nw_sess(sesskey, expiry) values('job', $expiry)")) {
    return true;
  }
  return false;

}

// Inicio do processamento dos jobs

$db = nwx_db::conexao();

if (bloqueia_jobs($db)) {
  // Encontra os jobs a executar
  $jobs = obter_jobs($db);
  // Percorre os jobs executando se necessario
  foreach ($jobs as $j => $jb) {  
    run_job($db, $j, $jb);
  }
  // Libera jobs
  $db->execute("delete from nw_sess where sesskey = 'job'");
}

error_reporting($nivelerro);
// vim:et:sw=2:ts=2:nowrap:
