<?php
/**
 * Montagem de paginas HTML para janelas avulsas
 *
 * @file nwx_dialogo.php
 * @author Gonalo Franco
 * @version $Id: nwx_dialogo.php 924 2007-01-11 18:36:37Z goncalo $
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");

/**
 * Classe representando uma pagina de dialogo
 *
 * Uma pagin de dialogo e' uma pagina avulsa fora da pagina principal do aplicativo.
 */
class nwx_dialog {

  public $title;
  public $bloco;

  /**
   * Contrutor
   *
   * @param $tit Titulo da pagina
   * @param $blo Bloco
   */
  function __construct($tit, $blo) {

    $this->title = $tit;
    $this->bloco = $blo;

  }

  /**
   * Monta a pagina e mostra
   */
  function mostra() {

    $css2 = "";
    $est2 = "";
    $css = NWX_HTD."/".NWX_SIS.".css";
    if (file_exists($css))
      $css2 = "    <link rel=\"stylesheet\" href=\"$css\">\n";
    if (isset($_SESSION['nwx_estilo'])) {
      $css = $_SESSION['nwx_estilo'];
      $est = ($css == 'nwx') ? '' : '/nwx/estilos/' . rtrim($css) . '/' . rtrim($css) . ".css";
      $est2 = $est ? "<link rel=\"stylesheet\" href=\"$est\">" : "";
    }

    // Mostra a pagina
    echo "
    <!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">
    <html>
      <head>
        <meta http-equiv=\"content-type\" content=\"text/html;charset=iso-8859-1\">
        <title>$this->title</title>
        <link rel=\"stylesheet\" href=\"/nwx/estilos/nwx/nwx.css\">
        $est2
        $css2
        <script type=\"text/javascript\" src=\"/nwx/jscript/TreeMenu.js\"></script>
        <script type=\"text/javascript\" src=\"/nwx/jscript/nwx_util.js\"></script>
        <script type=\"text/javascript\" src=\"/nwx/jscript/nwx_lov.js\"></script>
        <script type=\"text/javascript\" src=\"/nwx/jscript/tigra_tables.js\"></script>
        <script type=\"text/javascript\" src=\"/nwx/jscript/overlib.js\"></script>
        <script type=\"text/javascript\" src=\"/nwx/jscript/flexgrid.js\"></script>
        <script type=\"text/javascript\" src=\"/nwx/jscript/jsrsClient.js\"></script>
        <script type=\"text/javascript\" src=\"/nwx/jscript/nwx_ajax.js\"></script>
        <script type=\"text/javascript\" src=\"/nwx/jscript/jscalendar-1.0/calendar.js\"></script>
        <script type=\"text/javascript\" src=\"/nwx/jscript/jscalendar-1.0/lang/calendar-br.js\"></script>
        <script type=\"text/javascript\" src=\"/nwx/jscript/jscalendar-1.0/calendar-setup.js\"></script>
        <script type=\"text/javascript\" src=\"/nwx/jscript/prototype.js\"></script>
        <script type=\"text/javascript\" src=\"/nwx/jscript/rico.js\"></script>
      </head>
      <body class=\"dialog\" topmargin=\"0\" bottommargin=\"0\" leftmargin=\"0\" rightmargin=\"0\">\n
      <div id=\"overDiv\" style=\"position:absolute; visibility:hidden; z-index:1000;\"></div>";

    // Corpo da pagina
    echo "  <table cellspacing=\"0\" class=\"layout\"><tr>\n";
    echo "  <td class=\"corpo-dialog\">\n";
    $this->bloco->mostra();
    echo "  </td>\n";
    echo "  </tr></table>\n";

    // Termino da pagina
    echo "  </body>\n";
    echo "</html>\n";

  }

} //class nwx_dialog
// vim:et:sw=2:ts=2:nowrap:
