<?php
/**
 * Classe representando  o inicio de um fieldset (texto) 
 *
 * @author Gonalo Franco
 * @version $Id: nwx_form_label.php 875 2006-12-05 18:58:37Z goncalo $
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_form_ctrl.php");

/**
 * Classe representando um label (texto) 
 */
class nwx_form_fieldset extends nwx_form_ctrl {

  public $campos = array();
  public $frmobj;
  
  /**
   * Construtor
   *
   */
  function __construct($id, $form) {
    $this->id = $id;
    $this->frmobj = $form;
    $this->tipo = 'C';
    $this->tam = 0;
    $this->dec = 0;
    $this->nulo = true;
    $this->read_only = true;
    $this->automatico = true;
    $this->jscript = '';
    $this->ref_sql = '';
    $this->ref_campo = '';
    $this->ref_atrib = '';
    $this->lov = '';
  }
  
  function add_field($fl, $nome, $label) {
    $fl->id = $nome;
    $fl->nome = $nome;
    $fl->label = $label;
    $this->campos[] = $fl;
  }
  
  /**
   * Monta o conteudo do controle
   */
  function monta($ro, $nv) {
    $tit = $this->id;
    echo "<fieldset class=\"fs\">";
    echo "<legend class=\"fs\">$tit</legend>";
    foreach($this->campos as $fld) {
      if (isset($this->frmobj->campos_fs[$fld->id])) $fld->valor = $this->frmobj->campos_fs[$fld->id];
      $fld->monta($ro, $nv);  
    }
    echo "</fieldset>";
  }

}
// vim:et:sw=2:ts=2:nowrap:
