<?php
/**
 * Classe para listbox/combobox
 *
 * @file nwx_form_lista.php
 * @author Gonalo Franco
 * @version $Id: nwx_form_lista.php 924 2007-01-11 18:36:37Z goncalo $
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_form_ctrl.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_db.php");

/**
 * Classe representando um controle de lista
 */
class nwx_form_lista extends nwx_form_ctrl {

  public $opcoes;
  public $opcoes2;
  public $query;
  public $query2;
  public $msg2 = 'Adicionar';
  public $width;
  
  /**
   * Monta o array de opcoes via SQL
   */
  function run_query($val) {

    if ($val === '') $val = '0';
    $DB = nwx_db::conexao();
    $DB->SetFetchMode(ADODB_FETCH_NUM);
    $this->query = str_replace('?', "'$val'", $this->query);
    if (strpos($this->query, '?') === false)
      $rs = $DB->execute($this->query);
    else {
      $rs = $DB->execute($this->query, array($val));
    }
    $DB->SetFetchMode(ADODB_FETCH_ASSOC);
    $opc = array();
    //if (substr($this->query,0,13) != "select id_uni" && substr($this->query,0,13) != "select id_ori") die($val . '.' .$this->query);
    while (!$rs->EOF) {
      $opc[$rs->fields[0]] = $this->width ? substr($rs->fields[1], 0, $this->width) : $rs->fields[1];
      $rs->MoveNext();
    }
    if (is_array($this->opcoes))
      $this->opcoes = $this->opcoes + $opc;
    else
      $this->opcoes = $opc;

  }

  /**
   * Monta o array de opcoes adicionais via SQL
   */
  function run_query2($val) {

    if ($val === '') $val = '0';
    $DB = nwx_db::conexao();
    $DB->SetFetchMode(ADODB_FETCH_NUM);
    $this->query2 = str_replace('?', "'$val'", $this->query2);
    $rs = $DB->execute($this->query2);
    //$rs = $DB->execute($this->query2, array($val));
    $DB->SetFetchMode(ADODB_FETCH_ASSOC);
    $opc = array();

    $opc['_0'] = $this->msg2;
    while (!$rs->EOF) {
      $opc[$rs->fields[0]] = $this->width ? substr($rs->fields[1], 0, $this->width) : $rs->fields[1];
      $rs->MoveNext();
    }
    $this->opcoes2 = $opc;

  }

  /**
   * Monta o conteudo do controle
   */
  function monta($ro, $nv) {

    $valor = (isset($_POST[$this->nome.'_h'])) ? $_POST[$this->nome.'_h'] : $this->valor;
    if (!empty($this->query))
      $this->run_query($valor);
    if (!empty($this->query2))
      $this->run_query2($valor);
    $bRO = false;
    // Listas tip Combo Box (1 linha) nao mudam de cor no foco
    if (!preg_match('/size="1"/i',$this->atributos)) {
      $fc = "onfocus=\"nwFocus(this);\" onblur=\"nwBlur(this);\"";
    } else {
      $fc = "";
    }
    if ($this->mostra_label)
      echo $this->label . "<br>";
    if (($this->read_only and ($this->automatico or ((!empty($valor) || $valor == 0) && !$nv))) or $ro) {
      $sel = "<select class=\"form-lista\" disabled name=\"$this->nome\" $this->atributos>";
      $bRO = true;
    } else
      $sel = "<select class=\"form-lista\" name=\"{$this->nome}\" {$this->atributos} onkeypress=\"return focusNext(this.form,'$this->nome',event);\" $fc>";
    foreach($this->opcoes as $k => $v) {
      $s = (trim($k) == trim($valor)) ? 'selected' : '';
      $sel .= "<option value=\"$k\" $s>$v</option>";
    }
    $sel .= '</select>';
    $sel .= "<input type=\"hidden\" name=\"{$this->nome}_h\" value=\"{$valor}\">";
    // Se tem combo para inclusao adicional
    if (!$bRO && is_array($this->opcoes2)) {
      $bt1 = $this->nome;
      $bt2 = $this->nome . '2';
      $bt3 = $this->nome . '_lst';
      $dom = textdomain(null);
      textdomain('nwx');
      $sel .= "&nbsp;<br><button type=\"button\" class=\"botao\" onClick=\"transfSelect(document.forms['$this->form'].elements['$bt1'],document.forms['$this->form'].elements['$bt2'],document.forms['$this->form'].elements['$bt1'],document.forms['$this->form'].elements['$bt3']);\">"._("Excluir")."</button>";
      textdomain($dom);
      $sel .= "&nbsp;<select class=\"form-lista\" name=\"$this->nome"."2\" onChange=\"transfSelect(document.forms['$this->form'].elements['$bt2'],document.forms['$this->form'].elements['$bt1'],document.forms['$this->form'].elements['$bt1'],document.forms['$this->form'].elements['$bt3']);\">";
      foreach($this->opcoes2 as $k => $v) {
        $sel .= "<option value=\"$k\">$v</option>";
        }
      $sel .= '</select>';
      $sel .= "<input type=\"hidden\" name=\"$bt3\" value=\"\">";
      $sel .= "<script language=\"JavaScript\">lerSelect(document.forms['$this->form'].elements['$bt1'],document.forms['$this->form'].elements['$bt3']);</script>";
    }
    // Se tem LOV para inclusao adicional    
    if (!$bRO && !empty($this->lov)) {
      $dom = textdomain(null);
      textdomain('nwx');
      $bt1 = $this->nome;
      $bt2 = $this->nome . '2';
      $bt3 = $this->nome . '_lst';
      $lv = $this->lov;
      $frm = $lv->bloco;
      $fld = $this->nome;
      $lv->prepara($frm,$fld);
      $lv_cpo = '';
      $lv_dsp = '';
      $lv_sql = urlencode($lv->query2);
      $lv_form = $this->form;
      $lista = $lv->lista;
      $ori = "index_lov.php?frm=$frm&fld=$fld&tit=Teste&id=1&ds=$lv_cpo&sq=$lv_sql&form=$lv_form&dsp=$lv_dsp&ls=$lista";
      $t = "<iframe frameborder=\"0\" width=\"{$lv->width}\" height=\"{$lv->height}\" scrolling=no src=\"$ori\"></iframe>"; 
      $t = htmlentities($t);
      $sel .= "<a href=\"javascript:void(0);\" onCLICK=\"return " .
         "overlib('$t'," .
         "STICKY,HAUTO,VAUTO," .
         "CAPTION,'&nbsp;Opes'," . 
         "CAPTIONFONT,'Arial'," . 
         "CAPTIONSIZE,'12px'," .
         "CAPCOLOR,'yellow',". 
         "CLOSECLICK,CLOSETEXT,'Fechar',CLOSETITLE,'Clique para fechar',CLOSECOLOR,'white'" . 
         ");\" " .
         "onmouseout=\"nd();\" onmouseover=\"return true;\"><img class=\"ctlimg\" src=\"/nwx/img/lov.gif\" border=\"0\" alt=\""._("Clique aqui para adicionar itens")."\"></a>\n";
      $sel .= "&nbsp;<br><img class=\"ctlimg\" src=\"/nwx/img/del.gif\" border=\"0\" alt=\""._("Clique aqui para excluir itens")."\" onClick=\"delSelect(document.forms['$this->form'].elements['$bt1'],document.forms['$this->form'].elements['$bt3']);\">";
      $sel .= "<input type=\"hidden\" name=\"$bt3\" value=\"\">";
      $sel .= "<script language=\"JavaScript\">lerSelect(document.forms['$this->form'].elements['$bt1'],document.forms['$this->form'].elements['$bt3']);</script>";
      textdomain($dom);
    }
    echo $sel;
    $this->ajuda();

  }

} //class nwx_form_lista
// vim:et:sw=2:ts=2:nowrap:
