<?php
/**
 * Classe para controles de texto
 *
 * @file nwx_form_text.php
 * @author Gonalo Franco
 * @version $Id: nwx_form_text.php 924 2007-01-11 18:36:37Z goncalo $
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_util.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_db.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_lov.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_form_ctrl.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_time.php");

/**
 * Classe representando um controle de texto
 *
 */
class nwx_form_text extends nwx_form_ctrl {

  public $linhas = 0;
  
  /**
   * Monta o conteudo do controle
   */
  function monta($ro, $nv) {

    if ($this->mostra_label)
      echo $this->label . "<br>";
    $df = nwx_time::date_format();
    $idf = '%'.substr($df,0,2) . '%' . substr($df,2,2) . '%' . substr($df,4); 
    if (isset($this->valor) and !empty($this->valor) and $this->tipo == "D") {
      $v = adodb_date2($df, $this->valor);
    } elseif (isset($this->valor) and !empty($this->valor) and $this->tipo == "T") {
      $v = adodb_date2($df.' H:i', $this->valor);
    } else
      $v = $this->valor;

    $valor = (isset($_POST[$this->nome])) ? $_POST[$this->nome] : $v;

    $ref_text = '';
    if (!empty($this->ref_sql) && !empty($this->ref_campo)  && !empty($valor)) {
      $db = nwx_db::conexao();
      //$stmt = sprintf($this->ref_sql, nwx_db::nulo($valor,$valor));
      //$rs = $db->execute($stmt);
      $rs = $db->execute($this->ref_sql, array(nwx_db::nulo($valor,$valor)));
      if (!$rs->EOF)
        $ref_text = $rs->fields[strtolower($this->ref_campo)];
    }

    // Campo com display
    if (!empty($this->ref_sql) && !empty($this->ref_campo)) {
      $jsql = urlencode($this->ref_sql);
      $och = "onBlur=\"nwBlur(this);nwx_display('$jsql','$this->form','$this->nome','text_$this->nome');\"";
    } else
      $och = "onBlur=\"nwBlur(this);\"";

    //if (($this->read_only and ($this->automatico or (!empty($valor) && !$nv))) or $ro or !empty($this->lov)) {
    if (($this->read_only && ($this->automatico || (!empty($valor) || !$nv))) || $ro) {
      echo "<input class=\"form-input-ro\" readonly type=\"text\" name=\"$this->nome\" value=\"$valor\" $this->atributos onkeypress=\"return focusNext(this.form,'$this->nome',event);\">";
    } else {
      echo "<input class=\"form-input\" type=\"text\" name=\"$this->nome\" id=\"cal_$this->nome\" value=\"$valor\" $this->atributos $och onkeypress=\"return focusNext(this.form,'$this->nome',event);\" onfocus=\"nwFocus(this);\">";
      if ($this->tipo == "D") {
        $dom = textdomain(null);
        textdomain('nwx');
        echo "<img src=\"/nwx/img/calendar.gif\" align=\"top\" id=\"cal_img_$this->nome\" style=\"cursor:pointer;border:0px;\" title=\""._("Clique para calendrio")."\">";
        textdomain($dom);
        $this->jscript  = "\n<script type=\"text/javascript\">\n";
        $this->jscript .= "Calendar.setup({\n";
        $this->jscript .= "inputField     :  \"cal_$this->nome\",\n";
        $this->jscript .= "ifFormat       :  \"$idf\",\n";
        $this->jscript .= "button         :  \"cal_img_$this->nome\",\n";
        $this->jscript .= "singleClick    :  true\n";
        $this->jscript .= "});\n";
        $this->jscript .= "</script>\n";
      } elseif ($this->tipo == "T") {
        $dom = textdomain(null);
        textdomain('nwx');
        echo "<img src=\"/nwx/img/calendar.gif\" align=\"top\" id=\"cal_img_$this->nome\" style=\"cursor:pointer;border:0px;\" title=\""._("Clique para calendrio")."\">";
        textdomain($dom);
        $this->jscript  = "\n<script type=\"text/javascript\">\n";
        $this->jscript .= "Calendar.setup({\n";
        $this->jscript .= "inputField     :  \"cal_$this->nome\",\n";
        $this->jscript .= "ifFormat       :  \"$idf %H:%M\",\n";
        $this->jscript .= "button         :  \"cal_img_$this->nome\",\n";
        $this->jscript .= "singleClick    :  true,\n";
        $this->jscript .= "showsTime      :  true\n";
        $this->jscript .= "});\n";
        $this->jscript .= "</script>\n";
      }
    }
    if (!empty($this->lov) && ((!$this->read_only && !$ro) || empty($valor))) {
      $lv = $this->lov;
      $frm = $lv->bloco;
      $fld = $this->nome;
      $lv->prepara($frm,$fld);
      if (!empty($this->ref_sql) && !empty($this->ref_campo)) {
        $lv_sql = addslashes($this->ref_sql);
        $lv_cpo = strtolower($this->ref_campo);
        $lv_dsp = "text_" . $this->nome;
      } else {
        $lv_sql = '';
        $lv_cpo = '';
        $lv_dsp = '';
      }
      /**/
      $lv_form = $this->form;
      $ori = "index_lov.php?frm=$frm&fld=$fld&tit=Teste&id=1&ds=$lv_cpo&sq=$lv_sql&form=$lv_form&dsp=$lv_dsp";
      $t = "<iframe frameborder=\"0\" width=\"{$lv->width}\" height=\"{$lv->height}\" scrolling=no src=\"$ori\"></iframe>"; 
      $t = htmlentities($t);
      $dom = textdomain(null);
      textdomain('nwx');
      echo "<a href=\"javascript:void(0);\" onCLICK=\"return " .
         "overlib('$t'," .
         "STICKY,HAUTO,VAUTO," .
         "CAPTION,'&nbsp;"._('Opes')."'," . 
         "CAPTIONFONT,'Arial'," . 
         "CAPTIONSIZE,'12px'," .
         "CAPCOLOR,'yellow',". 
         "CLOSECLICK,CLOSETEXT,'"._('Fechar')."',CLOSETITLE,'"._('Clique para fechar')."',CLOSECOLOR,'white'" . 
         ");\" " .
         "onmouseout=\"nd();\" onmouseover=\"return true;\"><img class=\"ctlimg\" src=\"/nwx/img/lov.gif\" border=\"0\" alt=\""._('Clique aqui para lista')."\"></a>\n";
      textdomain($dom);
      /**/
      /**
      echo "<a href=\"javascript:lov_$this->nome.popup();\"><img class=\"ctlimg\" src=\"/nwx/img/lov.gif\" border=\"0\" alt=\"Clique aqui para lista\"></a>";
      $this->jscript .= "\n<script language=\"JavaScript\">\n";
      $this->jscript .= "<!-- //\n";
      if (!empty($lv_dsp))
        $this->jscript .= " var lov_$this->nome = new lov('/".NWX_APL."/',document.forms['$this->form'].elements['$this->nome'],'$lv_sql','$lv_cpo',document.forms['$this->form'].elements['$lv_dsp'],'$frm','$fld','$lv->titulo',$lv->width,$lv->height,$lv->top,$lv->left);\n";
      else
        $this->jscript .= " var lov_$this->nome = new lov('/".NWX_APL."/',document.forms['$this->form'].elements['$this->nome'],'','','','$frm','$fld','$lv->titulo',$lv->width,$lv->height,$lv->top,$lv->left);\n";
      $this->jscript .= "//-->\n";
      $this->jscript .= "</script>\n";
      **/ 
    }
    if (!empty($this->ref_sql)) {
      if (!$this->linhas) {
        echo "<input class=\"form-input-dsp\" readonly type=\"text\" name=\"text_$this->nome\" value=\"$ref_text\" $this->ref_atrib onkeypress=\"return focusNext(this.form,'$this->nome',event);\">";
      } else {
        echo "<br><textarea readonly class=\"form-input-ro\" style=\"width:100%;\" id=\"text_$this->nome\" name=\"text_$this->nome\" rows=\"$this->linhas\" onkeypress=\"return focusNext(this.form,'text_$this->nome',event);\">";
        echo preg_replace('/<br>/i',"\n",$ref_text);
        echo "</textarea>";
      }
    }
    $this->ajuda();

  }

} //class nwx_form_text
// vim:et:sw=2:ts=2:nowrap:
