<?php
/**
 * Arquivo de inclusao basico com constantes
 *
 * Define o ambiente e os arquivos de inclusao necessarios
 * para usar a biblioteca PHP padrao.
 *
 * @file nwx_inc.php
 * @author Gonalo Franco
 * @version $Id: nwx_inc.php 924 2007-01-11 18:36:37Z goncalo $
 */

// Diretorio da biblioteca PHP
define('NWX_DIR', dirname(__FILE__));

// Diretorio de locales
define('NWX_LANGDIR', dirname(NWX_DIR) . DIRECTORY_SEPARATOR . 'locale');

// Nome basico do aplicativo corrente
define('NWX_IDX', basename($_SERVER['PHP_SELF']));

// Constante para recarga da URL
define('NWX_LOC', NWX_APL . '/' . NWX_IDX);

// Diretorio raiz do aplicativo corrente
if (isset($_SERVER['SCRIPT_FILENAME'])) {
  define('NWX_HTD',dirname($_SERVER['SCRIPT_FILENAME']));
} elseif (isset($_SERVER['PATH_TRANSLATED'])) {
  define('NWX_HTD',dirname($_SERVER['PATH_TRANSLATED']));
} else {
  define('NWX_HTD','');
}

// Niveis de log
define('NWX_LOG_OFF', 0);
define('NWX_LOG_DEBUG', 10);
define('NWX_LOG_INFO', 20);
define('NWX_LOG_AVISO', 30);
define('NWX_LOG_ERRO', 40);
define('NWX_LOG_CRITICO', 50);
  
// vim:et:sw=2:ts=2:nowrap
