<?php
/**
 * Classe para processamento de LOV (Listas de Valores)
 *
 * @file nwx_lov.php
 * @author Gonalo Franco
 * @version $Id: nwx_lov.php 924 2007-01-11 18:36:37Z goncalo $
 */

/**
 * Classe representando uma LOV
 *
 * Uma LOV (Lista de Valores) e' uma pagina adicional de dialogo que permite escolher<br>
 * o valor de um campo relacionado em outra tabela.
 */
class nwx_lov {

  public $linhas;
  public $pk;
  public $filtro;
  public $colunas;
  public $titulo;
  public $width;
  public $height;
  public $top;
  public $left;
  public $query;
  public $where;
  public $tabela;
  public $lista;

  /**
   * Contrutor
   *
   * @param $bloco Objeto bloco onde o grid esta
   * @param $titulo Titulo da janela da LOV
   * @param $top Posicao superior da janela
   * @param $left Posicao esquerda da janela
   * @param $larg largura da janela
   * @param $alt Altura da janela
   * @param $query Consulta SQL para os dados
   * @param $where Clausula Where da consulta
   * @param $order Clausula Order by da consulta
   */
  function __construct($bloco, $titulo, $query, $where, $order, $top = 50, $left = 50, $larg = 500, $alt = 350) {

    $this->top = $top;
    $this->left = $left;
    $this->width = $larg;
    $this->height = $alt;
    $this->query = $query;
    $this->where = $where;
    $this->order = $order;
    $this->filtro = array();
    $this->colunas = array();
    $this->linhas = 10;
    $this->sql = '';
    $this->campo = '';
    $this->disp = '';
    $this->bloco = $bloco;
    $this->titulo = $titulo;
    $this->lista = '';
    $this->query2 = '';
    $this->funcao = '';

  }

  /**
   * Prepara valores da LOV
   *
   * @param $form Nome do formulario
   * @param $field Nome do campo
   */
  function prepara($form, $field) {

    $this->form = $form;
    $this->field = $field;
    $_SESSION['nwx_lov'][$form][$field]['query'] = $this->query;
    $_SESSION['nwx_lov'][$form][$field]['where'] = $this->where;
    $_SESSION['nwx_lov'][$form][$field]['order'] = $this->order;
    $_SESSION['nwx_lov'][$form][$field]['linhas'] = $this->linhas;
    $_SESSION['nwx_lov'][$form][$field]['pk'] = $this->pk;
    $_SESSION['nwx_lov'][$form][$field]['filtro'] = $this->filtro;
    $_SESSION['nwx_lov'][$form][$field]['colunas'] = $this->colunas;
    $_SESSION['nwx_lov'][$form][$field]['bloco'] = $this->bloco;
    $_SESSION['nwx_lov'][$form][$field]['lista'] = $this->lista;
    $_SESSION['nwx_lov'][$form][$field]['query2'] = $this->query2;
    $_SESSION['nwx_lov'][$form][$field]['funcao'] = $this->funcao;

  }

} //class nwx_lov
// vim:et:sw=2:ts=2:nowrap:
