<?php
/**
 * Alteracao de preferencias
 *
 * @file nwx_prefs.php
 * @author Gonalo Franco
 * @version $Id: nwx_prefs.php 924 2007-01-11 18:36:37Z goncalo $
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_form.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_util.php");

/**
 * Define formulario para alterar senha
 */
class nwx_prefs_form extends nwx_form {

  /**
   * Carrega valores iniciais
   */
  function carrega() {
    $this->valor('estilo',$_SESSION['nwx_estilo']);
    $this->valor('locale',$_SESSION['nwx_locale']);
  }

  /**
   * Verifica se entradas corretas
   */
  function verifica() {

  }

  /**
   * Processa alteracao
   */
  function processa($_sair) {

    $oper = $this->submit();

    if ($oper == _('Alterar')) {
      $_SESSION['nwx_estilo'] = $this->post('estilo');
      $_SESSION['nwx_locale'] = $this->post('locale');
      setcookie('nwx_estilo',$this->post('estilo'),time()+NWX_COOKIE);
      setcookie('nwx_locale',$this->post('locale'),time()+NWX_COOKIE);
    }
    nwx_repaginar();

  }

} //class nwx_senha_form

/**
 * Define quadro contendo formulario de senha
 */
class nwx_prefs extends nwx_quadro {

  /**
   * Construtor: ajusta o titulo e tipo
   */
  function __construct($id) {
    
    textdomain('nwx');
    parent::__construct($id);
    $this->titulo = _("Preferncias");
    $this->fixo = 1;

  }

  /**
   * Monta o conteudo do quadro
   */
  function monta() {
    
    $form = new nwx_prefs_form("nwx_prefs_form","nwx_prefs");

    $f1 = new nwx_form_lista('estilo','C',50,0,false,false);
    $f2 = new nwx_form_lista('locale','C',50,0,false,false);
    
    $f1->ajuda = _("Estilo das pginas");
    $f1->opcoes = $this->pag->estilos();
    
    $f2->ajuda = _("Lingua a utilizar");
    $f2->opcoes = $this->pag->locales();
    
    $form->submit = '';
    $form->salvar = '';
    $form->reset = '';
    $form->operacao(_('Alterar'), _('Alterar preferencias'));

    $form->input($f1,_('Estilo'),'','size="1"',true);
    $form->input($f2,_('Lingua'),'','size="1"',true);
    $form->mostra();
  
  }

} //class nwx_prefs
// vim:et:sw=2:ts=2:nowrap:
