<?php
/**
 * Definiao de quadros das paginas
 *
 * @file nwx_quadro.php
 * @author Gonalo Franco
 * @version $Id: nwx_quadro.php 924 2007-01-11 18:36:37Z goncalo $
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_bloco.php");

/**
 * Quadros basicos para paginas HTML
 *
 * Um quadro e' um bloco com titulo, moldura e opoes de controle.
 *
 */
abstract class nwx_quadro extends nwx_bloco {

  public $titulo;
  public $fixo;
  public $estado;
  public $icone;
  public $width = '100%';
  public $margin = '0px;';

  /**
   * Contrutor: Cria novo objeto quadro
   *
   * @param $id Identificacao
   * @param $titulo Titulo do quadro
   */
  function __construct($id) {

    $this->id = $id;
    $this->fixo = 1;
    $this->estado = 0;
    $this->icone = '';
    
    $val = nwx_qval($id, $_SESSION[NWX_SIS . '_tab']);
    if ($val && isset($val['ico']))
      $this->icone = "/nwx/img/" . $val['ico'];
    
  }

  /**
   * Mostra o quadro na pagina
   */
  function mostra() {

    $_p = "/nwx/estilos/" . $_SESSION['nwx_estilo'];

    // Se nao quadro fixo e tem titulo, desenha os icones de controle
    if (!$this->fixo && $this->titulo) {
      $dom = textdomain(null);
      textdomain('nwx');
      $ctl = "<a href=\"".nwx_reload()."&blc=$this->id&m\" ".nwx_ttip(_("Minimizar quadro"))."><img border=\"0\" src=\"$_p/ctl_m.gif\"></img></a>&nbsp;"
           . "<a href=\"".nwx_reload()."&blc=$this->id&s\" ".nwx_ttip(_("Restaurar/Maximizar quadro"))."><img border=\"0\" src=\"$_p/ctl_s.gif\"></img></a>&nbsp;"
           . "<a href=\"".nwx_reload()."&blc=$this->id&x\" ".nwx_ttip(_("Fechar quadro"))."><img border=\"0\" src=\"$_p/ctl_x.gif\"></img></a>";
      textdomain($dom);     
    } else {
      $ctl = '&nbsp;';
    }
    
    // Monta o quadro
    // Se nao minimizado
    if ($this->estado != 1) {
      // Abre a moldura
      if ($this->icone) {
        //if (defined('NWX_VER') && NWX_VER) {
        //  $a1 = '<a href="javascript:void(0);" '. nwx_ttip(_('Verso').': '.NWX_VER).">";
        //  $a2 = '</a>';
        //} else {
        //  $a1 = '';
        //  $a2 = '';
        //}
        //$ic = "$a1<img align=\"absmiddle\" border=\"0\" src=\"". $this->icone . "\"></img>$a2&nbsp;";
        $ic = "<img align=\"absmiddle\" border=\"0\" src=\"". $this->icone . "\"></img>&nbsp;";
      } else {
        $ic = "";
      }
      if ($this->titulo) {
        $pcab = "<tr><td class=\"titbloco-esc\">{$ic}$this->titulo</td><td class=\"titbloco-dir\">$ctl</td></tr>";                                                                                                                
      } else {
        $pcab = "<tr><td class=\"topbloco-esc\">&nbsp;</td><td class=\"topbloco-dir\">&nbsp;</td></tr>";                                                                                                                
      }
      echo "
      <table width=\"{$this->width}\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" style=\"margin:{$this->margin};\">
      $pcab
      <tr><td class=\"crpbloco\" colspan=\"2\">";
      // Conteudo
      $this->monta(); 
      // Fecha a moldura
      echo "
      </td></tr>
      <tr><td class=\"rodbloco-esc\">&nbsp;</td><td class=\"rodbloco-dir\">&nbsp;</td></tr>                                                                                                                
      </table>
      ";
      
    // Se minimizado
    } else {
      echo "
      <table class=\"minim\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">
      <tr><td class=\"minim\">$this->titulo&nbsp;&nbsp;$ctl</td></tr>                                                                                                                
      </table>
      ";
    }
    
  }

} //class nwx_quadro 
// vim:et:sw=2:ts=2:nowrap:
