<?php
/**
 * Mostra pagina de relatorio
 *
 * @file nwx_relat.php
 * @author Gonalo Franco
 * @version $Id: nwx_relat.php 924 2007-01-11 18:36:37Z goncalo $
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "TreeMenu.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_time.php");

/**
 * Define o quadro para mostrar na tela
 */
class nwx_relat extends nwx_quadro {

  /**
   * Construtor: Altera titulo
   */
  function __construct($id) {

    parent::__construct($id);
    $this->titulo = "Emisso de Relatrio";
  
  }

  /**
   * Mostra quadro na tela
   */
  function monta() {

    $db = nwx_db::conexao();

    // Le o parametro 'rel' passado a nwx_relat
    // Contem o nome do relatorio
    $p = nwx_qval('nwx_relat');
    if (isset($p['rel'])) 
      $relat = $p['rel'];
    else 
      $relat = '';
    
    if (isset($_SESSION['nwx_etc']['relat']))
      unset($_SESSION['nwx_etc']['relat']);

    // Verifica se pode encontrar o arquivo da classe
    if (file_exists(NWX_BAS . DIRECTORY_SEPARATOR  . "$relat.php")) {
      $pclass = NWX_BAS;
    } elseif (file_exists(NWX_DIR . DIRECTORY_SEPARATOR . "$relat.php")) {
      $pclass = NWX_DIR;
    } else {
      $pclass = '';
    }
    
    // Monta a pagina
    if ($relat && $pclass) {
      include_once($pclass . DIRECTORY_SEPARATOR . "$relat.php");
      $ret = planilha();
      $tit = $ret[0];
      $pla = $ret[1];
      $lin = $ret[2];
      $_SESSION['nwx_etc']['relat'] = $lin;
      $ok = true;
    } else {
      $tit = "Codigo: $relat";
      $pla = "<h3>Relatrio no encontrado</h3>";
      $ok = false;
    }

    // Botoes de fechar e imprimir
    echo "<table width=\"100%\" class=\"layout\" cellspacing=\"0\">\n";
    echo "<tr>";
    
    echo "<td class=\"rel-cabec\">";
    echo $tit;
    echo "</td>";
    
    echo "<td class=\"rel-control\">";
    echo bt_fechar("nwx_relat");
    if ($ok) {
      echo bt_imprimir($relat);
      echo bt_xls($relat);
    }
    echo "</td></tr>";
    echo "</table>";

    // Conteudo da Pagina
    echo "<div name=\"p1\" id=\"p1\" style=\"position:relative; left:0px; top:0px;margin:0px;\">\n";
    echo $pla . "&nbsp;";
    echo "</div>\n";

  }

}
// vim:et:sw=2:ts=2:nowrap:
