<?php
/**
 * Mostra tela de relatorio
 *
 * @author Gonalo Franco
 * @version $Id: nwx_relat_prn.php 908 2007-01-02 12:34:05Z goncalo $
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_dialogo.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "TreeMenu.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_db.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_time.php");

/**
 * Define o quadro para mostrar na tela
 */
class nwx_relat_prn extends nwx_bloco {

  /**
   * Mostra o quadro na tela
   */
  function monta() {

    // Le o parametro 'rel' passado a nwx_relat
    // Contem o nome do relatorio
    if (isset($_GET['rel'])) {
      $relat = $_GET['rel'];
    } else {
      $relat = '';
    }
    $db = nwx_db::conexao();

    // Verifica se pode encontrar o arquivo da classe
    if (file_exists(NWX_BAS . DIRECTORY_SEPARATOR  . "$relat.php")) {
      $pclass = NWX_BAS;
    } elseif (file_exists(NWX_DIR . DIRECTORY_SEPARATOR . "$relat.php")) {
      $pclass = NWX_DIR;
    } else {
      $pclass = '';
    }
    
    // Monta a pagina
    if ($relat && $pclass) {
      include_once($pclass . DIRECTORY_SEPARATOR . "$relat.php");
      $ret = planilha(true);
      $tit = $ret[0];
      $pla = $ret[1];
      $ok = true;
    } else {
      $tit = "Codigo: $relat";
      $pla = "<h3>Relatrio no encontrado</h3>";
      $ok = false;
    }
    
    //echo "<table width=\"100%\" class=\"layout\" cellspacing=\"0\">\n";
    //echo "<tr>";
    //echo "<td class=\"rel-print\">";
    //echo $tit;
    //echo "</td>";
    //echo "</tr>";
    //echo "</table>";

    // Conteudo da Pagina
    echo "<div name=\"p1\" id=\"p1\" style=\"position:relative; left:0px; top:0px;margin:0px;\">\n";
    echo $pla . "&nbsp;";
    echo "</div>\n";

    // Caixa de dialogo de impressao
    if (false && $ok) {
      echo "\n<script language=\"JavaScript\">";
      echo "\nwindow.print();"; 
      echo "\n</script>";
    }
    
  }

}
// vim:et:sw=2:ts=2:nowrap:
