<?php
/**
 * Alteracao da senha do usuario
 *
 * @file nwx_senha.php
 * @author Gonalo Franco
 * @version $Id: nwx_senha.php 924 2007-01-11 18:36:37Z goncalo $
 */

require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_form.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_quadro.php");

/**
 * Define formulario para alterar senha
 */
class nwx_senha_form extends nwx_form {

  /**
   * Carrega valores iniciais
   */
  function carrega() {
    $this->valor('senha_ant','');
    $this->valor('senha_1','');
    $this->valor('senha_2','');
  }

  /**
   * Verifica se entradas corretas
   */
  function verifica() {

    $usr = $_SESSION['nwx_usr'];
    $min = nwx_param('PASS_MIN');
    $cpx = nwx_param('PASS_CPLX');
    $mc = $cpx == '2' ? ' '._('(maisculas e minsculas)') : '';
    
    $senha_ant = $this->post('senha_ant');
    $senha_1 = $this->post('senha_1');
    $senha_2 = $this->post('senha_2');

    $db = nwx_db::conexao();
    $stmt = "select senha from nw_usr where usr = ?";
    
    $rs = $db->execute($stmt, array($usr));
    if ($rs->EOF || trim($rs->fields['senha']) != trim(md5($senha_ant))) {
      $this->erro(_('Senha anterior incorreta'));
    }

    // Senha 1 nao bate com senha 2
    if ($senha_1 != $senha_2) {
      $this->erro(_('Senha 1 e 2 diferentes'));
    }
    
    // Senha muito simples
    if (nwx_ssen($usr, $senha_1)) {
      $this->erro(_("Senha deve no mnimo {$min} caracteres e conter letras{$mc}, digitos e pontuao"));
    }
      
    // Senha repetida  
    if (nwx_rsen($usr, $senha_1)) {
      $this->erro(_("Senha j foi usada recentemente"));
    }
    
  }

  /**
   * Processa alteracao
   */
  function processa($_sair) {

    // Le parametros de seguranca
    $dias = nwx_param('PASS_EXP');
    if ($dias) {
      $nxsen = nwx_time::data_iso(nwx_time::soma_dias(date(nwx_time::date_format()), $dias));
    } else {
      $nxsen = null;
    }

    $db = nwx_db::conexao();
    if ($this->oper == 'ALT') {
      $stm = "update nw_usr set senha = ?, xsen = ? where usr = ?";
      $p = array(md5($this->post('senha_1'))
                ,$nxsen 
                ,$_SESSION['nwx_usr']
                );
      $this->sair = true;
    }

    if (isset($stm) && !$db->execute($stm,$p))
      $this->erro(nwx_db::erro());
    else
      nwx_repaginar();

  }

} //class nwx_senha_form

/**
 * Define quadro contendo formulario de senha
 */
class nwx_senha extends nwx_quadro {

  /**
   * Construtor: ajusta o titulo e tipo
   */
  function __construct($id) {
    
    textdomain('nwx');
    parent::__construct($id);
    $this->titulo = _("Alterar senha");
    $this->fixo = 1;

  }

  /**
   * Monta o conteudo do quadro
   */
  function monta() {
    
    $f1 = new nwx_form_pass('senha_ant','C',100,0,false,false);
    $f2 = new nwx_form_pass('senha_1','C',100,0,false,false);
    $f3 = new nwx_form_pass('senha_2','C',100,0,false,false);
    
    $f1->ajuda = _("Senha anterior a alterar");
    $f2->ajuda = _("Nova Senha");
    $f3->ajuda = _("Repetir Senha para confirmao");
    
    $form = new nwx_senha_form("nwx_senha_form","nwx_senha");
    $form->oper = 'ALT';
    //$form->set_submit('OK');
    //$form->set_reset('Reset');
    //$form->set_cancel('Cancela');
    $form->salvar = '';
    $form->input($f1,_('Anterior'),'','size="20"',true);
    $form->input($f2,_('Nova Senha'),'','size="20"',true);
    $form->input($f3,_('Repetir'),'','size="20"',false);
    $form->mostra();
  
  }

} //class nwx_senha
// vim:et:sw=2:ts=2:nowrap:
