<?php
/**
 * Implementaao de scheduler tipo crontab
 *
 * @author Gonalo Franco
 * @version $Id: nwx_cron.php 877 2006-12-05 20:34:59Z goncalo $
 */

//$nivelerro = error_reporting(0);

// Le o codigo do sistema
require("index_sis.php");

require_once("nwx_batch.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_db.php");
require_once(NWX_DIR . DIRECTORY_SEPARATOR . "nwx_time.php");

/**
 * Cria log do job
 */
function log_job($db, $job, $msg) {
  $log  = $db->GenID('nw_jobs_log_seq');
  $db->execute("insert into nw_jobs_log values(?,?,?)", array($job, $log, $msg));
}

/**
 * Percorre lista de jobs
 */
function obter_jobs($db) {

  // Percorre os jobs ativos
  $st = "select * from nw_jobs where stat = 1";
  $rs = $db->execute($st);
  $file = array();
  $jobs = array();
  while (!$rs->EOF) {
    $jobs[$rs->fields['id_job']] = array($rs->fields['comando'],$rs->fields['prx'],$rs->fields['descricao'],$rs->fields['interv'],$rs->fields['unid']);
    $rs->MoveNext();
  }

  return $jobs;

}

/**
 * Percorre lista de jobs
 */
function run_job($db, $id, $job) {

  // Percorre os jobs ativos
  $agora = $db->UnixTimeStamp(nwx_time::current_time());
  $cmd = $job[0];
  $hora = $db->UnixTimeStamp($job[1]);
  $nome = $job[2];
  $intrv = $job[3];
  $unid = $job[4];
  if ($hora <= $agora) {
    $arq = NWX_BAS . DIRECTORY_SEPARATOR . $cmd;
    if (file_exists($arq))  {
      include_once($arq);
      if ($unid == 'S') {
        $delta = $intrv;
      } elseif ($unid == 'M') {
        $delta = $intrv * 60;
      } elseif ($unid == 'H') {
        $delta = $intrv * 3600;
      }
      $novo = $hora + $delta;
      while ($novo <= $agora) {
        $novo += $delta;
      }
      $hora_fmt = strftime('%d/%m/%Y %H:%M', $agora);
      $novo_fmt = strftime('%d/%m/%Y %H:%M', $novo);
      $novo_db = nwx_time::data_iso($novo);
      $db->execute("update nw_jobs set prx = ? where id_job = ?", array($novo_db, $id));
      log_job($db, $id, "Executado: $hora_fmt, Prxima: $novo_fmt");
    }
  }

}

// Inicio do processamento dos jobs

$db = nwx_db::conexao();

// Encontra os jobs a executar
$jobs = obter_jobs($db);

// Percorre os jobs executando se necessario
foreach ($jobs as $j => $jb) {  
  run_job($db, $j, $jb);
}

//error_reporting($nivelerro);
