/**
 * Chamadas via Remote Scripting
 *
 * @file nwx_ajax.js
 * @author Gonalo Franco
 * @version $Id$
 */

var nwx_display_frm;
var nwx_display_des;


/**
 * Preenche campo de display com retorno de SQL
 * 
 * sql - Instrucao sql a executar
 * frm - Nome do formulario onde esta o campo a preencher
 * ori - Nome do campo origem para o where do sql
 * des - Nome do campo destino onde escrever o resultado
 *
 */
function nwx_display(sql,frm,ori,des) {
	
	v = document.forms[frm].elements[ori].value;
	
	var url = "index_ajx.php";
	var pars = 'opr=1' + '&sql=' + sql + '&val=' + v;
	nwx_display_frm = frm;
	nwx_display_des = des;
	var req = new Ajax.Request(
				url,
				{
					method: 'get',
					parameters: pars,
					onComplete: nwx_display_cb
				});

}

/**
 * Funcao de call-back para a nwx_display
 */
function nwx_display_cb(req) {

	document.forms[nwx_display_frm].elements[nwx_display_des].value = req.responseText;

}

/**
 * Seta sessao com valor de um campo
 * 
 * frm - Nome do formulario onde esta o campo a ler
 * cmp - Nome do campo com valor a ler
 */
function nwx_session(frm,cmp) {
	
	v = document.forms[frm].elements[cmp].value;
	var url = "index_ajx.php";
	var pars = 'opr=2' + '&cmp=' + cmp + '&val=' + v;
	var req = new Ajax.Request(
				url,
				{
					method: 'get',
					parameters: pars
				});

}

/**
 * Seta sessao com valor qualquer
 * 
 * val - Conteudo a guardar
 * cmp - Nome do campo com valor a ler
 */
function nwx_store(val,cmp) {
	
	var url = "index_ajx.php";
	var pars = 'opr=2' + '&cmp=' + cmp + '&val=' + val;
	var req = new Ajax.Request(
				url,
				{
					method: 'get',
					parameters: pars
				});

}

/**
 * Preenche campo de display com retorno de SQL
 * 
 * sql - Instrucao sql a executar
 */
function nwx_sql(sql) {
	
	var url = "index_ajx.php";
	var ns = encodeURI(sql);
	var pars = 'opr=3' + '&sql=' + ns;
	var req = new Ajax.Request(
				url,
				{
					method: 'get',
					parameters: pars
				});

}

/**
 * Preenche campo de display com retorno de SQL
 * 
 * sql - Instrucao sql a executar
 */
function nwx_sql2(sql, frm, cmp, opr, cr) {
	
	var v = document.forms[frm].elements[cmp].value;
	if (v == '') v = 'null';
	var nsql = sql.replace(/\?/g, v);
  
  if (cr) {
    td = new Date();
    var dia = td.getDay();
    if (dia < 10) dia = '0' + dia;
    var mes = td.getMonth() + 1;
    if (mes < 10) mes = '0' + mes;
    var ano = td.getFullYear();
    var hor = td.getHours();
    if (hor < 10) hor = '0' + hor;
    var min = td.getMinutes();
    if (min < 10) min = '0' + min;
    var seg = td.getSeconds();
    if (seg < 10) seg = '0' + seg;
    ls = cr + dia + '/' + mes + '/' + ano + ' ' + hor + ':' + min + ':' + seg;
  } else {
    ls = '';
  }
  if (opr) {
    var nsql = nsql.replace(/\!/g, opr + ls);
  }
  
  var ns = encodeURI(nsql);

	//alert(ns);
	var url = "index_ajx.php";
	var pars = 'opr=3' + '&sql=' + ns;
	var req = new Ajax.Request(
				url,
				{
					method: 'get',
					parameters: pars
				});

}

/**
 * Liga/Desliga valor de sessao
 * 
 * cmp - Nome do campo de sessao
 */
function nwx_session_check(cmp) {
  
  var url = "index_ajx.php";
  var pars = 'opr=4' + '&cmp=' + cmp;
  var req = new Ajax.Request(
        url,
        {
          method: 'get',
          parameters: pars
        });

}
