
/**
 * Funcoes utilitarias diversas em Javascript
 *
 */

/**
 * Retorna largura da janela do browser
 */
function nwx_getsize() {

  var de = document.documentElement;
  
  return {
    'width' : (window.innerWidth || (de && de.clientWidth) || document.body.clientWidth),
    'height' : (window.innerHeight || (de && de.clientHeight) || document.body.clientHeight)
  }

}

/**
 * Mostra e esconde mensagem de aguarde
 */
function nwx_wmsg(flag, md) {

/*
  var dv = document.getElementById('wmsg');
  
  var xy = nwx_getsize();
  var top = (xy.height - 140) / 4 || 0;
  var left = (xy.width - 180) / 2 || 0;

  dv.style.top = top + 'px';
  dv.style.left = left + 'px';
  dv.style.border = '2px solid black';
  
  if (flag) {
    dv.style.visibility = 'visible';
  } else {
    dv.style.visibility = 'hidden';
  }
*/
  
  YAHOO.namespace("nwx.wmsg");

  YAHOO.nwx.wmsg.wait = 
          new YAHOO.widget.Panel("wait",  
                                        { width: "180px", 
                                          fixedcenter: true, 
                                          close: false, 
                                          draggable: false, 
                                          zindex:1000,
                                          modal: md,
                                          visible: false
                                        } 
                                 );
  YAHOO.nwx.wmsg.wait.setHeader("Processando - Aguarde...");
  YAHOO.nwx.wmsg.wait.setBody("<div style=\"text-align:center;\"><img src=\"/nwx/img/progress.gif\"/></div>");
  YAHOO.nwx.wmsg.wait.render(document.body);

  if (flag) {
    YAHOO.nwx.wmsg.wait.show();
  } else {
    YAHOO.nwx.wmsg.wait.hide();
  }
  
}

/**
 * Faz submit de um formulario com aviso nao modal
 */
function submit_oper(pForm, pCampo, pID)
{
  document.forms[pForm].elements[pCampo].value = pID;
  document.forms[pForm].submit();
  nwx_wmsg(true, false);
}

/**
 * Faz submit de um formulario com aviso modal
 */
function submit_oper_modal(pForm, pCampo, pID)
{
  document.forms[pForm].elements[pCampo].value = pID;
  document.forms[pForm].submit();
  nwx_wmsg(true, true);
}

/**
 * Faz submit de um formulario sem aviso
 */
function submit_oper2(pForm, pCampo, pID)
{
  document.forms[pForm].elements[pCampo].value = pID;
  document.forms[pForm].submit();
}

/**
 * Faz reset
 */
function reset_oper(pForm)
{
  document.forms[pForm].reset();
}

/**
 * Submit para alteracao da ordem via labels dos grids
 */
function submit_order(pForm, pID, pCampo)
{
  document.forms[pForm].elements[pID+'_order'].value = pCampo;
  document.forms[pForm].elements[pID+'_altord'].value = pCampo;
  document.forms[pForm].elements[pID+'_inicial'].value = '1';
  document.forms[pForm].submit();
}

/**
 * Transfere valores entre campos de lista diferentes
 */
function transfSelect(selectOri, selectDest, selectTarg, txtSel) {
  var i, j, s;
  // transfere itens
  s = '';
  for (i = selectOri.options.length - 1; i >= 0; i--) {
    if (selectOri.options[i].selected && selectOri.options[i].value != '_0') {
      j = selectDest.options.length;
      selectDest.options[j] = new Option(selectOri.options[i].text);
      selectDest.options[j].value = selectOri.options[i].value;
      selectOri.options[i] = null;
    }
  }
  for (i = selectTarg.options.length - 1; i >= 0; i--) {
    s = s + '%' + selectTarg.options[i].value;
  }

  txtSel.value = s;
}

/**
 * Transfere valores entre campos de lista diferentes
 */
function delSelect(selectOri, txtSel) {
  var i, j, s;
  // transfere itens
  s = '';
  for (i = selectOri.options.length - 1; i >= 0; i--) {
    if (selectOri.options[i].selected && selectOri.options[i].value != '_0') {
      selectOri.options[i] = null;
    }
  }
  for (i = selectOri.options.length - 1; i >= 0; i--) {
    s = s + '%' + selectOri.options[i].value;
  }
  txtSel.value = s;
}

/**
 * Transfere valores entre campos de lista diferentes
 */
function addSelect(selectOri, val, texto, txtSel) {
  var i, j, s;
  selectOri.options.add(new Option(texto, val));
  s = '';
  for (i = selectOri.options.length - 1; i >= 0; i--) {
    s = s + '%' + selectOri.options[i].value;
  }
  txtSel.value = s;
}

/**
 * Limpa o select
 */
function emptySelect(selectOri, txtSel) {
  selectOri.options.length = 0;
  txtSel.value = '';
}

/**
 * Funcao auxiliar para passar conteudo de select multiplo como string unica
 */
function lerSelect(selectTarg, txtSel) {
  var i, s;
  // transfere itens
  s = '';
  for (i = selectTarg.options.length - 1; i >= 0; i--) {
    s = s + '%' + selectTarg.options[i].value;
  }

  txtSel.value = s;
}


/**
 * Funcao auxiliar para mudar a pagina tab corrente na navegacao
 *
 * Determina a pagina tab atual, coloca-a como visivel e esconde as outras
 */
function _nw_pag(p1, nome) {

  var t = nome.length + 1;
  var p = p1.substring(t);
  var i = 0;
  
  // Precorre os elementos chamadso p# ate esgotar as opcoes
  while (true) {
    ++i;

    var divObj = document.getElementById('p' + nome + i);
    if (divObj == null) {
      break;
    }
    var t = document.getElementById('t' + nome + i);
    if (i == p) {
      divObj.style.display = '';
      t.className = 'mnusel';
    } else {
      divObj.style.display = 'none';
      t.className = 'mnu';
    }
  }

}


/**
 * Controle de navegacao entre campos de um formulario
 * 
 * Passa o foco para o proximo campo ao teclar ENTER
 * 
 */
function focusNext(form, elem, evt) {

  evt = (evt) ? evt : event;
  var charCode = (evt.charCode) ? evt.charCode : ((evt.which) ? evt.which : evt.keyCode);

  var qual = -1;
  var nome;
  var tipo;
  
  // Se digitou ENTER ou esta em campo tipo display (text_...)
  if (charCode == 13 || elem.substring(0,4) == 'text') {

    var mx = form.elements.length;

    // Procura o elemento atual
    for (i = 0; i < mx; ++i) {
      nome = form.elements[i].name;
      if (nome == elem) {
        qual = i;
        break;
      }
    }
    
    // Procura o proximo que pode ter foco
    for (i = qual + 1; i < mx; ++i) {
      tipo = form.elements[i].type;
      ro = form.elements[i].readOnly;
      if ( !ro && tipo != 'submit' && tipo != 'reset' && tipo != 'hidden' && form.elements[i].name.substring(0,4) != 'text') {
        // Verifica se campo esta em um DIV (pagina tab)
        nodeNew = form.elements[i].parentNode.parentNode.parentNode.parentNode.parentNode.nodeName;
        if (nodeNew == 'DIV') {
          _nw_pag(form.elements[i].parentNode.parentNode.parentNode.parentNode.parentNode.id, form.name);
        }
        form.elements[i].focus(i);
        break;
      }
    }
    
    //var s = '';
    //for (i = 0; i < mx; ++i) {
    //  s += i + ' : ' + form.elements[i].name + ' ' + form.elements[i].type + ' > ' + form.elements[i].visibility + '\n'; 
    //}
    //alert(s);

    // Se estiver no ultimo campo do formulario: ENTER=SUBMIT
    if (i == mx)
      form.submit();
      //form.elements[0].focus(0);
        
    return false;
    
  }

  return true;
  
}

/**
 * Muda atributos do campo atual nos formularios
 */
function nwFocus(elem) {

  tipo = elem.type;  
  switch (tipo) {
  case 'text':
    elem.className = "form-input-cr";
    break;
  case 'password':
    elem.className = "form-input-cr";
    break;
  case 'file':
    elem.className = "form-input-cr";
    break;
  case 'textarea':
    elem.className = "form-input-cr";
    break;
  case 'select-one':
    elem.className = "form-lista-cr";
    break;
  case 'select-multiple':
    elem.className = "form-lista-cr";
    break;
  case 'checkbox':
    elem.className = "form-check-cr";
    break;
  case 'radio':
    elem.className = "form-radio-cr";
    break;
          
  }
    
}

/**
 * Volta atributos do campo atual para o normal nos formularios
 */
function nwBlur(elem) {

    tipo = elem.type;  
    switch (tipo) {
    case 'text':
      elem.className = "form-input";
      break;
    case 'password':
      elem.className = "form-input";
      break;
    case 'textarea':
      elem.className = "form-input";
      break;
    case 'file':
      elem.className = "form-input";
      break;
    case 'select-one':
      elem.className = "form-lista";
      break;
    case 'select-multiple':
      elem.className = "form-lista";
      break;
    case 'checkbox':
      elem.className = "form-check";
      break;
    case 'radio':
      elem.className = "form-radio";
      break;
    }
    
}

function nwliover(elem) {
  if (document.all && elem.className.indexOf('sel') < 0) {
    elem.className += 'over';
  }
}

function nwliout(elem) {
  if (document.all && elem.className.indexOf('sel') < 0) {
    elem.className = elem.className.replace('over','');
  }
}

